"IAL"

*
* Original Source File Name: d:\ial\procs\i68000_i8.s
*

VAR_0034        VARIABLE 000000000H
VAR_0036        VARIABLE 000000000H
VAR_0038        VARIABLE 000000000H
VAR_003A        VARIABLE 000000000H
VAR_003C_UNREF  VARIABLE 000000000H
VAR_003E_UNREF  VARIABLE 000000000H
VAR_0040_UNREF  VARIABLE 000000000H
VAR_0042_UNREF  VARIABLE 000000000H
VAR_0044        VARIABLE 000000000H
VAR_0046        VARIABLE 000000000H
VAR_0048        VARIABLE 000000000H
VAR_004A        VARIABLE 000000000H
VAR_004C_UNREF  VARIABLE 000000000H
VAR_004E        VARIABLE 000000000H
VAR_0050        VARIABLE 000000000H
VAR_0052        VARIABLE 000000000H
VAR_0054        VARIABLE 000000000H
VAR_0056        VARIABLE 000000000H
VAR_0058        VARIABLE 000000000H
VAR_005A_UNREF  VARIABLE 000000000H
VAR_005C_UNREF  VARIABLE 000000000H
CONST_005E      CONSTANT 0000000FFH
VAR_0060_UNREF  VARIABLE 0000FFFFFH
CONST_0062      CONSTANT 000FFFFFFH
CONST_0064      CONSTANT 0000000BBH
CONST_0066      CONSTANT 00000005FH
VAR_0068_UNREF  VARIABLE 0000000BFH
VAR_006A_UNREF  VARIABLE 0000000A9H
STR_0000        ASCII "supr data"
STR_0005        ASCII "supr program"
STR_000C        ASCII "user data"
STR_0011        ASCII "user program"
STR_0018        ASCII "interrupt ack"
STR_001F        ASCII "read"
STR_0022        ASCII "write"
STR_0025        ASCII " (6800)"
STR_0029        ASCII "DMA"
STR_002B_UNREF  ASCII "incomplete opcode"
STR_0034_UNREF  ASCII "/"
STR_0035_UNREF  ASCII "-"
STR_0036        ASCII "****"
STR_0039        ASCII ","
STR_003A        ASCII "D"
STR_003B        ASCII "A"
STR_003C        ASCII "B"
STR_003D        ASCII "W"
STR_003E        ASCII "L"
STR_003F        ASCII "#"
STR_0040        ASCII "OR"
STR_0042        ASCII "AND"
STR_0044        ASCII "SUB"
STR_0046        ASCII "EOR"
STR_0048        ASCII "ADD"
STR_004A        ASCII "CLR"
STR_004C        ASCII "MOVE"
STR_004F        ASCII "SR"
STR_0051        ASCII "CCR"
STR_0053        ASCII "USP"
STR_0055        ASCII "**"
STR_0057        ASCII "S"
STR_0058        ASCII "]"
STR_0059        ASCII "R"
STR_005A        ASCII "."
STR_005B        ASCII "Illegal"
        SEARCH_LIMIT     34
FMT_005F        FORMAT 3,BIN,3
FMT_0061        FORMAT 3,DEC,1
FMT_0063_UNREF  FORMAT 5,DEC,2
FMT_0065        FORMAT 4,HEX,1
FMT_0067        FORMAT 3,HEX,1
FMT_0069        FORMAT 8,HEX,2
FMT_006B        FORMAT 5,HEX,2
FMT_006D        FORMAT 16,HEX,4
FMT_006F_UNREF  FORMAT 20,HEX,5
FMT_0071        FORMAT 24,HEX,6
FMT_0073        FORMAT 32,HEX,8
        LABEL_TITLE      "68000 Mnemonic"
        BASE_TITLE       "      hex"
        DEFAULT_WIDTH    31
        MAPPED_WIDTH     41
        ENHANCED_WIDTH   41

ENTRY_POINT
    SET VAR_0058,0
    CASE_OF TASK
        GOTO LABEL_0030
        GOTO LABEL_0030
        GOTO LABEL_0030
        GOTO LABEL_000C
        GOTO LABEL_0010
        GOTO LABEL_0010
    CASE_END
    OUTPUT STR_005B    * "Illegal"
    OUTPUT " Task Request"
    ABORT

LABEL_000C
    LOAD ID_CODE
    IF 7,0 = 0000000F0H THEN SET VAR_0058,1

LABEL_0010
    SET RETURN_FLAGS,1
    SET VAR_004E,0
    SET VAR_0044,0
    LOAD INPUT_ADDRESS
    STORE VAR_0056
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_0459
    LOAD CONST_0064
    STORE QUALIFY_MASK
    LOAD 32
    STORE QUALIFY_VALUE
    IF VAR_0058 = 1 THEN GOTO LABEL_0027
    IF TASK = 3 THEN GOTO LABEL_0027
    LOAD CONST_0066
    STORE QUALIFY_MASK
    LOAD 16
    STORE QUALIFY_VALUE
    GOTO LABEL_0027

LABEL_0027
    LOAD INPUT_TAG
    IF 17,16 <> 0 THEN GOTO LABEL_0078
    LOAD INPUT_STATUS
    AND QUALIFY_MASK
    IF 7,0 = QUALIFY_VALUE THEN GOTO LABEL_0031

LABEL_0030
    SET RETURN_FLAGS,0

LABEL_0031
    POSITION ABS,3
    LOAD INPUT_DATA
    OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
    POSITION REL,1
    LOAD INPUT_TAG
    IF 1,0 <> 1 THEN GOTO LABEL_003B
    OUTPUT "unused prefetch"
    RETURN

LABEL_003B
    LOAD VAR_0058
    CASE_OF 0,0
        GOTO LABEL_0040
        GOTO LABEL_0078
    CASE_END

LABEL_0040
    LOAD INPUT_STATUS
    IF TASK = 3 THEN GOTO LABEL_0051
    AND 00000007CH
    ROTATE LEFT,1
    STORE VAR_0050
    LOAD INPUT_STATUS
    AND 3
    INCLUSIVE_OR VAR_0050
    STORE VAR_0050
    LOAD INITIAL_ADDRESS
    COMPLEMENT
    AND 1
    ROTATE LEFT,2
    INCLUSIVE_OR VAR_0050
    STORE INPUT_STATUS

LABEL_0051
    IF 7,7 = 0 THEN GOTO LABEL_0056
    OUTPUT STR_0029    * "DMA"
    RETURN

LABEL_0056
    CASE_OF 6,4
        CALL LABEL_0481
        OUTPUT STR_000C    * "user data"
        OUTPUT STR_0011    * "user program"
        CALL LABEL_0481
        CALL LABEL_0481
        OUTPUT STR_0000    * "supr data"
        OUTPUT STR_0005    * "supr program"
        OUTPUT STR_0018    * "interrupt ack"
    CASE_END
    IF 6,4 = 7 THEN GOTO LABEL_0068
    POSITION REL,1
    CASE_OF 0,0
        OUTPUT STR_001F    * "read"
        OUTPUT STR_0022    * "write"
    CASE_END

LABEL_0068
    CASE_OF 3,3
        NOP
        OUTPUT STR_0025    * " (6800)"
    CASE_END
    CASE_OF 2,0
        RETURN
        RETURN
        POSITION ABS,3
        POSITION ABS,3
        RETURN
        RETURN
        POSITION ABS,5
        POSITION ABS,5
    CASE_END
    OUTPUT "xx"
    RETURN

LABEL_0078
    LOAD INPUT_TAG
    IF 1,0 = 2 THEN GOTO LABEL_0030
    IF 1,0 = 1 THEN GOTO LABEL_0030
    LOAD INPUT_STATUS
    AND QUALIFY_MASK
    IF 7,0 <> QUALIFY_VALUE THEN GOTO LABEL_0030
    LOAD INPUT_DATA
    LOAD INPUT_DATA
    CASE_OF 15,12
        GOTO LABEL_0098
        GOTO LABEL_0105
        GOTO LABEL_0105
        GOTO LABEL_0105
        GOTO LABEL_011B
        GOTO LABEL_0218
        GOTO LABEL_0240
        GOTO LABEL_0266
        GOTO LABEL_02B8
        GOTO LABEL_0271
        GOTO LABEL_0329
        GOTO LABEL_0299
        GOTO LABEL_02B8
        GOTO LABEL_0271
        GOTO LABEL_0305
        GOTO LABEL_0329
    CASE_END

LABEL_0098
    IF 8,8 = 1 THEN GOTO LABEL_00BF
    CASE_OF 11,9
        OUTPUT STR_0040    * "OR"
        OUTPUT STR_0042    * "AND"
        OUTPUT STR_0044    * "SUB"
        OUTPUT STR_0048    * "ADD"
        GOTO LABEL_00EF
        OUTPUT STR_0046    * "EOR"
        OUTPUT "CMP"
        GOTO LABEL_045B
    CASE_END
    OUTPUT "I"
    CALL LABEL_0421
    CALL LABEL_03E5
    OUTPUT STR_0039    * ","
    LOAD INITIAL_DATA
    CASE_OF 11,9
        SET VAR_004E,1
        SET VAR_004E,1
        SET VAR_004E,0
        SET VAR_004E,0
        NOP
        SET VAR_004E,1
        SET VAR_004E,0
        NOP
    CASE_END
    CALL LABEL_032D
    IF VAR_004E = 0 THEN RETURN
    LOAD INITIAL_DATA
    IF 5,0 <> 60 THEN RETURN
    SET VAR_0054,2
    CALL LABEL_0474
    RETURN

LABEL_00BF
    IF 5,3 = 1 THEN GOTO LABEL_00D8
    CALL LABEL_00C7
    POSITION ABS,9
    CALL LABEL_0464
    OUTPUT STR_0039    * ","
    GOTO LABEL_032D

LABEL_00C7
    OUTPUT STR_003C    * "B"
    CASE_OF 7,6
        OUTPUT "TST"
        OUTPUT "CHG"
        OUTPUT STR_004A    * "CLR"
        OUTPUT "SET"
    CASE_END
    OUTPUT STR_005A    * "."
    IF 5,3 = 0 THEN GOTO LABEL_00D5
    OUTPUT STR_003C    * "B"
    SET VAR_003A,0
    RETURN

LABEL_00D5
    OUTPUT STR_003E    * "L"
    SET VAR_003A,2
    RETURN

LABEL_00D8
    OUTPUT STR_004C    * "MOVE"
    OUTPUT "P."
    CASE_OF 6,6
        OUTPUT STR_003D    * "W"
        OUTPUT STR_003E    * "L"
    CASE_END
    CASE_OF 6,6
        SET VAR_003A,1
        SET VAR_003A,2
    CASE_END
    SET VAR_0038,5
    POSITION ABS,9
    CASE_OF 7,7
        CALL LABEL_033C
        CALL LABEL_0464
    CASE_END
    LOAD INITIAL_DATA
    OUTPUT STR_0039    * ","
    CASE_OF 7,7
        CALL LABEL_0464
        CALL LABEL_033C
    CASE_END
    RETURN

LABEL_00EF
    CALL LABEL_00C7
    POSITION ABS,9
    OUTPUT STR_003F    * "#"
    CALL LABEL_0406
    IF INPUT_ERROR = 0 THEN GOTO LABEL_00FC
    LOAD VAR_003A
    CASE_OF 1,1
        OUTPUT "*"
        OUTPUT STR_0055    * "**"
    CASE_END
    GOTO LABEL_0103

LABEL_00FC
    LOAD INPUT_DATA
    CASE_OF VAR_003A
        OUTPUT ACCUMULATOR,FMT_0067    * 3,HEX,1
        NOP
        OUTPUT ACCUMULATOR,FMT_006B    * 5,HEX,2
        NOP
    CASE_END

LABEL_0103
    OUTPUT STR_0039    * ","
    GOTO LABEL_032D

LABEL_0105
    OUTPUT STR_004C    * "MOVE"
    IF 8,6 = 1 THEN OUTPUT STR_003B    * "A"
    OUTPUT STR_005A    * "."
    CASE_OF 13,12
        NOP
        OUTPUT STR_003C    * "B"
        OUTPUT STR_003E    * "L"
        OUTPUT STR_003D    * "W"
    CASE_END
    CASE_OF 13,12
        NOP
        SET VAR_003A,0
        SET VAR_003A,2
        SET VAR_003A,1
    CASE_END
    POSITION ABS,9
    CALL LABEL_032D
    OUTPUT STR_0039    * ","
    LOAD INITIAL_DATA
    GOTO LABEL_032F

LABEL_011B
    IF 8,7 = 2 THEN GOTO LABEL_045B
    IF 8,8 = 1 THEN GOTO LABEL_0141
    IF 11,11 = 0 THEN GOTO LABEL_014E
    CASE_OF 10,9
        GOTO LABEL_012B
        GOTO LABEL_01B9
        GOTO LABEL_01C2
        GOTO LABEL_01C6
    CASE_END
    RETURN

LABEL_012B
    CASE_OF 7,6
        OUTPUT "NBCD.B"
        GOTO LABEL_0133
        GOTO LABEL_018E
        GOTO LABEL_018E
    CASE_END
    POSITION ABS,9
    GOTO LABEL_032D

LABEL_0133
    SET VAR_0050,0
    IF 5,3 <> 0 THEN SET VAR_0050,1
    CASE_OF VAR_0050
        OUTPUT "SWAP.W"
        OUTPUT "PEA.L"
    CASE_END
    POSITION ABS,9
    CASE_OF VAR_0050
        CALL LABEL_0466
        CALL LABEL_032D
    CASE_END
    RETURN

LABEL_0141
    CASE_OF 6,6
        OUTPUT "CHK.W"
        OUTPUT "LEA.L"
    CASE_END
    POSITION ABS,9
    CALL LABEL_032D
    LOAD INITIAL_DATA
    OUTPUT STR_0039    * ","
    CASE_OF 6,6
        CALL LABEL_0464
        CALL LABEL_0460
    CASE_END
    RETURN

LABEL_014E
    IF 7,6 = 3 THEN GOTO LABEL_015A
    CASE_OF 10,9
        OUTPUT "NEGX"
        OUTPUT STR_004A    * "CLR"
        OUTPUT "NEG"
        OUTPUT "NOT"
    CASE_END
    CALL LABEL_0421
    CALL LABEL_032D
    RETURN

LABEL_015A
    OUTPUT STR_004C    * "MOVE"
    OUTPUT STR_005A    * "."
    CASE_OF 10,9
        OUTPUT STR_003D    * "W"
        GOTO LABEL_045B
        OUTPUT STR_003C    * "B"
        OUTPUT STR_003D    * "W"
    CASE_END
    CASE_OF 10,9
        SET VAR_003A,1
        SET VAR_003A,1
        SET VAR_003A,0
        SET VAR_003A,1
    CASE_END
    POSITION ABS,9
    CASE_OF 10,9
        OUTPUT STR_004F    * "SR"
        OUTPUT STR_0051    * "CCR"
        CALL LABEL_032D
        CALL LABEL_032D
    CASE_END
    OUTPUT STR_0039    * ","
    LOAD INITIAL_DATA
    CASE_OF 10,9
        CALL LABEL_032D
        CALL LABEL_032D
        OUTPUT STR_0051    * "CCR"
        OUTPUT STR_004F    * "SR"
    CASE_END
    LOAD INITIAL_DATA
    IF 10,9 < 2 THEN RETURN
    CASE_OF 5,3
        SET VAR_0054,1
        NOP
        SET VAR_0054,1
        SET VAR_0054,1
        SET VAR_0054,1
        SET VAR_0054,2
        SET VAR_0054,2
        CALL LABEL_0186
    CASE_END
    GOTO LABEL_0474

LABEL_0186
    CASE_OF 2,0
        SET VAR_0054,2
        SET VAR_0054,3
        SET VAR_0054,2
        SET VAR_0054,2
        SET VAR_0054,2
    CASE_END
    RETURN

LABEL_018E
    IF 5,3 = 0 THEN GOTO LABEL_01B2

LABEL_0191
    OUTPUT STR_004C    * "MOVE"
    OUTPUT "M."
    CASE_OF 6,6
        OUTPUT STR_003D    * "W"
        OUTPUT STR_003E    * "L"
    CASE_END
    CALL LABEL_0406
    STORE VAR_0052
    IF INPUT_ERROR <> 0 THEN SET VAR_0052,0
    POSITION ABS,9
    LOAD INITIAL_DATA
    CASE_OF 10,10
        CALL LABEL_01A9
        CALL LABEL_032D
    CASE_END
    OUTPUT STR_0039    * ","
    LOAD INITIAL_DATA
    CASE_OF 10,10
        CALL LABEL_032D
        CALL LABEL_01A9
    CASE_END
    RETURN

LABEL_01A9
    OUTPUT "rm="
    LOAD VAR_0052
    IF 15,0 <> 0 THEN GOTO LABEL_01B0
    OUTPUT STR_0036    * "****"
    RETURN

LABEL_01B0
    OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
    RETURN

LABEL_01B2
    OUTPUT "EXT."
    CASE_OF 6,6
        OUTPUT STR_003D    * "W"
        OUTPUT STR_003E    * "L"
    CASE_END
    POSITION ABS,9
    GOTO LABEL_0466

LABEL_01B9
    IF 7,6 <> 3 THEN GOTO LABEL_01BE
    OUTPUT "TAS.B"
    GOTO LABEL_01C0

LABEL_01BE
    OUTPUT "TST"
    CALL LABEL_0421

LABEL_01C0
    POSITION ABS,9
    GOTO LABEL_032D

LABEL_01C2
    IF 7,7 = 0 THEN GOTO LABEL_045B
    GOTO LABEL_0191

LABEL_01C6
    CASE_OF 8,6
        GOTO LABEL_045B
        GOTO LABEL_01CE
        OUTPUT "JSR"
        OUTPUT "JMP"
    CASE_END
    POSITION ABS,9
    GOTO LABEL_032D

LABEL_01CE
    CASE_OF 5,4
        GOTO LABEL_01F4
        GOTO LABEL_01FB
        GOTO LABEL_020B
        NOP
    CASE_END
    IF 5,3 = 7 THEN GOTO LABEL_045B
    CASE_OF 2,0
        OUTPUT "RESET"
        OUTPUT "NOP"
        OUTPUT "STOP"
        OUTPUT "RTE"
        GOTO LABEL_045B
        OUTPUT "RTS"
        OUTPUT "TRAPV"
        OUTPUT "RTR"
    CASE_END
    IF 2,0 <> 2 THEN GOTO LABEL_01EC
    POSITION ABS,9
    OUTPUT STR_003F    * "#"
    CALL LABEL_0406
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_045E
    OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
    RETURN

LABEL_01EC
    IF 2,0 < 3 THEN RETURN
    IF 2,0 = 6 THEN RETURN
    SET VAR_0054,1
    GOTO LABEL_0474

LABEL_01F4
    OUTPUT "TRAP"
    POSITION ABS,9
    OUTPUT STR_003F    * "#"
    AND 15
    OUTPUT ACCUMULATOR,FMT_0065    * 4,HEX,1
    SET VAR_0054,1
    GOTO LABEL_0474

LABEL_01FB
    CASE_OF 3,3
        OUTPUT "LINK"
        OUTPUT "UNLK"
    CASE_END
    POSITION ABS,9
    CALL LABEL_0462
    IF 3,3 = 1 THEN RETURN
    OUTPUT ",#"
    CALL LABEL_0406
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_045E
    OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
    RETURN

LABEL_020B
    OUTPUT STR_004C    * "MOVE"
    OUTPUT ".L"
    POSITION ABS,9
    CASE_OF 3,3
        CALL LABEL_0462
        OUTPUT STR_0053    * "USP"
    CASE_END
    OUTPUT STR_0039    * ","
    CASE_OF 3,3
        OUTPUT STR_0053    * "USP"
        CALL LABEL_0462
    CASE_END
    RETURN

LABEL_0218
    IF 7,6 <> 3 THEN GOTO LABEL_0238
    IF 5,3 = 1 THEN GOTO LABEL_0220
    OUTPUT STR_0057    * "S"
    GOTO LABEL_0221

LABEL_0220
    OUTPUT "DB"

LABEL_0221
    CALL LABEL_0438
    IF 5,3 = 1 THEN GOTO LABEL_0228
    OUTPUT ".B"
    POSITION ABS,9
    GOTO LABEL_032D

LABEL_0228
    POSITION ABS,9
    OUTPUT STR_003A    * "D"
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    OUTPUT STR_0039    * ","
    CALL LABEL_0406
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_045E
    IF 15,15 = 1 THEN INCLUSIVE_OR 000FF0000H
    ADD INPUT_ADDRESS

LABEL_0234
    AND CONST_0062
    IF_NOT_MAPPED THEN OUTPUT ACCUMULATOR,FMT_0071    * 24,HEX,6
    RETURN

LABEL_0238
    CASE_OF 8,8
        OUTPUT "ADDQ"
        OUTPUT "SUBQ"
    CASE_END
    CALL LABEL_0421
    CALL LABEL_042E
    OUTPUT STR_0039    * ","
    GOTO LABEL_032D

LABEL_0240
    OUTPUT STR_003C    * "B"
    CALL LABEL_0438
    IF 7,0 <> 0 THEN GOTO LABEL_0250
    OUTPUT ".W"
    SET VAR_003A,1
    CALL LABEL_0406
    IF 15,15 = 1 THEN INCLUSIVE_OR 000FF0000H
    IF INPUT_ERROR = 0 THEN GOTO LABEL_0256
    OUTPUT "********"
    RETURN

LABEL_0250
    OUTPUT ".B"
    SET VAR_003A,0
    AND CONST_005E
    IF 7,7 = 1 THEN INCLUSIVE_OR 000FFFF00H

LABEL_0256
    POSITION ABS,9
    ADD INPUT_ADDRESS
    AND CONST_0062
    IF VAR_003A = 0 THEN ADD 2
    CALL LABEL_0234
    LOAD INITIAL_DATA
    IF 15,9 <> 48 THEN RETURN
    IF 7,0 = 0 THEN RETURN
    SET VAR_0054,1
    GOTO LABEL_0474

LABEL_0266
    OUTPUT STR_004C    * "MOVE"
    OUTPUT "Q.L"
    POSITION ABS,9
    AND CONST_005E
    IF 7,7 = 1 THEN INCLUSIVE_OR 0FFFFFF00H
    OUTPUT STR_003F    * "#"
    OUTPUT ACCUMULATOR,FMT_0073    * 32,HEX,8
    OUTPUT STR_0039    * ","
    GOTO LABEL_0464

LABEL_0271
    CASE_OF 14,14
        OUTPUT STR_0044    * "SUB"
        OUTPUT STR_0048    * "ADD"
    CASE_END
    IF 7,6 = 3 THEN GOTO LABEL_028B
    IF 8,8 <> 1 THEN GOTO LABEL_027E
    IF 5,4 = 0 THEN GOTO LABEL_046A

LABEL_027E
    CALL LABEL_0421
    POSITION ABS,9
    CASE_OF 8,8
        CALL LABEL_032D
        CALL LABEL_0464
    CASE_END
    OUTPUT STR_0039    * ","
    LOAD INITIAL_DATA
    CASE_OF 8,8
        CALL LABEL_0464
        CALL LABEL_032D
    CASE_END
    RETURN

LABEL_028B
    OUTPUT "A."

LABEL_028C
    CASE_OF 8,8
        OUTPUT STR_003D    * "W"
        OUTPUT STR_003E    * "L"
    CASE_END
    CASE_OF 8,8
        SET VAR_003A,1
        SET VAR_003A,2
    CASE_END
    POSITION ABS,9
    CALL LABEL_032D
    OUTPUT STR_0039    * ","
    LOAD INITIAL_DATA
    GOTO LABEL_0460

LABEL_0299
    IF 7,6 = 3 THEN GOTO LABEL_02A4
    IF 8,8 = 1 THEN GOTO LABEL_02A6
    OUTPUT "CMP"
    CALL LABEL_0421
    CALL LABEL_032D
    OUTPUT STR_0039    * ","
    GOTO LABEL_0464

LABEL_02A4
    OUTPUT "CMPA."
    GOTO LABEL_028C

LABEL_02A6
    IF 5,3 <> 1 THEN GOTO LABEL_02B3
    OUTPUT "CMPM"
    CALL LABEL_0421
    POSITION ABS,9
    OUTPUT "[xx]+,[xx]+"
    POSITION REL,-10
    CALL LABEL_0462
    POSITION REL,4
    CALL LABEL_0460
    POSITION REL,2
    RETURN

LABEL_02B3
    OUTPUT STR_0046    * "EOR"
    CALL LABEL_0421
    CALL LABEL_0464
    OUTPUT STR_0039    * ","
    GOTO LABEL_032D

LABEL_02B8
    IF 7,6 = 3 THEN GOTO LABEL_02CC
    IF 14,14 = 0 THEN GOTO LABEL_02C4
    IF 8,4 = 20 THEN GOTO LABEL_02EB
    IF 8,4 = 24 THEN GOTO LABEL_02EB

LABEL_02C4
    IF 8,4 = 16 THEN GOTO LABEL_02D9
    CASE_OF 14,14
        OUTPUT STR_0040    * "OR"
        OUTPUT STR_0042    * "AND"
    CASE_END
    GOTO LABEL_027E

LABEL_02CC
    CASE_OF 14,14
        OUTPUT "DIV"
        OUTPUT "MUL"
    CASE_END
    CASE_OF 8,8
        OUTPUT "U"
        OUTPUT STR_0057    * "S"
    CASE_END
    OUTPUT ".W"
    POSITION ABS,9
    CALL LABEL_032D
    OUTPUT STR_0039    * ","
    GOTO LABEL_0464

LABEL_02D9
    CASE_OF 14,14
        OUTPUT STR_0057    * "S"
        OUTPUT STR_003B    * "A"
    CASE_END
    OUTPUT "BCD.B"
    POSITION ABS,9
    IF 3,3 = 0 THEN GOTO LABEL_02E8
    OUTPUT "-["
    CALL LABEL_0462
    OUTPUT "],-["
    CALL LABEL_0460
    OUTPUT STR_0058    * "]"
    RETURN

LABEL_02E8
    CALL LABEL_0466
    OUTPUT STR_0039    * ","
    GOTO LABEL_0464

LABEL_02EB
    OUTPUT "EXG.L"
    POSITION ABS,9
    IF 7,3 = 8 THEN SET VAR_0050,0
    IF 7,3 = 9 THEN SET VAR_0050,1
    IF 7,3 = 17 THEN SET VAR_0050,2
    CASE_OF VAR_0050
        CALL LABEL_0464
        CALL LABEL_0460
        CALL LABEL_0464
        NOP
    CASE_END
    OUTPUT STR_0039    * ","
    LOAD INITIAL_DATA
    CASE_OF VAR_0050
        CALL LABEL_0466
        CALL LABEL_0462
        CALL LABEL_0462
        NOP
    CASE_END
    RETURN

LABEL_0305
    IF 7,6 = 3 THEN GOTO LABEL_031B
    CASE_OF 4,3
        OUTPUT "AS"
        OUTPUT "LS"
        OUTPUT "ROX"
        OUTPUT "RO"
    CASE_END
    CASE_OF 8,8
        OUTPUT STR_0059    * "R"
        OUTPUT STR_003E    * "L"
    CASE_END
    CALL LABEL_0421
    IF 5,5 = 1 THEN GOTO LABEL_0318
    CALL LABEL_042E
    GOTO LABEL_0319

LABEL_0318
    CALL LABEL_0464

LABEL_0319
    OUTPUT STR_0039    * ","
    GOTO LABEL_0466

LABEL_031B
    CASE_OF 10,9
        OUTPUT "AS"
        OUTPUT "LS"
        OUTPUT "ROX"
        OUTPUT "RO"
    CASE_END
    CASE_OF 8,8
        OUTPUT STR_0059    * "R"
        OUTPUT STR_003E    * "L"
    CASE_END
    OUTPUT ".W"
    SET VAR_003A,1
    POSITION ABS,9
    GOTO LABEL_032D

LABEL_0329
    OUTPUT "Unimplemented Instruction:"
    OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
    SET VAR_0054,1
    GOTO LABEL_0474

LABEL_032D
    SET VAR_0034,1
    GOTO LABEL_0330

LABEL_032F
    SET VAR_0034,0

LABEL_0330
    LOAD INITIAL_DATA
    CASE_OF VAR_0034
        ROTATE RIGHT,6
        ROTATE RIGHT,3
    CASE_END
    AND 7
    STORE VAR_0038
    LOAD INITIAL_DATA
    CASE_OF VAR_0034
        ROTATE RIGHT,9
        NOP
    CASE_END

LABEL_033C
    AND 7
    STORE VAR_0036
    CASE_OF VAR_0038
        OUTPUT STR_003A    * "D"
        OUTPUT STR_003B    * "A"
        OUTPUT "[A"
        OUTPUT "[A"
        OUTPUT "-[A"
        GOTO LABEL_0356
        GOTO LABEL_035D
        GOTO LABEL_037E
    CASE_END
    LOAD VAR_0036
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    LOAD INITIAL_DATA
    CASE_OF VAR_0038
        RETURN
        RETURN
        OUTPUT STR_0058    * "]"
        OUTPUT "]+"
        OUTPUT STR_0058    * "]"
        NOP
        NOP
        NOP
    CASE_END
    RETURN

LABEL_0356
    CALL LABEL_0400
    OUTPUT "[A"
    LOAD VAR_0036
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    OUTPUT STR_0058    * "]"
    LOAD INITIAL_DATA
    RETURN

LABEL_035D
    CALL LABEL_0406
    IF INPUT_ERROR = 0 THEN GOTO LABEL_0366
    OUTPUT "**[A"
    LOAD VAR_0036
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    OUTPUT ",**.*]"
    RETURN

LABEL_0366
    AND CONST_005E
    OUTPUT ACCUMULATOR,FMT_0069    * 8,HEX,2
    OUTPUT "["
    LOAD INPUT_DATA
    OUTPUT STR_003B    * "A"
    LOAD VAR_0036
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    OUTPUT STR_0039    * ","
    CASE_OF 15,15
        OUTPUT STR_003A    * "D"
        OUTPUT STR_003B    * "A"
    CASE_END
    LOAD INPUT_DATA
    ROTATE RIGHT,12
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    OUTPUT STR_005A    * "."
    LOAD INPUT_DATA
    CASE_OF 11,11
        OUTPUT STR_003D    * "W"
        OUTPUT STR_003E    * "L"
    CASE_END
    OUTPUT STR_0058    * "]"
    LOAD INITIAL_DATA
    RETURN

LABEL_037E
    CASE_OF VAR_0036
        GOTO LABEL_0386
        GOTO LABEL_0390
        GOTO LABEL_03B4
        GOTO LABEL_03BF
        GOTO LABEL_03DB
    CASE_END
    GOTO LABEL_0455

LABEL_0386
    CALL LABEL_0406
    IF INPUT_ERROR = 0 THEN GOTO LABEL_038C
    OUTPUT "******"
    RETURN

LABEL_038C
    IF 15,15 = 1 THEN INCLUSIVE_OR 000FF0000H
    GOTO LABEL_0234

LABEL_0390
    CALL LABEL_0406
    STORE VAR_0048
    SET VAR_0046,0
    IF INPUT_ERROR <> 0 THEN SET VAR_0046,1
    CALL LABEL_0406
    STORE VAR_004A
    LOAD VAR_0046
    IF INPUT_ERROR <> 0 THEN INCLUSIVE_OR 2
    STORE VAR_0046
    IF VAR_0046 = 0 THEN GOTO LABEL_03AF
    LOAD VAR_0048
    CASE_OF VAR_0046
        NOP
        OUTPUT STR_0036    * "****"
        OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
        OUTPUT STR_0036    * "****"
    CASE_END
    LOAD VAR_004A
    CASE_OF VAR_0046
        NOP
        OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
        OUTPUT STR_0036    * "****"
        OUTPUT STR_0036    * "****"
    CASE_END
    RETURN

LABEL_03AF
    LOAD VAR_0048
    AND 0000000FFH
    ROTATE LEFT,16
    INCLUSIVE_OR VAR_004A
    GOTO LABEL_0234

LABEL_03B4
    CALL LABEL_0406
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_045E
    IF 15,15 = 1 THEN INCLUSIVE_OR 000FF0000H
    ADD INPUT_ADDRESS
    CALL LABEL_0234
    OUTPUT "[PC]"
    RETURN

LABEL_03BF
    CALL LABEL_0406
    IF INPUT_ERROR = 0 THEN GOTO LABEL_03C5
    OUTPUT "**[PC,**.*]"
    RETURN

LABEL_03C5
    AND 0000000FFH
    IF 7,7 = 1 THEN INCLUSIVE_OR 000FFFF00H
    ADD INPUT_ADDRESS
    CALL LABEL_0234
    LOAD INPUT_DATA
    OUTPUT "[PC,"
    CASE_OF 15,15
        OUTPUT STR_003A    * "D"
        OUTPUT STR_003B    * "A"
    CASE_END
    ROTATE RIGHT,12
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    OUTPUT STR_005A    * "."
    LOAD INPUT_DATA
    CASE_OF 11,11
        OUTPUT STR_003D    * "W"
        OUTPUT STR_003E    * "L"
    CASE_END
    OUTPUT STR_0058    * "]"
    RETURN

LABEL_03DB
    IF VAR_004E = 0 THEN GOTO LABEL_03E5
    CASE_OF VAR_003A
        OUTPUT STR_0051    * "CCR"
        OUTPUT STR_004F    * "SR"
        GOTO LABEL_0455
        GOTO LABEL_0455
    CASE_END
    RETURN

LABEL_03E5
    OUTPUT STR_003F    * "#"
    CALL LABEL_0406
    IF INPUT_ERROR = 0 THEN GOTO LABEL_03F1
    CASE_OF VAR_003A
        OUTPUT STR_0055    * "**"
        OUTPUT STR_0036    * "****"
        OUTPUT STR_0036    * "****"
        GOTO LABEL_045B
    CASE_END
    GOTO LABEL_03F7

LABEL_03F1
    CASE_OF VAR_003A
        OUTPUT ACCUMULATOR,FMT_0069    * 8,HEX,2
        OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
        OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
        GOTO LABEL_045B
    CASE_END

LABEL_03F7
    IF VAR_003A <> 2 THEN RETURN
    CALL LABEL_0406
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_045E
    OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
    RETURN

LABEL_0400
    CALL LABEL_0406
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_045E
    OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
    RETURN

LABEL_0406
    INCREMENT VAR_0056
    INCREMENT VAR_0056
    CALL LABEL_040F
    CALL LABEL_0411
    IF INPUT_ERROR = 0 THEN TAG_WITH 2
    LOAD INPUT_DATA
    RETURN

LABEL_040F
    INPUT ABS,VAR_0056,QUALIFIED
    RETURN

LABEL_0411
    IF TASK = 3 THEN RETURN
    IF VAR_0044 = 1 THEN SET INPUT_ERROR,1
    IF INPUT_ERROR <> 0 THEN RETURN
    LOAD INPUT_TAG
    IF 17,16 <> 3 THEN RETURN
    SET VAR_0044,1
    SET INPUT_ERROR,1
    RETURN

LABEL_0421
    OUTPUT STR_005A    * "."
    CASE_OF 7,6
        OUTPUT STR_003C    * "B"
        OUTPUT STR_003D    * "W"
        OUTPUT STR_003E    * "L"
        GOTO LABEL_0455
    CASE_END
    ROTATE RIGHT,6
    AND 3
    STORE VAR_003A
    LOAD INITIAL_DATA
    POSITION ABS,9
    RETURN

LABEL_042E
    OUTPUT STR_003F    * "#"
    IF 11,9 <> 0 THEN GOTO LABEL_0434
    OUTPUT "8"
    RETURN

LABEL_0434
    ROTATE RIGHT,9
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    LOAD INITIAL_DATA
    RETURN

LABEL_0438
    CASE_OF 11,8
        GOTO LABEL_044B
        GOTO LABEL_0450
        OUTPUT "HI"
        OUTPUT "LS"
        OUTPUT "CC"
        OUTPUT "CS"
        OUTPUT "NE"
        OUTPUT "EQ"
        OUTPUT "VC"
        OUTPUT "VS"
        OUTPUT "PL"
        OUTPUT "MI"
        OUTPUT "GE"
        OUTPUT "LT"
        OUTPUT "GT"
        OUTPUT "LE"
    CASE_END
    RETURN

LABEL_044B
    CASE_OF 12,12
        OUTPUT "RA"
        OUTPUT "T"
    CASE_END
    RETURN

LABEL_0450
    CASE_OF 12,12
        OUTPUT STR_004F    * "SR"
        OUTPUT "F"
    CASE_END
    RETURN

LABEL_0455
    POSITION ABS,9
    OUTPUT STR_005B    * "Illegal"
    OUTPUT " Operand    "
    ABORT

LABEL_0459
    OUTPUT "Data Error"
    ABORT

LABEL_045B
    OUTPUT STR_005B    * "Illegal"
    OUTPUT " Opcode"
    ABORT

LABEL_045E
    OUTPUT STR_0036    * "****"
    RETURN

LABEL_0460
    LOAD INITIAL_DATA
    ROTATE RIGHT,9

LABEL_0462
    OUTPUT STR_003B    * "A"
    GOTO LABEL_0467

LABEL_0464
    LOAD INITIAL_DATA
    ROTATE RIGHT,9

LABEL_0466
    OUTPUT STR_003A    * "D"

LABEL_0467
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    LOAD INITIAL_DATA
    RETURN

LABEL_046A
    OUTPUT "X"
    CALL LABEL_0421
    CASE_OF 3,3
        SET VAR_0038,0
        SET VAR_0038,4
    CASE_END
    CALL LABEL_033C
    ROTATE RIGHT,9
    OUTPUT STR_0039    * ","
    GOTO LABEL_033C

LABEL_0474
    INPUT REL,VAR_0054,QUALIFIED
    CALL LABEL_0411
    IF INPUT_ERROR <> 0 THEN RETURN
    LOAD VAR_0056
    ADD 2
    SUBTRACT INPUT_ADDRESS
    IF 31,0 <> 0 THEN RETURN
    TAG_WITH 1
    RETURN

LABEL_0481
    OUTPUT "unknown ("
    AND 000000070H
    ROTATE RIGHT,4
    OUTPUT ACCUMULATOR,FMT_005F    * 3,BIN,3
    OUTPUT ")"
    LOAD INPUT_STATUS
    RETURN
