"IAL"

*
* Original Source File Name: i6800_i.s
*

        LABEL_TITLE      " 6800/6802 Mnemonic"
        BASE_TITLE       "        hex"
        SEARCH_LIMIT     12
        DEFAULT_WIDTH    21
        MAPPED_WIDTH     21
VAR_0034        VARIABLE 000000000H
VAR_0036        VARIABLE 000000000H
VAR_0038_UNREF  VARIABLE 000000000H
VAR_003A        VARIABLE 000000000H
VAR_003C        VARIABLE 000000000H
VAR_003E        VARIABLE 000000000H
VAR_0040        VARIABLE 000000000H
FMT_0010        FORMAT 16,HEX,4
FMT_0012        FORMAT 8,HEX,2
STR_0014        ASCII "A"
STR_0015        ASCII "B"
STR_0016        ASCII "C"
STR_0017_UNREF  ASCII "H"
STR_0018        ASCII "I"
STR_0019        ASCII "S"
STR_001A        ASCII "V"
STR_001B        ASCII "X"
STR_001C        ASCII "PUL"
STR_001E        ASCII "PSH"
STR_0020_UNREF  ASCII ","
STR_0021_UNREF  ASCII "-"
STR_0022        ASCII ",X"
STR_0024        ASCII "operand fetch"
STR_002B        ASCII "stack read"
STR_0031        ASCII "stack write"
STR_0037        ASCII "halt"
STR_003A        ASCII "vector"
STR_003E        ASCII "unused"
STR_0042        ASCII "opcode fetch"
STR_0049        ASCII "DMA read"
STR_004E        ASCII "DMA write"
STR_0053        ASCII "memory read"
STR_0059        ASCII "memory write"
STR_0060        ASCII "out of synch"
STR_0067        ASCII "interrupt ack"
STR_006E        ASCII "Illegal Opcode"
STR_0076        ASCII "unused cycle"
STR_007D        ASCII "dma or halt"
STR_0083        ASCII "non valid cycle"
CONST_0042      CONSTANT 00000FFFFH
CONST_0044      CONSTANT 00000FF00H
CONST_0046      CONSTANT 0FFFFFF00H

ENTRY_POINT
    IF TASK = 3 THEN GOTO LABEL_0010
    IF TASK = 4 THEN GOTO LABEL_0015
    IF TASK = 5 THEN GOTO LABEL_0015
    OUTPUT "Illegal Task Request"
    ABORT
    OUTPUT "Data Error"
    ABORT

LABEL_000D
    POSITION ABS,1
    OUTPUT STR_006E    * "Illegal Opcode"
    ABORT

LABEL_0010
    LOAD ID_CODE
    IF 7,0 = 0000000F0H THEN GOTO LABEL_0016
    GOTO LABEL_0026

LABEL_0015
    GOTO LABEL_0026

LABEL_0016
    LOAD INPUT_TAG
    IF 17,16 = 0 THEN GOTO LABEL_0043
    LOAD INPUT_STATUS
    IF 2,2 = 1 THEN GOTO LABEL_0043
    LOAD INPUT_TAG
    CASE_OF 1,0
        GOTO LABEL_01A2
        GOTO LABEL_0043
        GOTO LABEL_0054
        NOP
    CASE_END
    RETURN

LABEL_0026
    LOAD INPUT_STATUS
    IF 3,0 = 9 THEN GOTO LABEL_005B
    LOAD INPUT_DATA
    POSITION ABS,3
    OUTPUT ACCUMULATOR,FMT_0012    * 8,HEX,2
    POSITION REL,1
    LOAD INPUT_STATUS
    CASE_OF 3,0
        OUTPUT STR_006E    * "Illegal Opcode"
        OUTPUT STR_0024    * "operand fetch"
        NOP
        NOP
        OUTPUT STR_002B    * "stack read"
        OUTPUT STR_0031    * "stack write"
        OUTPUT STR_0037    * "halt"
        OUTPUT STR_003A    * "vector"
        OUTPUT STR_003E    * "unused"
        OUTPUT STR_0042    * "opcode fetch"
        OUTPUT STR_0049    * "DMA read"
        OUTPUT STR_004E    * "DMA write"
        OUTPUT STR_0059    * "memory write"
        OUTPUT STR_0053    * "memory read"
        OUTPUT STR_0060    * "out of synch"
        OUTPUT STR_0067    * "interrupt ack"
    CASE_END
    SET RETURN_FLAGS,0
    RETURN

LABEL_0043
    LOAD INPUT_DATA
    POSITION ABS,3
    OUTPUT ACCUMULATOR,FMT_0012    * 8,HEX,2
    POSITION REL,1
    LOAD INPUT_STATUS
    CASE_OF 2,0
        OUTPUT STR_0083    * "non valid cycle"
        OUTPUT STR_0083    * "non valid cycle"
        OUTPUT STR_0059    * "memory write"
        OUTPUT STR_0053    * "memory read"
        OUTPUT STR_007D    * "dma or halt"
        OUTPUT STR_007D    * "dma or halt"
        OUTPUT STR_007D    * "dma or halt"
        OUTPUT STR_007D    * "dma or halt"
    CASE_END
    SET RETURN_FLAGS,0
    RETURN

LABEL_0054
    LOAD INPUT_DATA
    POSITION ABS,3
    OUTPUT ACCUMULATOR,FMT_0012    * 8,HEX,2
    POSITION REL,1
    OUTPUT STR_0076    * "unused cycle"
    SET RETURN_FLAGS,0
    RETURN

LABEL_005B
    SET RETURN_FLAGS,1
    INPUT REL,0
    LOAD INITIAL_DATA
    CASE_OF 7,7
        GOTO LABEL_0062
        GOTO LABEL_0103
    CASE_END

LABEL_0062
    CASE_OF 7,4
        GOTO LABEL_006C
        GOTO LABEL_008C
        GOTO LABEL_009F
        GOTO LABEL_00C4
        GOTO LABEL_00E2
        GOTO LABEL_00E2
        GOTO LABEL_00E2
        GOTO LABEL_00E2
    CASE_END

LABEL_006C
    CASE_OF 3,0
        GOTO LABEL_000D
        OUTPUT "NOP"
        GOTO LABEL_000D
        GOTO LABEL_000D
        GOTO LABEL_000D
        GOTO LABEL_000D
        OUTPUT "TAP"
        OUTPUT "TPA"
        OUTPUT "INX"
        OUTPUT "DEX"
        GOTO LABEL_007F
        GOTO LABEL_0081
        GOTO LABEL_007F
        GOTO LABEL_0081
        GOTO LABEL_007F
        GOTO LABEL_0081
    CASE_END
    RETURN

LABEL_007F
    OUTPUT "CL"
    GOTO LABEL_0082

LABEL_0081
    OUTPUT "SE"

LABEL_0082
    IF 2,1 = 1 THEN OUTPUT STR_001A    * "V"
    IF 2,1 = 2 THEN OUTPUT STR_0016    * "C"
    IF 2,1 = 3 THEN OUTPUT STR_0018    * "I"
    RETURN

LABEL_008C
    CASE_OF 3,0
        OUTPUT "SBA"
        OUTPUT "CBA"
        GOTO LABEL_000D
        GOTO LABEL_000D
        GOTO LABEL_000D
        GOTO LABEL_000D
        OUTPUT "TAB"
        OUTPUT "TBA"
        GOTO LABEL_000D
        OUTPUT "DAA"
        GOTO LABEL_000D
        OUTPUT "ABA"
        GOTO LABEL_000D
        GOTO LABEL_000D
        GOTO LABEL_000D
        GOTO LABEL_000D
    CASE_END
    RETURN

LABEL_009F
    OUTPUT STR_0015    * "B"
    CASE_OF 3,0
        OUTPUT "RA"
        GOTO LABEL_000D
        OUTPUT "HI"
        OUTPUT "LS"
        OUTPUT "CC"
        OUTPUT "CS"
        OUTPUT "NE"
        OUTPUT "EQ"
        OUTPUT "VC"
        OUTPUT "VS"
        OUTPUT "PL"
        OUTPUT "MI"
        OUTPUT "GE"
        OUTPUT "LT"
        OUTPUT "GT"
        OUTPUT "LE"
    CASE_END

LABEL_00B2
    INCREMENT INPUT_ADDRESS
    LOAD INPUT_ADDRESS
    ADD 1
    STORE VAR_003E
    INPUT ABS,INPUT_ADDRESS
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_017C
    LOAD INPUT_DATA
    POSITION ABS,6
    IF 7,7 = 1 THEN INCLUSIVE_OR CONST_0046
    ADD VAR_003E
    AND CONST_0042
    IF_NOT_MAPPED THEN OUTPUT ACCUMULATOR,FMT_0010    * 16,HEX,4
    RETURN

LABEL_00C4
    CASE_OF 3,0
        OUTPUT "TSX"
        OUTPUT "INS"
        GOTO LABEL_00D7
        GOTO LABEL_00D7
        OUTPUT "DES"
        OUTPUT "TXS"
        GOTO LABEL_00D7
        GOTO LABEL_00D7
        GOTO LABEL_000D
        OUTPUT "RTS"
        GOTO LABEL_000D
        OUTPUT "RTI"
        GOTO LABEL_000D
        GOTO LABEL_000D
        OUTPUT "WAI"
        OUTPUT "SWI"
    CASE_END
    RETURN

LABEL_00D7
    IF 2,2 = 0 THEN OUTPUT STR_001C    * "PUL"
    IF 2,2 = 1 THEN OUTPUT STR_001E    * "PSH"
    CASE_OF 0,0
        GOTO LABEL_00FF
        GOTO LABEL_0101
    CASE_END
    RETURN

LABEL_00E2
    CASE_OF 3,0
        OUTPUT "NEG"
        GOTO LABEL_000D
        GOTO LABEL_000D
        OUTPUT "COM"
        OUTPUT "LSR"
        GOTO LABEL_000D
        OUTPUT "ROR"
        OUTPUT "ASR"
        OUTPUT "ASL"
        OUTPUT "ROL"
        OUTPUT "DEC"
        GOTO LABEL_000D
        OUTPUT "INC"
        OUTPUT "TST"
        GOTO LABEL_00F5
        OUTPUT "CLR"
    CASE_END
    GOTO LABEL_00F9

LABEL_00F5
    CASE_OF 5,5
        GOTO LABEL_000D
        OUTPUT "JMP"
    CASE_END

LABEL_00F9
    CASE_OF 5,4
        GOTO LABEL_00FF
        GOTO LABEL_0101
        GOTO LABEL_016B
        GOTO LABEL_0170
    CASE_END

LABEL_00FF
    OUTPUT STR_0014    * "A"
    RETURN

LABEL_0101
    OUTPUT STR_0015    * "B"
    RETURN

LABEL_0103
    CASE_OF 3,0
        OUTPUT "SUB"
        OUTPUT "CMP"
        OUTPUT "SBC"
        GOTO LABEL_000D
        OUTPUT "AND"
        OUTPUT "BIT"
        OUTPUT "LDA"
        GOTO LABEL_0116
        OUTPUT "EOR"
        OUTPUT "ADC"
        OUTPUT "ORA"
        OUTPUT "ADD"
        GOTO LABEL_011E
        GOTO LABEL_0126
        GOTO LABEL_0138
        GOTO LABEL_0141
    CASE_END
    GOTO LABEL_0150

LABEL_0116
    IF 7,4 = 8 THEN GOTO LABEL_000D
    IF 7,4 = 12 THEN GOTO LABEL_000D
    OUTPUT "STA"
    GOTO LABEL_0150

LABEL_011E
    IF 7,4 >= 12 THEN GOTO LABEL_000D
    OUTPUT "CPX"
    IF 5,4 = 0 THEN GOTO LABEL_0161
    GOTO LABEL_0156

LABEL_0126
    IF 7,4 = 9 THEN GOTO LABEL_000D
    IF 7,4 >= 12 THEN GOTO LABEL_000D
    IF 5,4 = 0 THEN GOTO LABEL_0136
    OUTPUT "JSR"
    IF 5,4 = 2 THEN GOTO LABEL_016B
    IF 5,4 = 3 THEN GOTO LABEL_0170

LABEL_0136
    OUTPUT "BSR"
    GOTO LABEL_00B2

LABEL_0138
    OUTPUT "LD"
    CASE_OF 6,6
        OUTPUT STR_0019    * "S"
        OUTPUT STR_001B    * "X"
    CASE_END
    IF 5,4 = 0 THEN GOTO LABEL_0161
    GOTO LABEL_0156

LABEL_0141
    IF 7,4 = 8 THEN GOTO LABEL_000D
    IF 7,4 = 12 THEN GOTO LABEL_000D
    OUTPUT "ST"
    CASE_OF 6,6
        OUTPUT STR_0019    * "S"
        OUTPUT STR_001B    * "X"
    CASE_END
    IF 5,4 = 0 THEN GOTO LABEL_0161
    GOTO LABEL_0156

LABEL_0150
    IF 6,6 = 0 THEN CALL LABEL_00FF
    IF 6,6 = 1 THEN CALL LABEL_0101

LABEL_0156
    CASE_OF 5,4
        GOTO LABEL_015C
        GOTO LABEL_0166
        GOTO LABEL_016B
        GOTO LABEL_0170
    CASE_END

LABEL_015C
    POSITION ABS,6
    OUTPUT "#"
    CALL LABEL_0175
    OUTPUT ACCUMULATOR,FMT_0012    * 8,HEX,2
    RETURN

LABEL_0161
    POSITION ABS,6
    OUTPUT "#"
    CALL LABEL_017E
    OUTPUT ACCUMULATOR,FMT_0010    * 16,HEX,4
    RETURN

LABEL_0166
    POSITION ABS,6
    CALL LABEL_0175
    IF_NOT_MAPPED THEN OUTPUT ACCUMULATOR,FMT_0010    * 16,HEX,4
    RETURN

LABEL_016B
    POSITION ABS,6
    CALL LABEL_0175
    OUTPUT ACCUMULATOR,FMT_0012    * 8,HEX,2
    OUTPUT STR_0022    * ",X"
    RETURN

LABEL_0170
    POSITION ABS,6
    CALL LABEL_017E
    IF_NOT_MAPPED THEN OUTPUT ACCUMULATOR,FMT_0010    * 16,HEX,4
    RETURN

LABEL_0175
    INCREMENT INPUT_ADDRESS
    INPUT ABS,INPUT_ADDRESS
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_017C
    LOAD INPUT_DATA
    RETURN

LABEL_017C
    OUTPUT "**"
    ABORT

LABEL_017E
    INCREMENT INPUT_ADDRESS
    LOAD INPUT_ADDRESS
    STORE VAR_003C
    INPUT ABS,INPUT_ADDRESS
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_0192
    LOAD INPUT_DATA
    ROTATE LEFT,8
    AND CONST_0044
    STORE VAR_0034
    INCREMENT INPUT_ADDRESS
    INPUT ABS,INPUT_ADDRESS
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_019D
    LOAD INPUT_DATA
    AND 0000000FFH
    INCLUSIVE_OR VAR_0034
    RETURN

LABEL_0192
    OUTPUT "**"
    LOAD VAR_003C
    STORE INPUT_ADDRESS
    INCREMENT INPUT_ADDRESS
    INPUT ABS,INPUT_ADDRESS
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_01A0
    LOAD INPUT_DATA
    OUTPUT ACCUMULATOR,FMT_0012    * 8,HEX,2
    ABORT

LABEL_019D
    LOAD VAR_0034
    ROTATE RIGHT,8
    OUTPUT ACCUMULATOR,FMT_0012    * 8,HEX,2

LABEL_01A0
    OUTPUT "**"
    ABORT

LABEL_01A2
    SET VAR_0040,0

LABEL_01A3
    LOAD INPUT_STATUS
    IF 1,0 = 3 THEN GOTO LABEL_01AE
    TAG_WITH 2
    INCREMENT VAR_0040
    INPUT REL,VAR_0040
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_005B
    GOTO LABEL_01A3

LABEL_01AE
    LOAD INPUT_DATA
    CASE_OF 7,0
        GOTO LABEL_000D
        LOAD 56
        GOTO LABEL_000D
        GOTO LABEL_000D
        GOTO LABEL_000D
        GOTO LABEL_000D
        LOAD 56
        LOAD 56
        LOAD 0000003A8H
        LOAD 0000003A8H
        LOAD 56
        LOAD 56
        LOAD 56
        LOAD 56
        LOAD 56
        LOAD 56
        LOAD 56
        LOAD 56
        GOTO LABEL_000D
        GOTO LABEL_000D
        GOTO LABEL_000D
        GOTO LABEL_000D
        LOAD 56
        LOAD 56
        GOTO LABEL_000D
        LOAD 56
        GOTO LABEL_000D
        LOAD 56
        GOTO LABEL_000D
        GOTO LABEL_000D
        GOTO LABEL_000D
        GOTO LABEL_000D
        LOAD 0000003A4H
        GOTO LABEL_000D
        LOAD 0000003A4H
        LOAD 0000003A4H
        LOAD 0000003A4H
        LOAD 0000003A4H
        LOAD 0000003A4H
        LOAD 0000003A4H
        LOAD 0000003A4H
        LOAD 0000003A4H
        LOAD 0000003A4H
        LOAD 0000003A4H
        LOAD 0000003A4H
        LOAD 0000003A4H
        LOAD 0000003A4H
        LOAD 0000003A4H
        LOAD 0000003A8H
        LOAD 0000003A8H
        LOAD 000000368H
        LOAD 000000368H
        LOAD 0000003A8H
        LOAD 0000003A8H
        LOAD 000000398H
        LOAD 000000398H
        GOTO LABEL_000D
        LOAD 000000D68H
        GOTO LABEL_000D
        LOAD 000355568H
        GOTO LABEL_000D
        GOTO LABEL_000D
        LOAD 00D695558H
        LOAD 003595558H
        LOAD 56
        GOTO LABEL_000D
        GOTO LABEL_000D
        LOAD 56
        LOAD 56
        GOTO LABEL_000D
        LOAD 56
        LOAD 56
        LOAD 56
        LOAD 56
        LOAD 56
        GOTO LABEL_000D
        LOAD 56
        LOAD 56
        GOTO LABEL_000D
        LOAD 56
        LOAD 56
        GOTO LABEL_000D
        GOTO LABEL_000D
        LOAD 56
        LOAD 56
        GOTO LABEL_000D
        LOAD 56
        LOAD 56
        LOAD 56
        LOAD 56
        LOAD 56
        GOTO LABEL_000D
        LOAD 56
        LOAD 56
        GOTO LABEL_000D
        LOAD 56
        LOAD 00000D9A4H
        GOTO LABEL_000D
        GOTO LABEL_000D
        LOAD 00000D9A4H
        LOAD 00000D9A4H
        GOTO LABEL_000D
        LOAD 00000D9A4H
        LOAD 00000D9A4H
        LOAD 00000D9A4H
        LOAD 00000D9A4H
        LOAD 00000D9A4H
        GOTO LABEL_000D
        LOAD 00000D9A4H
        LOAD 00000EAA4H
        LOAD 0000003A4H
        LOAD 00000D9A4H
        LOAD 000003654H
        GOTO LABEL_000D
        GOTO LABEL_000D
        LOAD 000003654H
        LOAD 000003654H
        GOTO LABEL_000D
        LOAD 000003654H
        LOAD 000003654H
        LOAD 000003654H
        LOAD 000003654H
        LOAD 000003654H
        GOTO LABEL_000D
        LOAD 000003654H
        LOAD 000003A54H
        LOAD 0000000D4H
        LOAD 000003654H
        LOAD 52
        LOAD 52
        LOAD 52
        GOTO LABEL_000D
        LOAD 52
        LOAD 52
        LOAD 52
        GOTO LABEL_000D
        LOAD 52
        LOAD 52
        LOAD 52
        LOAD 52
        LOAD 0000000D4H
        LOAD 00003A964H
        LOAD 0000000D4H
        GOTO LABEL_000D
        LOAD 0000000D4H
        LOAD 0000000D4H
        LOAD 0000000D4H
        GOTO LABEL_000D
        LOAD 0000000D4H
        LOAD 0000000D4H
        LOAD 0000000D4H
        LOAD 000000364H
        LOAD 0000000D4H
        LOAD 0000000D4H
        LOAD 0000000D4H
        LOAD 0000000D4H
        LOAD 000000354H
        GOTO LABEL_000D
        LOAD 000000354H
        LOAD 000000D64H
        LOAD 000000DA4H
        LOAD 000000DA4H
        LOAD 000000DA4H
        GOTO LABEL_000D
        LOAD 000000DA4H
        LOAD 000000DA4H
        LOAD 000000DA4H
        LOAD 0000036A4H
        LOAD 000000DA4H
        LOAD 000000DA4H
        LOAD 000000DA4H
        LOAD 000000DA4H
        LOAD 0000035A4H
        LOAD 00003A964H
        LOAD 0000035A4H
        LOAD 00000D6A4H
        LOAD 000000354H
        LOAD 000000354H
        LOAD 000000354H
        GOTO LABEL_000D
        LOAD 000000354H
        LOAD 000000354H
        LOAD 000000354H
        LOAD 000000D94H
        LOAD 000000354H
        LOAD 000000354H
        LOAD 000000354H
        LOAD 000000354H
        LOAD 000000D54H
        LOAD 0000EA594H
        LOAD 000000D54H
        LOAD 000003594H
        LOAD 52
        LOAD 52
        LOAD 52
        GOTO LABEL_000D
        LOAD 52
        LOAD 52
        LOAD 52
        GOTO LABEL_000D
        LOAD 52
        LOAD 52
        LOAD 52
        LOAD 52
        GOTO LABEL_000D
        GOTO LABEL_000D
        LOAD 0000000D4H
        GOTO LABEL_000D
        LOAD 0000000D4H
        LOAD 0000000D4H
        LOAD 0000000D4H
        GOTO LABEL_000D
        LOAD 0000000D4H
        LOAD 0000000D4H
        LOAD 0000000D4H
        LOAD 000000364H
        LOAD 0000000D4H
        LOAD 0000000D4H
        LOAD 0000000D4H
        LOAD 0000000D4H
        GOTO LABEL_000D
        GOTO LABEL_000D
        LOAD 000000354H
        LOAD 000000D64H
        LOAD 000000DA4H
        LOAD 000000DA4H
        LOAD 000000DA4H
        GOTO LABEL_000D
        LOAD 000000DA4H
        LOAD 000000DA4H
        LOAD 000000DA4H
        LOAD 0000036A4H
        LOAD 000000DA4H
        LOAD 000000DA4H
        LOAD 000000DA4H
        LOAD 000000DA4H
        GOTO LABEL_000D
        GOTO LABEL_000D
        LOAD 0000035A4H
        LOAD 00000D6A4H
        LOAD 000000354H
        LOAD 000000354H
        LOAD 000000354H
        GOTO LABEL_000D
        LOAD 000000354H
        LOAD 000000354H
        LOAD 000000354H
        LOAD 000000D94H
        LOAD 000000354H
        LOAD 000000354H
        LOAD 000000354H
        LOAD 000000354H
        GOTO LABEL_000D
        GOTO LABEL_000D
        LOAD 000000D54H
        LOAD 000003594H
    CASE_END

LABEL_02B1
    STORE VAR_0036
    AND 3
    STORE VAR_003A
    IF 1,0 = 3 THEN GOTO LABEL_005B
    TAG_WITH VAR_003A

LABEL_02B8
    INCREMENT VAR_0040
    INPUT REL,VAR_0040
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_005B
    LOAD INPUT_STATUS
    IF 2,2 = 1 THEN GOTO LABEL_02B8
    LOAD VAR_0036
    ROTATE RIGHT,2
    GOTO LABEL_02B1
