"IAL"

*
* Original Source File Name: d:\ial\procs\i68010_i.s
*

VAR_0034        VARIABLE 000000000H
VAR_0036        VARIABLE 000000000H
VAR_0038        VARIABLE 000000000H
VAR_003A        VARIABLE 000000000H
VAR_003C_UNREF  VARIABLE 000000000H
VAR_003E_UNREF  VARIABLE 000000000H
VAR_0040_UNREF  VARIABLE 000000000H
VAR_0042_UNREF  VARIABLE 000000000H
VAR_0044        VARIABLE 000000000H
VAR_0046        VARIABLE 000000000H
VAR_0048        VARIABLE 000000000H
VAR_004A        VARIABLE 000000000H
VAR_004C        VARIABLE 000000000H
VAR_004E        VARIABLE 000000000H
VAR_0050        VARIABLE 000000000H
VAR_0052        VARIABLE 000000000H
VAR_0054        VARIABLE 000000000H
VAR_0056        VARIABLE 000000000H
VAR_0058        VARIABLE 000000000H
VAR_005A        VARIABLE 000000000H
VAR_005C_UNREF  VARIABLE 000000000H
VAR_005E        VARIABLE 0000FFFFFH
CONST_0060      CONSTANT 0000000FFH
CONST_0062      CONSTANT 0000FFFFFH
CONST_0064      CONSTANT 000FFFFFFH
CONST_0066      CONSTANT 0000000BBH
CONST_0068      CONSTANT 00000005FH
VAR_006A_UNREF  VARIABLE 0000000BFH
VAR_006C_UNREF  VARIABLE 0000000A9H
STR_0000        ASCII "supr data"
STR_0005        ASCII "supr program"
STR_000C        ASCII "user data"
STR_0011        ASCII "user program"
STR_0018        ASCII "read"
STR_001B        ASCII "write"
STR_001E        ASCII " (6800)"
STR_0022        ASCII "DMA"
STR_0024_UNREF  ASCII "incomplete opcode"
STR_002D_UNREF  ASCII "/"
STR_002E_UNREF  ASCII "-"
STR_002F        ASCII "****"
STR_0032        ASCII ","
STR_0033        ASCII "D"
STR_0034        ASCII "A"
STR_0035        ASCII "B"
STR_0036        ASCII "W"
STR_0037        ASCII "L"
STR_0038        ASCII "#"
STR_0039        ASCII "OR"
STR_003B        ASCII "AND"
STR_003D        ASCII "SUB"
STR_003F        ASCII "EOR"
STR_0041        ASCII "ADD"
STR_0043        ASCII "CLR"
STR_0045        ASCII "MOVE"
STR_0048        ASCII "SR"
STR_004A        ASCII "CCR"
STR_004C        ASCII "USP"
STR_004E        ASCII "**"
STR_0050        ASCII "S"
STR_0051        ASCII "]"
STR_0052        ASCII "R"
STR_0053        ASCII "."
STR_0054        ASCII "Illegal"
        SEARCH_LIMIT     34
FMT_0058        FORMAT 3,BIN,3
FMT_005A        FORMAT 3,DEC,1
FMT_005C_UNREF  FORMAT 5,DEC,2
FMT_005E        FORMAT 4,HEX,1
FMT_0060        FORMAT 3,HEX,1
FMT_0062        FORMAT 8,HEX,2
FMT_0064        FORMAT 5,HEX,2
FMT_0066        FORMAT 16,HEX,4
FMT_0068_UNREF  FORMAT 20,HEX,5
FMT_006A        FORMAT 24,HEX,6
FMT_006C        FORMAT 32,HEX,8
        LABEL_TITLE      "68010 Mnemonic"
        BASE_TITLE       "      hex"
        DEFAULT_WIDTH    31
        MAPPED_WIDTH     41
        ENHANCED_WIDTH   41

ENTRY_POINT
    SET VAR_0058,0
    LOAD CONST_0062
    STORE VAR_005E
    CASE_OF TASK
        GOTO LABEL_0032
        GOTO LABEL_0032
        GOTO LABEL_0032
        GOTO LABEL_000E
        GOTO LABEL_0012
        GOTO LABEL_0012
    CASE_END
    OUTPUT STR_0054    * "Illegal"
    OUTPUT " Task Request"
    ABORT

LABEL_000E
    LOAD ID_CODE
    IF 7,0 = 0000000F0H THEN SET VAR_0058,1

LABEL_0012
    SET RETURN_FLAGS,1
    SET VAR_004E,0
    SET VAR_0044,0
    LOAD INPUT_ADDRESS
    STORE VAR_0056
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_04AB
    LOAD CONST_0066
    STORE QUALIFY_MASK
    LOAD 32
    STORE QUALIFY_VALUE
    IF VAR_0058 = 1 THEN GOTO LABEL_0029
    IF TASK = 3 THEN GOTO LABEL_0029
    LOAD CONST_0068
    STORE QUALIFY_MASK
    LOAD 16
    STORE QUALIFY_VALUE
    GOTO LABEL_0029

LABEL_0029
    LOAD INPUT_TAG
    IF 17,16 <> 0 THEN GOTO LABEL_007F
    LOAD INPUT_STATUS
    AND QUALIFY_MASK
    IF 7,0 = QUALIFY_VALUE THEN GOTO LABEL_0033

LABEL_0032
    SET RETURN_FLAGS,0

LABEL_0033
    POSITION ABS,3
    LOAD INPUT_DATA
    OUTPUT ACCUMULATOR,FMT_0066    * 16,HEX,4
    POSITION REL,1
    LOAD INPUT_TAG
    IF 1,0 <> 1 THEN GOTO LABEL_003D
    OUTPUT "unused prefetch"
    RETURN

LABEL_003D
    LOAD VAR_0058
    CASE_OF 0,0
        GOTO LABEL_0042
        GOTO LABEL_007E
    CASE_END

LABEL_0042
    LOAD INPUT_STATUS
    IF TASK = 3 THEN GOTO LABEL_0056
    AND 00000007CH
    ROTATE LEFT,1
    STORE VAR_0050
    LOAD INPUT_STATUS
    AND 3
    INCLUSIVE_OR VAR_0050
    STORE VAR_0050
    LOAD INITIAL_ADDRESS
    COMPLEMENT
    AND 1
    ROTATE LEFT,2
    INCLUSIVE_OR VAR_0050
    STORE INPUT_STATUS
    LOAD 00000FFFFH
    STORE VAR_005E
    LOAD INPUT_STATUS

LABEL_0056
    IF 7,7 = 0 THEN GOTO LABEL_005B
    OUTPUT STR_0022    * "DMA"
    RETURN

LABEL_005B
    SET VAR_004C,0
    CASE_OF 6,4
        CALL LABEL_04D5
        OUTPUT STR_000C    * "user data"
        OUTPUT STR_0011    * "user program"
        CALL LABEL_04D5
        CALL LABEL_04D5
        OUTPUT STR_0000    * "supr data"
        OUTPUT STR_0005    * "supr program"
        CALL LABEL_04DC
    CASE_END
    IF VAR_004C = 1 THEN GOTO LABEL_006E
    POSITION REL,1
    CASE_OF 0,0
        OUTPUT STR_0018    * "read"
        OUTPUT STR_001B    * "write"
    CASE_END

LABEL_006E
    CASE_OF 3,3
        NOP
        OUTPUT STR_001E    * " (6800)"
    CASE_END
    CASE_OF 2,0
        RETURN
        RETURN
        POSITION ABS,3
        POSITION ABS,3
        RETURN
        RETURN
        POSITION ABS,5
        POSITION ABS,5
    CASE_END
    OUTPUT "xx"
    RETURN

LABEL_007E
    SET VAR_004C,0

LABEL_007F
    LOAD INPUT_TAG
    IF 1,0 = 2 THEN GOTO LABEL_0032
    IF 1,0 = 1 THEN GOTO LABEL_0032
    LOAD INPUT_STATUS
    AND QUALIFY_MASK
    IF 7,0 <> QUALIFY_VALUE THEN GOTO LABEL_0032
    LOAD INPUT_DATA
    LOAD INPUT_DATA
    CASE_OF 15,12
        GOTO LABEL_009F
        GOTO LABEL_0127
        GOTO LABEL_0127
        GOTO LABEL_0127
        GOTO LABEL_013D
        GOTO LABEL_026A
        GOTO LABEL_0292
        GOTO LABEL_02B8
        GOTO LABEL_030A
        GOTO LABEL_02C3
        GOTO LABEL_037B
        GOTO LABEL_02EB
        GOTO LABEL_030A
        GOTO LABEL_02C3
        GOTO LABEL_0357
        GOTO LABEL_037B
    CASE_END

LABEL_009F
    IF 8,8 = 1 THEN GOTO LABEL_00E1
    CASE_OF 11,9
        OUTPUT STR_0039    * "OR"
        OUTPUT STR_003B    * "AND"
        OUTPUT STR_003D    * "SUB"
        OUTPUT STR_0041    * "ADD"
        GOTO LABEL_0111
        OUTPUT STR_003F    * "EOR"
        OUTPUT "CMP"
        GOTO LABEL_00C4
    CASE_END
    OUTPUT "I"
    CALL LABEL_0473
    CALL LABEL_0437
    OUTPUT STR_0032    * ","
    LOAD INITIAL_DATA
    CASE_OF 11,9
        SET VAR_004E,1
        SET VAR_004E,1
        SET VAR_004E,0
        SET VAR_004E,0
        NOP
        SET VAR_004E,1
        SET VAR_004E,0
        NOP
    CASE_END
    CALL LABEL_037F
    IF VAR_004E = 0 THEN RETURN
    LOAD INITIAL_DATA
    IF 5,0 <> 60 THEN RETURN
    RETURN

LABEL_00C4
    OUTPUT STR_0045    * "MOVE"
    OUTPUT STR_0050    * "S"
    CALL LABEL_0473
    CALL LABEL_0458
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_04B2
    LOAD INPUT_DATA
    STORE VAR_005A
    CASE_OF 11,11
        CALL LABEL_037F
        CALL LABEL_00D8
    CASE_END
    OUTPUT STR_0032    * ","
    LOAD VAR_005A
    CASE_OF 11,11
        CALL LABEL_00D8
        CALL LABEL_037F
    CASE_END
    RETURN

LABEL_00D8
    LOAD VAR_005A
    CASE_OF 15,15
        OUTPUT STR_0033    * "D"
        OUTPUT STR_0034    * "A"
    CASE_END
    AND 000007000H
    ROTATE RIGHT,12
    OUTPUT ACCUMULATOR,FMT_005A    * 3,DEC,1
    RETURN

LABEL_00E1
    IF 5,3 = 1 THEN GOTO LABEL_00FA
    CALL LABEL_00E9
    POSITION ABS,9
    CALL LABEL_04B8
    OUTPUT STR_0032    * ","
    GOTO LABEL_037F

LABEL_00E9
    OUTPUT STR_0035    * "B"
    CASE_OF 7,6
        OUTPUT "TST"
        OUTPUT "CHG"
        OUTPUT STR_0043    * "CLR"
        OUTPUT "SET"
    CASE_END
    OUTPUT STR_0053    * "."
    IF 5,3 = 0 THEN GOTO LABEL_00F7
    OUTPUT STR_0035    * "B"
    SET VAR_003A,0
    RETURN

LABEL_00F7
    OUTPUT STR_0037    * "L"
    SET VAR_003A,2
    RETURN

LABEL_00FA
    OUTPUT STR_0045    * "MOVE"
    OUTPUT "P."
    CASE_OF 6,6
        OUTPUT STR_0036    * "W"
        OUTPUT STR_0037    * "L"
    CASE_END
    CASE_OF 6,6
        SET VAR_003A,1
        SET VAR_003A,2
    CASE_END
    SET VAR_0038,5
    POSITION ABS,9
    CASE_OF 7,7
        CALL LABEL_038E
        CALL LABEL_04B8
    CASE_END
    LOAD INITIAL_DATA
    OUTPUT STR_0032    * ","
    CASE_OF 7,7
        CALL LABEL_04B8
        CALL LABEL_038E
    CASE_END
    RETURN

LABEL_0111
    CALL LABEL_00E9
    POSITION ABS,9
    OUTPUT STR_0038    * "#"
    CALL LABEL_0458
    IF INPUT_ERROR = 0 THEN GOTO LABEL_011E
    LOAD VAR_003A
    CASE_OF 1,1
        OUTPUT "*"
        OUTPUT STR_004E    * "**"
    CASE_END
    GOTO LABEL_0125

LABEL_011E
    LOAD INPUT_DATA
    CASE_OF VAR_003A
        OUTPUT ACCUMULATOR,FMT_0060    * 3,HEX,1
        NOP
        OUTPUT ACCUMULATOR,FMT_0064    * 5,HEX,2
        NOP
    CASE_END

LABEL_0125
    OUTPUT STR_0032    * ","
    GOTO LABEL_037F

LABEL_0127
    OUTPUT STR_0045    * "MOVE"
    IF 8,6 = 1 THEN OUTPUT STR_0034    * "A"
    OUTPUT STR_0053    * "."
    CASE_OF 13,12
        NOP
        OUTPUT STR_0035    * "B"
        OUTPUT STR_0037    * "L"
        OUTPUT STR_0036    * "W"
    CASE_END
    CASE_OF 13,12
        NOP
        SET VAR_003A,0
        SET VAR_003A,2
        SET VAR_003A,1
    CASE_END
    POSITION ABS,9
    CALL LABEL_037F
    OUTPUT STR_0032    * ","
    LOAD INITIAL_DATA
    GOTO LABEL_0381

LABEL_013D
    IF 8,7 = 2 THEN GOTO LABEL_04AD
    IF 8,8 = 1 THEN GOTO LABEL_0163
    IF 11,11 = 0 THEN GOTO LABEL_0170
    CASE_OF 10,9
        GOTO LABEL_014D
        GOTO LABEL_01DB
        GOTO LABEL_01E4
        GOTO LABEL_01E8
    CASE_END
    RETURN

LABEL_014D
    CASE_OF 7,6
        OUTPUT "NBCD.B"
        GOTO LABEL_0155
        GOTO LABEL_01B0
        GOTO LABEL_01B0
    CASE_END
    POSITION ABS,9
    GOTO LABEL_037F

LABEL_0155
    SET VAR_0050,0
    IF 5,3 <> 0 THEN SET VAR_0050,1
    CASE_OF VAR_0050
        OUTPUT "SWAP.W"
        OUTPUT "PEA.L"
    CASE_END
    POSITION ABS,9
    CASE_OF VAR_0050
        CALL LABEL_04BA
        CALL LABEL_037F
    CASE_END
    RETURN

LABEL_0163
    CASE_OF 6,6
        OUTPUT "CHK.W"
        OUTPUT "LEA.L"
    CASE_END
    POSITION ABS,9
    CALL LABEL_037F
    LOAD INITIAL_DATA
    OUTPUT STR_0032    * ","
    CASE_OF 6,6
        CALL LABEL_04B8
        CALL LABEL_04B4
    CASE_END
    RETURN

LABEL_0170
    IF 7,6 = 3 THEN GOTO LABEL_017C
    CASE_OF 10,9
        OUTPUT "NEGX"
        OUTPUT STR_0043    * "CLR"
        OUTPUT "NEG"
        OUTPUT "NOT"
    CASE_END
    CALL LABEL_0473
    CALL LABEL_037F
    RETURN

LABEL_017C
    OUTPUT STR_0045    * "MOVE"
    OUTPUT STR_0053    * "."
    CASE_OF 10,9
        OUTPUT STR_0036    * "W"
        OUTPUT STR_0036    * "W"
        OUTPUT STR_0035    * "B"
        OUTPUT STR_0036    * "W"
    CASE_END
    CASE_OF 10,9
        SET VAR_003A,1
        SET VAR_003A,1
        SET VAR_003A,0
        SET VAR_003A,1
    CASE_END
    POSITION ABS,9
    CASE_OF 10,9
        OUTPUT STR_0048    * "SR"
        OUTPUT STR_004A    * "CCR"
        CALL LABEL_037F
        CALL LABEL_037F
    CASE_END
    OUTPUT STR_0032    * ","
    LOAD INITIAL_DATA
    CASE_OF 10,9
        CALL LABEL_037F
        CALL LABEL_037F
        OUTPUT STR_004A    * "CCR"
        OUTPUT STR_0048    * "SR"
    CASE_END
    LOAD INITIAL_DATA
    IF 10,9 < 2 THEN RETURN
    CASE_OF 5,3
        SET VAR_0054,1
        NOP
        SET VAR_0054,1
        SET VAR_0054,1
        SET VAR_0054,1
        SET VAR_0054,2
        SET VAR_0054,2
        CALL LABEL_01A8
    CASE_END
    GOTO LABEL_04C8

LABEL_01A8
    CASE_OF 2,0
        SET VAR_0054,2
        SET VAR_0054,3
        SET VAR_0054,2
        SET VAR_0054,2
        SET VAR_0054,2
    CASE_END
    RETURN

LABEL_01B0
    IF 5,3 = 0 THEN GOTO LABEL_01D4

LABEL_01B3
    OUTPUT STR_0045    * "MOVE"
    OUTPUT "M."
    CASE_OF 6,6
        OUTPUT STR_0036    * "W"
        OUTPUT STR_0037    * "L"
    CASE_END
    CALL LABEL_0458
    STORE VAR_0052
    IF INPUT_ERROR <> 0 THEN SET VAR_0052,0
    POSITION ABS,9
    LOAD INITIAL_DATA
    CASE_OF 10,10
        CALL LABEL_01CB
        CALL LABEL_037F
    CASE_END
    OUTPUT STR_0032    * ","
    LOAD INITIAL_DATA
    CASE_OF 10,10
        CALL LABEL_037F
        CALL LABEL_01CB
    CASE_END
    RETURN

LABEL_01CB
    OUTPUT "rm="
    LOAD VAR_0052
    IF 15,0 <> 0 THEN GOTO LABEL_01D2
    OUTPUT STR_002F    * "****"
    RETURN

LABEL_01D2
    OUTPUT ACCUMULATOR,FMT_0066    * 16,HEX,4
    RETURN

LABEL_01D4
    OUTPUT "EXT."
    CASE_OF 6,6
        OUTPUT STR_0036    * "W"
        OUTPUT STR_0037    * "L"
    CASE_END
    POSITION ABS,9
    GOTO LABEL_04BA

LABEL_01DB
    IF 7,6 <> 3 THEN GOTO LABEL_01E0
    OUTPUT "TAS.B"
    GOTO LABEL_01E2

LABEL_01E0
    OUTPUT "TST"
    CALL LABEL_0473

LABEL_01E2
    POSITION ABS,9
    GOTO LABEL_037F

LABEL_01E4
    IF 7,7 = 0 THEN GOTO LABEL_04AD
    GOTO LABEL_01B3

LABEL_01E8
    CASE_OF 8,6
        GOTO LABEL_04AD
        GOTO LABEL_01F0
        OUTPUT "JSR"
        OUTPUT "JMP"
    CASE_END
    POSITION ABS,9
    GOTO LABEL_037F

LABEL_01F0
    CASE_OF 5,4
        GOTO LABEL_0246
        GOTO LABEL_024D
        GOTO LABEL_025D
        NOP
    CASE_END
    IF 5,3 = 7 THEN GOTO LABEL_0218
    CASE_OF 2,0
        OUTPUT "RESET"
        OUTPUT "NOP"
        OUTPUT "STOP"
        OUTPUT "RTE"
        GOTO LABEL_020E
        OUTPUT "RTS"
        OUTPUT "TRAPV"
        OUTPUT "RTR"
    CASE_END
    IF 2,0 <> 2 THEN GOTO LABEL_023E
    POSITION ABS,9
    OUTPUT STR_0038    * "#"
    CALL LABEL_0458
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_04B0
    OUTPUT ACCUMULATOR,FMT_0066    * 16,HEX,4
    RETURN

LABEL_020E
    OUTPUT "RTD"
    POSITION ABS,9
    OUTPUT STR_0038    * "#"
    CALL LABEL_0458
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_04B0
    LOAD INPUT_DATA
    OUTPUT ACCUMULATOR,FMT_0066    * 16,HEX,4
    RETURN

LABEL_0218
    OUTPUT STR_0045    * "MOVE"
    OUTPUT "C.L"
    POSITION ABS,9
    CALL LABEL_0458
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_04B2
    LOAD INPUT_DATA
    STORE VAR_005A
    LOAD INITIAL_DATA
    CASE_OF 0,0
        CALL LABEL_022D
        CALL LABEL_00D8
    CASE_END
    OUTPUT STR_0032    * ","
    LOAD INITIAL_DATA
    CASE_OF 0,0
        CALL LABEL_00D8
        CALL LABEL_022D
    CASE_END
    RETURN

LABEL_022D
    LOAD VAR_005A
    IF 11,0 = 0 THEN OUTPUT "SFC"
    IF 11,0 = 1 THEN OUTPUT "DFC"
    IF 11,0 = 000000800H THEN OUTPUT STR_004C    * "USP"
    IF 11,0 = 000000801H THEN OUTPUT "VBR"
    IF 10,1 <> 0 THEN GOTO LABEL_04A7
    RETURN

LABEL_023E
    IF 2,0 < 3 THEN RETURN
    IF 2,0 = 6 THEN RETURN
    SET VAR_0054,1
    GOTO LABEL_04C8

LABEL_0246
    OUTPUT "TRAP"
    POSITION ABS,9
    OUTPUT STR_0038    * "#"
    AND 15
    OUTPUT ACCUMULATOR,FMT_005E    * 4,HEX,1
    SET VAR_0054,1
    GOTO LABEL_04C8

LABEL_024D
    CASE_OF 3,3
        OUTPUT "LINK"
        OUTPUT "UNLK"
    CASE_END
    POSITION ABS,9
    CALL LABEL_04B6
    IF 3,3 = 1 THEN RETURN
    OUTPUT ",#"
    CALL LABEL_0458
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_04B0
    OUTPUT ACCUMULATOR,FMT_0066    * 16,HEX,4
    RETURN

LABEL_025D
    OUTPUT STR_0045    * "MOVE"
    OUTPUT ".L"
    POSITION ABS,9
    CASE_OF 3,3
        CALL LABEL_04B6
        OUTPUT STR_004C    * "USP"
    CASE_END
    OUTPUT STR_0032    * ","
    CASE_OF 3,3
        OUTPUT STR_004C    * "USP"
        CALL LABEL_04B6
    CASE_END
    RETURN

LABEL_026A
    IF 7,6 <> 3 THEN GOTO LABEL_028A
    IF 5,3 = 1 THEN GOTO LABEL_0272
    OUTPUT STR_0050    * "S"
    GOTO LABEL_0273

LABEL_0272
    OUTPUT "DB"

LABEL_0273
    CALL LABEL_048A
    IF 5,3 = 1 THEN GOTO LABEL_027A
    OUTPUT ".B"
    POSITION ABS,9
    GOTO LABEL_037F

LABEL_027A
    POSITION ABS,9
    OUTPUT STR_0033    * "D"
    OUTPUT ACCUMULATOR,FMT_005A    * 3,DEC,1
    OUTPUT STR_0032    * ","
    CALL LABEL_0458
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_04B0
    IF 15,15 = 1 THEN INCLUSIVE_OR 000FF0000H
    ADD INPUT_ADDRESS

LABEL_0286
    AND CONST_0064
    IF_NOT_MAPPED THEN OUTPUT ACCUMULATOR,FMT_006A    * 24,HEX,6
    RETURN

LABEL_028A
    CASE_OF 8,8
        OUTPUT "ADDQ"
        OUTPUT "SUBQ"
    CASE_END
    CALL LABEL_0473
    CALL LABEL_0480
    OUTPUT STR_0032    * ","
    GOTO LABEL_037F

LABEL_0292
    OUTPUT STR_0035    * "B"
    CALL LABEL_048A
    IF 7,0 <> 0 THEN GOTO LABEL_02A2
    OUTPUT ".W"
    SET VAR_003A,1
    CALL LABEL_0458
    IF 15,15 = 1 THEN INCLUSIVE_OR 000FF0000H
    IF INPUT_ERROR = 0 THEN GOTO LABEL_02A8
    OUTPUT "********"
    RETURN

LABEL_02A2
    OUTPUT ".B"
    SET VAR_003A,0
    AND CONST_0060
    IF 7,7 = 1 THEN INCLUSIVE_OR 000FFFF00H

LABEL_02A8
    POSITION ABS,9
    ADD INPUT_ADDRESS
    AND CONST_0064
    IF VAR_003A = 0 THEN ADD 2
    CALL LABEL_0286
    LOAD INITIAL_DATA
    IF 15,9 <> 48 THEN RETURN
    IF 7,0 = 0 THEN RETURN
    SET VAR_0054,1
    GOTO LABEL_04C8

LABEL_02B8
    OUTPUT STR_0045    * "MOVE"
    OUTPUT "Q.L"
    POSITION ABS,9
    AND CONST_0060
    IF 7,7 = 1 THEN INCLUSIVE_OR 0FFFFFF00H
    OUTPUT STR_0038    * "#"
    OUTPUT ACCUMULATOR,FMT_006C    * 32,HEX,8
    OUTPUT STR_0032    * ","
    GOTO LABEL_04B8

LABEL_02C3
    CASE_OF 14,14
        OUTPUT STR_003D    * "SUB"
        OUTPUT STR_0041    * "ADD"
    CASE_END
    IF 7,6 = 3 THEN GOTO LABEL_02DD
    IF 8,8 <> 1 THEN GOTO LABEL_02D0
    IF 5,4 = 0 THEN GOTO LABEL_04BE

LABEL_02D0
    CALL LABEL_0473
    POSITION ABS,9
    CASE_OF 8,8
        CALL LABEL_037F
        CALL LABEL_04B8
    CASE_END
    OUTPUT STR_0032    * ","
    LOAD INITIAL_DATA
    CASE_OF 8,8
        CALL LABEL_04B8
        CALL LABEL_037F
    CASE_END
    RETURN

LABEL_02DD
    OUTPUT "A."

LABEL_02DE
    CASE_OF 8,8
        OUTPUT STR_0036    * "W"
        OUTPUT STR_0037    * "L"
    CASE_END
    CASE_OF 8,8
        SET VAR_003A,1
        SET VAR_003A,2
    CASE_END
    POSITION ABS,9
    CALL LABEL_037F
    OUTPUT STR_0032    * ","
    LOAD INITIAL_DATA
    GOTO LABEL_04B4

LABEL_02EB
    IF 7,6 = 3 THEN GOTO LABEL_02F6
    IF 8,8 = 1 THEN GOTO LABEL_02F8
    OUTPUT "CMP"
    CALL LABEL_0473
    CALL LABEL_037F
    OUTPUT STR_0032    * ","
    GOTO LABEL_04B8

LABEL_02F6
    OUTPUT "CMPA."
    GOTO LABEL_02DE

LABEL_02F8
    IF 5,3 <> 1 THEN GOTO LABEL_0305
    OUTPUT "CMPM"
    CALL LABEL_0473
    POSITION ABS,9
    OUTPUT "[xx]+,[xx]+"
    POSITION REL,-10
    CALL LABEL_04B6
    POSITION REL,4
    CALL LABEL_04B4
    POSITION REL,2
    RETURN

LABEL_0305
    OUTPUT STR_003F    * "EOR"
    CALL LABEL_0473
    CALL LABEL_04B8
    OUTPUT STR_0032    * ","
    GOTO LABEL_037F

LABEL_030A
    IF 7,6 = 3 THEN GOTO LABEL_031E
    IF 14,14 = 0 THEN GOTO LABEL_0316
    IF 8,4 = 20 THEN GOTO LABEL_033D
    IF 8,4 = 24 THEN GOTO LABEL_033D

LABEL_0316
    IF 8,4 = 16 THEN GOTO LABEL_032B
    CASE_OF 14,14
        OUTPUT STR_0039    * "OR"
        OUTPUT STR_003B    * "AND"
    CASE_END
    GOTO LABEL_02D0

LABEL_031E
    CASE_OF 14,14
        OUTPUT "DIV"
        OUTPUT "MUL"
    CASE_END
    CASE_OF 8,8
        OUTPUT "U"
        OUTPUT STR_0050    * "S"
    CASE_END
    OUTPUT ".W"
    POSITION ABS,9
    CALL LABEL_037F
    OUTPUT STR_0032    * ","
    GOTO LABEL_04B8

LABEL_032B
    CASE_OF 14,14
        OUTPUT STR_0050    * "S"
        OUTPUT STR_0034    * "A"
    CASE_END
    OUTPUT "BCD.B"
    POSITION ABS,9
    IF 3,3 = 0 THEN GOTO LABEL_033A
    OUTPUT "-["
    CALL LABEL_04B6
    OUTPUT "],-["
    CALL LABEL_04B4
    OUTPUT STR_0051    * "]"
    RETURN

LABEL_033A
    CALL LABEL_04BA
    OUTPUT STR_0032    * ","
    GOTO LABEL_04B8

LABEL_033D
    OUTPUT "EXG.L"
    POSITION ABS,9
    IF 7,3 = 8 THEN SET VAR_0050,0
    IF 7,3 = 9 THEN SET VAR_0050,1
    IF 7,3 = 17 THEN SET VAR_0050,2
    CASE_OF VAR_0050
        CALL LABEL_04B8
        CALL LABEL_04B4
        CALL LABEL_04B8
        NOP
    CASE_END
    OUTPUT STR_0032    * ","
    LOAD INITIAL_DATA
    CASE_OF VAR_0050
        CALL LABEL_04BA
        CALL LABEL_04B6
        CALL LABEL_04B6
        NOP
    CASE_END
    RETURN

LABEL_0357
    IF 7,6 = 3 THEN GOTO LABEL_036D
    CASE_OF 4,3
        OUTPUT "AS"
        OUTPUT "LS"
        OUTPUT "ROX"
        OUTPUT "RO"
    CASE_END
    CASE_OF 8,8
        OUTPUT STR_0052    * "R"
        OUTPUT STR_0037    * "L"
    CASE_END
    CALL LABEL_0473
    IF 5,5 = 1 THEN GOTO LABEL_036A
    CALL LABEL_0480
    GOTO LABEL_036B

LABEL_036A
    CALL LABEL_04B8

LABEL_036B
    OUTPUT STR_0032    * ","
    GOTO LABEL_04BA

LABEL_036D
    CASE_OF 10,9
        OUTPUT "AS"
        OUTPUT "LS"
        OUTPUT "ROX"
        OUTPUT "RO"
    CASE_END
    CASE_OF 8,8
        OUTPUT STR_0052    * "R"
        OUTPUT STR_0037    * "L"
    CASE_END
    OUTPUT ".W"
    SET VAR_003A,1
    POSITION ABS,9
    GOTO LABEL_037F

LABEL_037B
    OUTPUT "Unimplemented Instruction:"
    OUTPUT ACCUMULATOR,FMT_0066    * 16,HEX,4
    SET VAR_0054,1
    GOTO LABEL_04C8

LABEL_037F
    SET VAR_0034,1
    GOTO LABEL_0382

LABEL_0381
    SET VAR_0034,0

LABEL_0382
    LOAD INITIAL_DATA
    CASE_OF VAR_0034
        ROTATE RIGHT,6
        ROTATE RIGHT,3
    CASE_END
    AND 7
    STORE VAR_0038
    LOAD INITIAL_DATA
    CASE_OF VAR_0034
        ROTATE RIGHT,9
        NOP
    CASE_END

LABEL_038E
    AND 7
    STORE VAR_0036
    CASE_OF VAR_0038
        OUTPUT STR_0033    * "D"
        OUTPUT STR_0034    * "A"
        OUTPUT "[A"
        OUTPUT "[A"
        OUTPUT "-[A"
        GOTO LABEL_03A8
        GOTO LABEL_03AF
        GOTO LABEL_03D0
    CASE_END
    LOAD VAR_0036
    OUTPUT ACCUMULATOR,FMT_005A    * 3,DEC,1
    LOAD INITIAL_DATA
    CASE_OF VAR_0038
        RETURN
        RETURN
        OUTPUT STR_0051    * "]"
        OUTPUT "]+"
        OUTPUT STR_0051    * "]"
        NOP
        NOP
        NOP
    CASE_END
    RETURN

LABEL_03A8
    CALL LABEL_0452
    OUTPUT "[A"
    LOAD VAR_0036
    OUTPUT ACCUMULATOR,FMT_005A    * 3,DEC,1
    OUTPUT STR_0051    * "]"
    LOAD INITIAL_DATA
    RETURN

LABEL_03AF
    CALL LABEL_0458
    IF INPUT_ERROR = 0 THEN GOTO LABEL_03B8
    OUTPUT "**[A"
    LOAD VAR_0036
    OUTPUT ACCUMULATOR,FMT_005A    * 3,DEC,1
    OUTPUT ",**.*]"
    RETURN

LABEL_03B8
    AND CONST_0060
    OUTPUT ACCUMULATOR,FMT_0062    * 8,HEX,2
    OUTPUT "["
    LOAD INPUT_DATA
    OUTPUT STR_0034    * "A"
    LOAD VAR_0036
    OUTPUT ACCUMULATOR,FMT_005A    * 3,DEC,1
    OUTPUT STR_0032    * ","
    CASE_OF 15,15
        OUTPUT STR_0033    * "D"
        OUTPUT STR_0034    * "A"
    CASE_END
    LOAD INPUT_DATA
    ROTATE RIGHT,12
    OUTPUT ACCUMULATOR,FMT_005A    * 3,DEC,1
    OUTPUT STR_0053    * "."
    LOAD INPUT_DATA
    CASE_OF 11,11
        OUTPUT STR_0036    * "W"
        OUTPUT STR_0037    * "L"
    CASE_END
    OUTPUT STR_0051    * "]"
    LOAD INITIAL_DATA
    RETURN

LABEL_03D0
    CASE_OF VAR_0036
        GOTO LABEL_03D8
        GOTO LABEL_03E2
        GOTO LABEL_0406
        GOTO LABEL_0411
        GOTO LABEL_042D
    CASE_END
    GOTO LABEL_04A7

LABEL_03D8
    CALL LABEL_0458
    IF INPUT_ERROR = 0 THEN GOTO LABEL_03DE
    OUTPUT "******"
    RETURN

LABEL_03DE
    IF 15,15 = 1 THEN INCLUSIVE_OR 000FF0000H
    GOTO LABEL_0286

LABEL_03E2
    CALL LABEL_0458
    STORE VAR_0048
    SET VAR_0046,0
    IF INPUT_ERROR <> 0 THEN SET VAR_0046,1
    CALL LABEL_0458
    STORE VAR_004A
    LOAD VAR_0046
    IF INPUT_ERROR <> 0 THEN INCLUSIVE_OR 2
    STORE VAR_0046
    IF VAR_0046 = 0 THEN GOTO LABEL_0401
    LOAD VAR_0048
    CASE_OF VAR_0046
        NOP
        OUTPUT STR_002F    * "****"
        OUTPUT ACCUMULATOR,FMT_0066    * 16,HEX,4
        OUTPUT STR_002F    * "****"
    CASE_END
    LOAD VAR_004A
    CASE_OF VAR_0046
        NOP
        OUTPUT ACCUMULATOR,FMT_0066    * 16,HEX,4
        OUTPUT STR_002F    * "****"
        OUTPUT STR_002F    * "****"
    CASE_END
    RETURN

LABEL_0401
    LOAD VAR_0048
    AND 0000000FFH
    ROTATE LEFT,16
    INCLUSIVE_OR VAR_004A
    GOTO LABEL_0286

LABEL_0406
    CALL LABEL_0458
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_04B0
    IF 15,15 = 1 THEN INCLUSIVE_OR 000FF0000H
    ADD INPUT_ADDRESS
    CALL LABEL_0286
    OUTPUT "[PC]"
    RETURN

LABEL_0411
    CALL LABEL_0458
    IF INPUT_ERROR = 0 THEN GOTO LABEL_0417
    OUTPUT "**[PC,**.*]"
    RETURN

LABEL_0417
    AND 0000000FFH
    IF 7,7 = 1 THEN INCLUSIVE_OR 000FFFF00H
    ADD INPUT_ADDRESS
    CALL LABEL_0286
    LOAD INPUT_DATA
    OUTPUT "[PC,"
    CASE_OF 15,15
        OUTPUT STR_0033    * "D"
        OUTPUT STR_0034    * "A"
    CASE_END
    ROTATE RIGHT,12
    OUTPUT ACCUMULATOR,FMT_005A    * 3,DEC,1
    OUTPUT STR_0053    * "."
    LOAD INPUT_DATA
    CASE_OF 11,11
        OUTPUT STR_0036    * "W"
        OUTPUT STR_0037    * "L"
    CASE_END
    OUTPUT STR_0051    * "]"
    RETURN

LABEL_042D
    IF VAR_004E = 0 THEN GOTO LABEL_0437
    CASE_OF VAR_003A
        OUTPUT STR_004A    * "CCR"
        OUTPUT STR_0048    * "SR"
        GOTO LABEL_04A7
        GOTO LABEL_04A7
    CASE_END
    RETURN

LABEL_0437
    OUTPUT STR_0038    * "#"
    CALL LABEL_0458
    IF INPUT_ERROR = 0 THEN GOTO LABEL_0443
    CASE_OF VAR_003A
        OUTPUT STR_004E    * "**"
        OUTPUT STR_002F    * "****"
        OUTPUT STR_002F    * "****"
        GOTO LABEL_04AD
    CASE_END
    GOTO LABEL_0449

LABEL_0443
    CASE_OF VAR_003A
        OUTPUT ACCUMULATOR,FMT_0062    * 8,HEX,2
        OUTPUT ACCUMULATOR,FMT_0066    * 16,HEX,4
        OUTPUT ACCUMULATOR,FMT_0066    * 16,HEX,4
        GOTO LABEL_04AD
    CASE_END

LABEL_0449
    IF VAR_003A <> 2 THEN RETURN
    CALL LABEL_0458
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_04B0
    OUTPUT ACCUMULATOR,FMT_0066    * 16,HEX,4
    RETURN

LABEL_0452
    CALL LABEL_0458
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_04B0
    OUTPUT ACCUMULATOR,FMT_0066    * 16,HEX,4
    RETURN

LABEL_0458
    INCREMENT VAR_0056
    INCREMENT VAR_0056
    CALL LABEL_0461
    CALL LABEL_0463
    IF INPUT_ERROR = 0 THEN TAG_WITH 2
    LOAD INPUT_DATA
    RETURN

LABEL_0461
    INPUT ABS,VAR_0056,QUALIFIED
    RETURN

LABEL_0463
    IF TASK = 3 THEN RETURN
    IF VAR_0044 = 1 THEN SET INPUT_ERROR,1
    IF INPUT_ERROR <> 0 THEN RETURN
    LOAD INPUT_TAG
    IF 17,16 <> 3 THEN RETURN
    SET VAR_0044,1
    SET INPUT_ERROR,1
    RETURN

LABEL_0473
    OUTPUT STR_0053    * "."
    CASE_OF 7,6
        OUTPUT STR_0035    * "B"
        OUTPUT STR_0036    * "W"
        OUTPUT STR_0037    * "L"
        GOTO LABEL_04A7
    CASE_END
    ROTATE RIGHT,6
    AND 3
    STORE VAR_003A
    LOAD INITIAL_DATA
    POSITION ABS,9
    RETURN

LABEL_0480
    OUTPUT STR_0038    * "#"
    IF 11,9 <> 0 THEN GOTO LABEL_0486
    OUTPUT "8"
    RETURN

LABEL_0486
    ROTATE RIGHT,9
    OUTPUT ACCUMULATOR,FMT_005A    * 3,DEC,1
    LOAD INITIAL_DATA
    RETURN

LABEL_048A
    CASE_OF 11,8
        GOTO LABEL_049D
        GOTO LABEL_04A2
        OUTPUT "HI"
        OUTPUT "LS"
        OUTPUT "CC"
        OUTPUT "CS"
        OUTPUT "NE"
        OUTPUT "EQ"
        OUTPUT "VC"
        OUTPUT "VS"
        OUTPUT "PL"
        OUTPUT "MI"
        OUTPUT "GE"
        OUTPUT "LT"
        OUTPUT "GT"
        OUTPUT "LE"
    CASE_END
    RETURN

LABEL_049D
    CASE_OF 12,12
        OUTPUT "RA"
        OUTPUT "T"
    CASE_END
    RETURN

LABEL_04A2
    CASE_OF 12,12
        OUTPUT STR_0048    * "SR"
        OUTPUT "F"
    CASE_END
    RETURN

LABEL_04A7
    POSITION ABS,9
    OUTPUT STR_0054    * "Illegal"
    OUTPUT " Operand    "
    ABORT

LABEL_04AB
    OUTPUT "Data Error"
    ABORT

LABEL_04AD
    OUTPUT STR_0054    * "Illegal"
    OUTPUT " Opcode"
    ABORT

LABEL_04B0
    OUTPUT STR_002F    * "****"
    RETURN

LABEL_04B2
    OUTPUT "incomplete opcode"
    ABORT

LABEL_04B4
    LOAD INITIAL_DATA
    ROTATE RIGHT,9

LABEL_04B6
    OUTPUT STR_0034    * "A"
    GOTO LABEL_04BB

LABEL_04B8
    LOAD INITIAL_DATA
    ROTATE RIGHT,9

LABEL_04BA
    OUTPUT STR_0033    * "D"

LABEL_04BB
    OUTPUT ACCUMULATOR,FMT_005A    * 3,DEC,1
    LOAD INITIAL_DATA
    RETURN

LABEL_04BE
    OUTPUT "X"
    CALL LABEL_0473
    CASE_OF 3,3
        SET VAR_0038,0
        SET VAR_0038,4
    CASE_END
    CALL LABEL_038E
    ROTATE RIGHT,9
    OUTPUT STR_0032    * ","
    GOTO LABEL_038E

LABEL_04C8
    INPUT REL,VAR_0054,QUALIFIED
    CALL LABEL_0463
    IF INPUT_ERROR <> 0 THEN RETURN
    LOAD VAR_0056
    ADD 2
    SUBTRACT INPUT_ADDRESS
    IF 31,0 <> 0 THEN RETURN
    TAG_WITH 1
    RETURN

LABEL_04D5
    OUTPUT "unknown ("
    AND 000000070H
    ROTATE RIGHT,4
    OUTPUT ACCUMULATOR,FMT_0058    * 3,BIN,3
    OUTPUT ")"
    LOAD INPUT_STATUS
    RETURN

LABEL_04DC
    LOAD INPUT_ADDRESS
    SET VAR_004C,1
    IF 23,4 <> VAR_005E THEN GOTO LABEL_04E4
    OUTPUT "int_ack"
    LOAD INPUT_STATUS
    RETURN

LABEL_04E4
    SET VAR_004C,0
    OUTPUT "cpu space"
    LOAD INPUT_STATUS
    RETURN
