"IAL"

*
* Original Source File Name: iz80_i.s
*

CONST_0034      CONSTANT 00000FFDFH
CONST_0036      CONSTANT 00000007EH
VAR_0038        VARIABLE 000000000H
VAR_003A        VARIABLE 000000000H
VAR_003C        VARIABLE 000000000H
VAR_003E        VARIABLE 000000000H
VAR_0040        VARIABLE 000000000H
VAR_0042        VARIABLE 000000000H
VAR_0044        VARIABLE 000000000H
VAR_0046        VARIABLE 000000000H
VAR_0048        VARIABLE 000000000H
VAR_004A        VARIABLE 000000000H
VAR_004C        VARIABLE 000000000H
VAR_004E        VARIABLE 000000000H
VAR_0050        VARIABLE 000000000H
FMT_0000        FORMAT 8,HEX,2
FMT_0002        FORMAT 16,HEX,4
        LABEL_TITLE      "Z80 Mnemonic"
        BASE_TITLE       "    hex"
        DEFAULT_WIDTH    22
        MAPPED_WIDTH     24

ENTRY_POINT
    LOAD 14
    STORE VAR_004E
    LOAD 6
    STORE VAR_004A
    LOAD ID_CODE
    AND CONST_0036
    STORE VAR_004C
    IF TASK = 4 THEN GOTO LABEL_0014
    IF TASK = 5 THEN GOTO LABEL_0014
    IF VAR_004C = 0 THEN GOTO LABEL_0014
    LOAD 7
    STORE VAR_004A
    LOAD 15
    STORE VAR_004E

LABEL_0014
    SET VAR_003C,0
    SET VAR_003E,0
    SET VAR_0042,0
    SET VAR_0044,0
    SET RETURN_FLAGS,1
    IF TASK = 3 THEN GOTO LABEL_0024
    IF TASK = 4 THEN GOTO LABEL_0024
    IF TASK = 5 THEN GOTO LABEL_0024
    OUTPUT "Illegal Task Request"
    ABORT

LABEL_0024
    LOAD INPUT_TAG
    IF 1,0 = 2 THEN GOTO LABEL_002B
    IF INPUT_STATUS = VAR_004A THEN GOTO LABEL_0069

LABEL_002B
    SET RETURN_FLAGS,0
    POSITION ABS,3
    LOAD INITIAL_DATA
    OUTPUT ACCUMULATOR,FMT_0000    * 8,HEX,2
    POSITION REL,1
    IF VAR_004C = 0 THEN GOTO LABEL_0051
    IF TASK = 4 THEN GOTO LABEL_0051
    IF TASK = 5 THEN GOTO LABEL_0051
    CASE_OF INPUT_STATUS
        OUTPUT "unknown"
        OUTPUT "unknown"
        OUTPUT "unknown"
        OUTPUT "unknown"
        OUTPUT "unknown"
        OUTPUT "interrupt ack"
        OUTPUT "unknown"
        OUTPUT "opcode fetch"
        OUTPUT "unknown"
        OUTPUT "unknown"
        OUTPUT "unknown"
        OUTPUT "refresh"
        OUTPUT "i/o write"
        OUTPUT "i/o read"
        OUTPUT "memory write"
        OUTPUT "memory read"
    CASE_END
    IF INPUT_STATUS <> 11 THEN RETURN
    POSITION ABS,3
    OUTPUT "xx"
    RETURN

LABEL_0051
    CASE_OF INPUT_STATUS
        OUTPUT "unknown"
        OUTPUT "unknown"
        OUTPUT "unknown"
        OUTPUT "unknown"
        OUTPUT "interrupt ack"
        OUTPUT "unknown"
        OUTPUT "opcode fetch"
        OUTPUT "unknown"
        OUTPUT "unknown"
        OUTPUT "unknown"
        OUTPUT "refresh"
        OUTPUT "unknown"
        OUTPUT "i/o read"
        OUTPUT "i/o write"
        OUTPUT "memory read"
        OUTPUT "memory write"
    CASE_END
    IF INPUT_STATUS <> 10 THEN RETURN
    POSITION ABS,3
    OUTPUT "xx"
    RETURN

LABEL_0069
    LOAD INPUT_TAG
    IF 1,0 = 0 THEN CALL LABEL_034D
    IF 1,0 = 2 THEN GOTO LABEL_002B
    TAG_WITH 1
    LOAD INPUT_DATA
    CASE_OF 7,6
        GOTO LABEL_0078
        GOTO LABEL_0082
        GOTO LABEL_008D
        GOTO LABEL_0093
    CASE_END

LABEL_0078
    CASE_OF 2,0
        GOTO LABEL_009D
        GOTO LABEL_00B1
        GOTO LABEL_00BC
        GOTO LABEL_00D8
        GOTO LABEL_00DF
        GOTO LABEL_00DF
        GOTO LABEL_00E6
        GOTO LABEL_00EC
    CASE_END

LABEL_0082
    IF 7,0 <> 000000076H THEN GOTO LABEL_0087
    OUTPUT "HALT"
    RETURN

LABEL_0087
    OUTPUT "LD"
    POSITION ABS,6
    CALL LABEL_02B1
    OUTPUT ","
    CALL LABEL_02B4
    RETURN

LABEL_008D
    CALL LABEL_0342
    CASE_OF 6,6
        CALL LABEL_02B4
        CALL LABEL_02E9
    CASE_END
    RETURN

LABEL_0093
    CASE_OF 2,0
        GOTO LABEL_00F7
        GOTO LABEL_0104
        GOTO LABEL_00F7
        GOTO LABEL_0112
        GOTO LABEL_00F7
        GOTO LABEL_0137
        GOTO LABEL_008D
        GOTO LABEL_012A
    CASE_END

LABEL_009D
    CASE_OF 5,3
        OUTPUT "NOP"
        OUTPUT "EX   AF,AF'"
        OUTPUT "DJNZ"
    CASE_END
    IF 5,3 < 2 THEN RETURN
    IF 5,3 >= 3 THEN OUTPUT "JR"
    POSITION ABS,6
    IF 5,5 <> 1 THEN GOTO LABEL_00AF
    AND CONST_0034
    CALL LABEL_02DE
    OUTPUT ","

LABEL_00AF
    CALL LABEL_038A
    RETURN

LABEL_00B1
    CASE_OF 3,3
        OUTPUT "LD   "
        OUTPUT "ADD  HL,"
    CASE_END
    CALL LABEL_02CC
    IF 3,3 = 1 THEN RETURN
    OUTPUT ","
    CALL LABEL_02F7
    RETURN

LABEL_00BC
    OUTPUT "LD"
    POSITION ABS,6
    IF 3,3 = 0 THEN OUTPUT "["
    CASE_OF 5,3
        OUTPUT "BC],A"
        OUTPUT "A,[BC]"
        OUTPUT "DE],A"
        OUTPUT "A,[DE]"
        CALL LABEL_02F7
        OUTPUT "HL,["
        CALL LABEL_02F7
        OUTPUT "A,["
    CASE_END
    IF 5,5 = 0 THEN RETURN
    CASE_OF 4,3
        OUTPUT "],HL"
        CALL LABEL_02F7
        OUTPUT "],A"
        CALL LABEL_02F7
    CASE_END
    IF 3,3 = 1 THEN OUTPUT "]"
    RETURN

LABEL_00D8
    CASE_OF 3,3
        OUTPUT "INC"
        OUTPUT "DEC"
    CASE_END
    POSITION ABS,6
    CALL LABEL_02CC
    RETURN

LABEL_00DF
    CASE_OF 0,0
        OUTPUT "INC"
        OUTPUT "DEC"
    CASE_END
    POSITION ABS,6
    CALL LABEL_02B1
    RETURN

LABEL_00E6
    OUTPUT "LD"
    POSITION ABS,6
    CALL LABEL_02B1
    OUTPUT ","
    CALL LABEL_02E9
    RETURN

LABEL_00EC
    CASE_OF 5,3
        OUTPUT "RLCA"
        OUTPUT "RRCA"
        OUTPUT "RLA"
        OUTPUT "RRA"
        OUTPUT "DAA"
        OUTPUT "CPL"
        OUTPUT "SCF"
        OUTPUT "CCF"
    CASE_END
    RETURN

LABEL_00F7
    CASE_OF 2,1
        OUTPUT "RET"
        OUTPUT "JP"
        OUTPUT "CALL"
    CASE_END
    POSITION ABS,6
    CALL LABEL_02DE
    IF 2,1 = 0 THEN RETURN
    OUTPUT ","
    CALL LABEL_02F7
    RETURN

LABEL_0104
    IF 3,3 = 0 THEN OUTPUT "POP  "
    CASE_OF 5,3
        OUTPUT "BC"
        OUTPUT "RET"
        OUTPUT "DE"
        OUTPUT "EXX"
        OUTPUT "HL"
        OUTPUT "JP   [HL]"
        OUTPUT "AF"
        OUTPUT "LD   SP,HL"
    CASE_END
    RETURN

LABEL_0112
    CASE_OF 5,3
        OUTPUT "JP   "
        GOTO LABEL_0148
        OUTPUT "OUT  ["
        OUTPUT "IN   A,["
        OUTPUT "EX   [SP],HL"
        OUTPUT "EX   DE,HL"
        OUTPUT "DI"
        OUTPUT "EI"
    CASE_END
    CASE_OF 5,3
        CALL LABEL_02F7
        NOP
        CALL LABEL_02E9
        CALL LABEL_02E9
    CASE_END
    LOAD INITIAL_DATA
    CASE_OF 5,3
        NOP
        NOP
        OUTPUT "],A"
        OUTPUT "]"
    CASE_END
    RETURN

LABEL_012A
    OUTPUT "RST"
    POSITION ABS,6
    CASE_OF 5,3
        OUTPUT "0"
        OUTPUT "8"
        OUTPUT "10"
        OUTPUT "18"
        OUTPUT "20"
        OUTPUT "28"
        OUTPUT "30"
        OUTPUT "38"
    CASE_END
    RETURN

LABEL_0137
    IF 3,3 = 0 THEN OUTPUT "PUSH "
    CASE_OF 5,3
        OUTPUT "BC"
        OUTPUT "CALL "
        OUTPUT "DE"
        GOTO LABEL_0148
        OUTPUT "HL"
        GOTO LABEL_0148
        OUTPUT "AF"
        GOTO LABEL_0148
    CASE_END
    IF 5,3 = 1 THEN CALL LABEL_02F7
    RETURN

LABEL_0148
    IF VAR_003C <> 0 THEN STORE VAR_003E
    IF VAR_003C = 0 THEN STORE VAR_003C
    CASE_OF 5,4
        GOTO LABEL_0154
        GOTO LABEL_0172
        GOTO LABEL_017C
        GOTO LABEL_0172
    CASE_END

LABEL_0154
    IF VAR_003C = 0000000DDH THEN GOTO LABEL_0288
    IF VAR_003C = 0000000FDH THEN GOTO LABEL_0288
    CALL LABEL_0324
    TAG_WITH 2
    LOAD INPUT_DATA
    CASE_OF 7,6
        GOTO LABEL_0163
        GOTO LABEL_0167
        GOTO LABEL_0167
        GOTO LABEL_0167
    CASE_END

LABEL_0163
    CALL LABEL_02D3
    POSITION ABS,6
    CALL LABEL_02B4
    RETURN

LABEL_0167
    CASE_OF 7,6
        NOP
        OUTPUT "BIT"
        OUTPUT "RES"
        OUTPUT "SET"
    CASE_END
    POSITION ABS,6
    CALL LABEL_02C1
    OUTPUT ","
    CALL LABEL_02B4
    RETURN

LABEL_0172
    CALL LABEL_0324
    TAG_WITH 2
    LOAD INPUT_DATA
    CASE_OF 7,6
        GOTO LABEL_01F4
        GOTO LABEL_0246
        GOTO LABEL_025F
        GOTO LABEL_0265
    CASE_END
    RETURN

LABEL_017C
    CALL LABEL_0324
    TAG_WITH 2
    LOAD INPUT_DATA
    CASE_OF 7,6
        GOTO LABEL_033C
        GOTO LABEL_0185
        GOTO LABEL_01DA
        GOTO LABEL_033C
    CASE_END

LABEL_0185
    CASE_OF 2,0
        GOTO LABEL_018F
        GOTO LABEL_018F
        GOTO LABEL_019B
        GOTO LABEL_01A3
        GOTO LABEL_01B3
        GOTO LABEL_01B8
        GOTO LABEL_01C1
        GOTO LABEL_01CF
    CASE_END

LABEL_018F
    IF 5,3 = 6 THEN GOTO LABEL_033C
    CASE_OF 0,0
        OUTPUT "IN   "
        OUTPUT "OUT  [C],"
    CASE_END
    CALL LABEL_02B1
    IF 0,0 = 0 THEN OUTPUT ",[C]"
    RETURN

LABEL_019B
    CASE_OF 3,3
        OUTPUT "SBC"
        OUTPUT "ADC"
    CASE_END
    POSITION ABS,6
    OUTPUT "HL,"
    CALL LABEL_02CC
    RETURN

LABEL_01A3
    IF 5,4 = 2 THEN GOTO LABEL_033C
    OUTPUT "LD"
    POSITION ABS,6
    SET VAR_0042,3
    CASE_OF 3,3
        CALL LABEL_02F7
        CALL LABEL_02CC
    CASE_END
    OUTPUT ","
    CASE_OF 3,3
        CALL LABEL_02CC
        CALL LABEL_02F7
    CASE_END
    RETURN

LABEL_01B3
    IF 5,3 <> 0 THEN GOTO LABEL_033C
    OUTPUT "NEG"
    RETURN

LABEL_01B8
    IF 5,4 <> 0 THEN GOTO LABEL_033C
    OUTPUT "RET"
    CASE_OF 3,3
        OUTPUT "N"
        OUTPUT "I"
    CASE_END
    RETURN

LABEL_01C1
    IF 5,3 > 3 THEN GOTO LABEL_033C
    IF 5,3 = 1 THEN GOTO LABEL_033C
    OUTPUT "IM "
    CASE_OF 4,3
        OUTPUT "0"
        NOP
        OUTPUT "1"
        OUTPUT "2"
    CASE_END
    RETURN

LABEL_01CF
    CASE_OF 5,3
        OUTPUT "LD   I,A"
        OUTPUT "LD   R,A"
        OUTPUT "LD   A,I"
        OUTPUT "LD   A,R"
        OUTPUT "RRD"
        OUTPUT "RLD"
        GOTO LABEL_033C
        GOTO LABEL_033C
    CASE_END
    RETURN

LABEL_01DA
    IF 5,5 = 0 THEN GOTO LABEL_033C
    IF 2,2 = 1 THEN GOTO LABEL_033C
    CASE_OF 1,0
        OUTPUT "LD"
        OUTPUT "CP"
        OUTPUT "IN"
        OUTPUT "O"
    CASE_END
    IF 1,0 <> 3 THEN GOTO LABEL_01ED
    CASE_OF 4,4
        OUTPUT "UT"
        OUTPUT "T"
    CASE_END

LABEL_01ED
    CASE_OF 4,3
        OUTPUT "I"
        OUTPUT "D"
        OUTPUT "IR"
        OUTPUT "DR"
    CASE_END
    RETURN

LABEL_01F4
    CASE_OF 2,0
        GOTO LABEL_033C
        GOTO LABEL_01FE
        GOTO LABEL_0219
        GOTO LABEL_0229
        GOTO LABEL_0233
        GOTO LABEL_0233
        GOTO LABEL_0233
        GOTO LABEL_033C
    CASE_END

LABEL_01FE
    IF 3,3 = 1 THEN OUTPUT "ADD  "
    IF 5,3 = 4 THEN OUTPUT "LD   "
    CASE_OF 5,3
        GOTO LABEL_033C
        OUTPUT "xx,BC"
        GOTO LABEL_033C
        OUTPUT "xx,DE"
        OUTPUT "xx,"
        NOP
        GOTO LABEL_033C
        OUTPUT "xx,SP"
    CASE_END
    IF 5,3 = 4 THEN CALL LABEL_02F7
    POSITION ABS,6
    CALL LABEL_032E
    IF 5,3 <> 5 THEN RETURN
    OUTPUT ","
    CALL LABEL_032E
    RETURN

LABEL_0219
    IF 5,4 <> 2 THEN GOTO LABEL_033C
    OUTPUT "LD"
    POSITION ABS,6
    SET VAR_0042,3
    CASE_OF 3,3
        CALL LABEL_02F7
        CALL LABEL_032E
    CASE_END
    OUTPUT ","
    CASE_OF 3,3
        CALL LABEL_032E
        CALL LABEL_02F7
    CASE_END
    RETURN

LABEL_0229
    IF 5,4 <> 2 THEN GOTO LABEL_033C
    CASE_OF 3,3
        OUTPUT "INC"
        OUTPUT "DEC"
    CASE_END
    POSITION ABS,6
    CALL LABEL_032E
    RETURN

LABEL_0233
    IF 5,3 <> 6 THEN GOTO LABEL_033C
    CASE_OF 1,0
        OUTPUT "INC"
        OUTPUT "DEC"
        OUTPUT "LD"
        GOTO LABEL_033C
    CASE_END
    POSITION ABS,6
    STORE VAR_0040
    CALL LABEL_0336
    LOAD VAR_0040
    IF 2,0 <> 6 THEN RETURN
    OUTPUT ","
    CALL LABEL_02E9
    RETURN

LABEL_0246
    OUTPUT "LD"
    POSITION ABS,6
    IF 2,0 = 6 THEN GOTO LABEL_024F
    IF 5,3 = 6 THEN GOTO LABEL_0256
    GOTO LABEL_033C

LABEL_024F
    IF 5,3 = 6 THEN GOTO LABEL_033C
    CALL LABEL_02B1
    OUTPUT ","
    CALL LABEL_0336
    RETURN

LABEL_0256
    IF 2,0 = 6 THEN GOTO LABEL_033C
    STORE VAR_0040
    CALL LABEL_0336
    LOAD VAR_0040
    OUTPUT ","
    CALL LABEL_02B4
    RETURN

LABEL_025F
    IF 2,0 <> 6 THEN GOTO LABEL_033C
    CALL LABEL_0342
    CALL LABEL_0336
    RETURN

LABEL_0265
    IF 7,0 = 0000000CBH THEN GOTO LABEL_0148
    IF 0,0 = 0 THEN GOTO LABEL_033C
    IF 2,0 = 7 THEN GOTO LABEL_033C
    IF 2,0 = 1 THEN GOTO LABEL_027A
    IF 5,3 <> 4 THEN GOTO LABEL_033C
    CASE_OF 1,1
        OUTPUT "PUSH "
        OUTPUT "EX   [SP],"
    CASE_END
    CALL LABEL_032E
    RETURN

LABEL_027A
    IF 5,5 = 0 THEN GOTO LABEL_033C
    CASE_OF 4,3
        OUTPUT "POP  "
        OUTPUT "JP   ["
        GOTO LABEL_033C
        OUTPUT "LD   SP,"
    CASE_END
    CALL LABEL_032E
    IF 5,3 = 5 THEN OUTPUT "]"
    RETURN

LABEL_0288
    INCREMENT INPUT_ADDRESS
    INCREMENT INPUT_ADDRESS
    LOAD 15
    STORE QUALIFY_MASK
    LOAD VAR_004E
    STORE QUALIFY_VALUE
    INPUT ABS,INPUT_ADDRESS,QUALIFIED
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_033F
    LOAD INPUT_DATA
    IF 2,0 <> 6 THEN GOTO LABEL_033C
    CASE_OF 7,6
        GOTO LABEL_029C
        GOTO LABEL_02A3
        GOTO LABEL_02A3
        GOTO LABEL_02A3
    CASE_END

LABEL_029C
    CALL LABEL_02D3
    POSITION ABS,6
    LOAD INPUT_ADDRESS
    SUBTRACT 2
    STORE INPUT_ADDRESS
    CALL LABEL_0336
    RETURN

LABEL_02A3
    CASE_OF 7,6
        NOP
        OUTPUT "BIT"
        OUTPUT "RES"
        OUTPUT "SET"
    CASE_END
    POSITION ABS,6
    CALL LABEL_02C1
    OUTPUT ","
    LOAD INPUT_ADDRESS
    SUBTRACT 2
    STORE INPUT_ADDRESS
    CALL LABEL_0336
    RETURN

LABEL_02B1
    STORE VAR_0040
    ROTATE RIGHT,3
    GOTO LABEL_02B5

LABEL_02B4
    STORE VAR_0040

LABEL_02B5
    CASE_OF 2,0
        OUTPUT "B"
        OUTPUT "C"
        OUTPUT "D"
        OUTPUT "E"
        OUTPUT "H"
        OUTPUT "L"
        OUTPUT "[HL]"
        OUTPUT "A"
    CASE_END
    LOAD VAR_0040
    RETURN

LABEL_02C1
    CASE_OF 5,3
        OUTPUT "0"
        OUTPUT "1"
        OUTPUT "2"
        OUTPUT "3"
        OUTPUT "4"
        OUTPUT "5"
        OUTPUT "6"
        OUTPUT "7"
    CASE_END
    RETURN

LABEL_02CC
    CASE_OF 5,4
        OUTPUT "BC"
        OUTPUT "DE"
        OUTPUT "HL"
        OUTPUT "SP"
    CASE_END
    RETURN

LABEL_02D3
    CASE_OF 5,3
        OUTPUT "RLC"
        OUTPUT "RRC"
        OUTPUT "RL"
        OUTPUT "RR"
        OUTPUT "SLA"
        OUTPUT "SRA"
        GOTO LABEL_033C
        OUTPUT "SRL"
    CASE_END
    RETURN

LABEL_02DE
    CASE_OF 5,3
        OUTPUT "NZ"
        OUTPUT "Z"
        OUTPUT "NC"
        OUTPUT "C"
        OUTPUT "PO"
        OUTPUT "PE"
        OUTPUT "P"
        OUTPUT "M"
    CASE_END
    RETURN

LABEL_02E9
    CALL LABEL_031D
    IF INPUT_STATUS <> VAR_004A THEN GOTO LABEL_02EF
    OUTPUT "**"
    RETURN

LABEL_02EF
    LOAD INPUT_DATA
    IF INPUT_ERROR = 0 THEN OUTPUT ACCUMULATOR,FMT_0000    * 8,HEX,2
    IF INPUT_ERROR <> 0 THEN OUTPUT "**"
    RETURN

LABEL_02F7
    SET VAR_0038,1
    GOTO LABEL_02FA
    SET VAR_0038,0

LABEL_02FA
    STORE VAR_0040
    LOAD VAR_0042
    IF 1,1 = 1 THEN OUTPUT "["
    CALL LABEL_031D
    IF INPUT_ERROR = 0 THEN GOTO LABEL_0307
    SET VAR_0038,0
    POSITION REL,2
    OUTPUT "**"
    POSITION REL,-4

LABEL_0307
    LOAD INPUT_DATA
    STORE VAR_003A
    CALL LABEL_031D
    IF INPUT_ERROR = 0 THEN GOTO LABEL_030F
    SET VAR_0038,0
    OUTPUT "**"

LABEL_030F
    IF VAR_0038 = 0 THEN GOTO LABEL_0317
    LOAD INPUT_DATA
    ROTATE LEFT,8
    INCLUSIVE_OR VAR_003A
    IF_NOT_MAPPED THEN OUTPUT ACCUMULATOR,FMT_0002    * 16,HEX,4

LABEL_0317
    LOAD VAR_0042
    IF 0,0 = 1 THEN OUTPUT "]"
    LOAD VAR_0040
    RETURN

LABEL_031D
    INCREMENT INPUT_ADDRESS
    LOAD VAR_004E
    STORE QUALIFY_VALUE
    LOAD 15
    STORE QUALIFY_MASK
    INPUT ABS,INPUT_ADDRESS,QUALIFIED
    RETURN

LABEL_0324
    INCREMENT INPUT_ADDRESS
    LOAD 15
    STORE QUALIFY_MASK
    LOAD VAR_004A
    STORE QUALIFY_VALUE
    INPUT ABS,INPUT_ADDRESS,QUALIFIED
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_033F
    RETURN

LABEL_032E
    STORE VAR_0040
    LOAD VAR_003C
    CASE_OF 5,5
        OUTPUT "IX"
        OUTPUT "IY"
    CASE_END
    LOAD VAR_0040
    RETURN

LABEL_0336
    OUTPUT "["
    CALL LABEL_032E
    OUTPUT "+"
    CALL LABEL_02E9
    OUTPUT "]"
    RETURN

LABEL_033C
    POSITION ABS,1
    OUTPUT "Illegal Opcode                         "
    ABORT

LABEL_033F
    POSITION ABS,1
    OUTPUT "Partial Instruction                    "
    ABORT

LABEL_0342
    CASE_OF 5,3
        OUTPUT "ADD  A,"
        OUTPUT "ADC  A,"
        OUTPUT "SUB  "
        OUTPUT "SBC  A,"
        OUTPUT "AND  "
        OUTPUT "XOR  "
        OUTPUT "OR   "
        OUTPUT "CP   "
    CASE_END
    RETURN

LABEL_034D
    SET VAR_0048,-1
    LOAD INPUT_ADDRESS
    SUBTRACT 1
    STORE VAR_0050
    LOAD 15
    STORE QUALIFY_MASK
    LOAD VAR_004A
    STORE QUALIFY_VALUE
    INPUT REL,VAR_0048,QUALIFIED
    IF INPUT_ADDRESS <> VAR_0050 THEN GOTO LABEL_0385
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_0385
    LOAD INPUT_TAG
    IF 1,0 <> 0 THEN GOTO LABEL_0385
    IF INPUT_DATA = 0000000CBH THEN GOTO LABEL_036D
    IF INPUT_DATA = 0000000DDH THEN GOTO LABEL_036D
    IF INPUT_DATA = 0000000EDH THEN GOTO LABEL_036D
    IF INPUT_DATA = 0000000FDH THEN GOTO LABEL_036D
    GOTO LABEL_0385

LABEL_036D
    SET VAR_0046,2
    IF INPUT_DATA <> 0000000CBH THEN GOTO LABEL_0386

LABEL_0371
    DECREMENT VAR_0048
    DECREMENT VAR_0050
    INPUT REL,VAR_0048,QUALIFIED
    IF INPUT_ADDRESS <> VAR_0050 THEN GOTO LABEL_0386
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_0386
    LOAD INPUT_TAG
    IF 1,0 <> 0 THEN GOTO LABEL_0386
    IF INPUT_DATA <> 0000000CBH THEN GOTO LABEL_0386
    LOAD VAR_0046
    EXCLUSIVE_OR 2
    STORE VAR_0046
    GOTO LABEL_0371

LABEL_0385
    SET VAR_0046,0

LABEL_0386
    INPUT REL,0
    TAG_WITH VAR_0046
    LOAD INPUT_TAG
    RETURN

LABEL_038A
    CALL LABEL_031D
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_039A
    IF INPUT_STATUS <> VAR_004E THEN GOTO LABEL_039A
    LOAD INPUT_DATA
    IF 7,7 = 1 THEN INCLUSIVE_OR 00000FF00H
    ADD INPUT_ADDRESS
    ADD 1
    IF_NOT_MAPPED THEN OUTPUT ACCUMULATOR,FMT_0002    * 16,HEX,4
    RETURN

LABEL_039A
    OUTPUT "****"
    RETURN
