"IAL"

*
* Original Source File Name: i68000_p
*

VAR_0034        VARIABLE 000000000H
VAR_0036        VARIABLE 000000000H
VAR_0038        VARIABLE 000000000H
VAR_003A        VARIABLE 000000000H
VAR_003C_UNREF  VARIABLE 000000000H
VAR_003E_UNREF  VARIABLE 000000000H
VAR_0040_UNREF  VARIABLE 000000000H
VAR_0042_UNREF  VARIABLE 000000000H
VAR_0044        VARIABLE 000000000H
VAR_0046        VARIABLE 000000000H
VAR_0048        VARIABLE 000000000H
VAR_004A        VARIABLE 000000000H
VAR_004C_UNREF  VARIABLE 000000000H
VAR_004E        VARIABLE 000000000H
VAR_0050        VARIABLE 000000000H
VAR_0052        VARIABLE 000000000H
VAR_0054        VARIABLE 000000000H
VAR_0056        VARIABLE 000000000H
VAR_0058        VARIABLE 000000000H
VAR_005A_UNREF  VARIABLE 000000000H
VAR_005C_UNREF  VARIABLE 000000000H
CONST_005E      CONSTANT 0000000FFH
VAR_0060_UNREF  VARIABLE 0000FFFFFH
CONST_0062      CONSTANT 000FFFFFFH
VAR_0064_UNREF  VARIABLE 0000000BBH
VAR_0066_UNREF  VARIABLE 00000005FH
VAR_0068_UNREF  VARIABLE 0000000BFH
VAR_006A_UNREF  VARIABLE 0000000A9H
STR_0000_UNREF  ASCII "supr data"
STR_0005_UNREF  ASCII "supr program"
STR_000C_UNREF  ASCII "user data"
STR_0011_UNREF  ASCII "user program"
STR_0018_UNREF  ASCII "interrupt ack"
STR_001F        ASCII "read"
STR_0022        ASCII "write"
STR_0025_UNREF  ASCII " (6800)"
STR_0029        ASCII "DMA"
STR_002B_UNREF  ASCII "incomplete opcode"
STR_0034_UNREF  ASCII "/"
STR_0035_UNREF  ASCII "-"
STR_0036        ASCII "****"
STR_0039        ASCII ","
STR_003A        ASCII "D"
STR_003B        ASCII "A"
STR_003C        ASCII "B"
STR_003D        ASCII "W"
STR_003E        ASCII "L"
STR_003F        ASCII "#"
STR_0040        ASCII "OR"
STR_0042        ASCII "AND"
STR_0044        ASCII "SUB"
STR_0046        ASCII "EOR"
STR_0048        ASCII "ADD"
STR_004A        ASCII "CLR"
STR_004C        ASCII "MOVE"
STR_004F        ASCII "SR"
STR_0051        ASCII "CCR"
STR_0053        ASCII "USP"
STR_0055        ASCII "**"
STR_0057        ASCII "S"
STR_0058        ASCII "]"
STR_0059        ASCII "R"
STR_005A        ASCII "."
STR_005B        ASCII "Illegal"
        SEARCH_LIMIT     34
FMT_005F        FORMAT 3,BIN,3
FMT_0061        FORMAT 3,DEC,1
FMT_0063_UNREF  FORMAT 5,DEC,2
FMT_0065        FORMAT 4,HEX,1
FMT_0067        FORMAT 3,HEX,1
FMT_0069        FORMAT 8,HEX,2
FMT_006B        FORMAT 5,HEX,2
FMT_006D        FORMAT 16,HEX,4
FMT_006F_UNREF  FORMAT 20,HEX,5
FMT_0071        FORMAT 24,HEX,6
FMT_0073        FORMAT 32,HEX,8
        LABEL_TITLE      "68000 Mnemonic"
        BASE_TITLE       "      hex"
        DEFAULT_WIDTH    33
        MAPPED_WIDTH     41
        ENHANCED_WIDTH   41

ENTRY_POINT
    SET VAR_0058,0
    CASE_OF TASK
        GOTO LABEL_0026
        GOTO LABEL_0026
        GOTO LABEL_0026
        GOTO LABEL_000C
        GOTO LABEL_0010
        GOTO LABEL_0010
    CASE_END
    OUTPUT STR_005B    * "Illegal"
    OUTPUT " Task Request"
    ABORT

LABEL_000C
    LOAD ID_CODE
    IF 7,0 = 0000000F0H THEN SET VAR_0058,1

LABEL_0010
    SET RETURN_FLAGS,1
    SET VAR_004E,0
    SET VAR_0044,0
    LOAD INPUT_ADDRESS
    STORE VAR_0056
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_0422
    LOAD 7
    STORE QUALIFY_MASK
    LOAD 5
    STORE QUALIFY_VALUE
    GOTO LABEL_001D

LABEL_001D
    LOAD INPUT_TAG
    IF 17,16 <> 0 THEN GOTO LABEL_0041
    LOAD INPUT_STATUS
    AND QUALIFY_MASK
    IF 7,0 = QUALIFY_VALUE THEN GOTO LABEL_0027

LABEL_0026
    SET RETURN_FLAGS,0

LABEL_0027
    POSITION ABS,3
    LOAD INPUT_DATA
    OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
    POSITION REL,1
    LOAD INPUT_TAG
    IF 1,0 <> 1 THEN GOTO LABEL_0031
    OUTPUT "unused prefetch"
    RETURN

LABEL_0031
    LOAD INPUT_STATUS
    IF 2,2 = 1 THEN GOTO LABEL_0037
    OUTPUT STR_0029    * "DMA"
    RETURN

LABEL_0037
    CASE_OF 1,1
        OUTPUT "program"
        OUTPUT "data"
    CASE_END
    POSITION REL,1
    CASE_OF 0,0
        OUTPUT STR_0022    * "write"
        OUTPUT STR_001F    * "read"
    CASE_END
    RETURN

LABEL_0041
    LOAD INPUT_TAG
    IF 1,0 = 2 THEN GOTO LABEL_0026
    IF 1,0 = 1 THEN GOTO LABEL_0026
    LOAD INPUT_STATUS
    AND QUALIFY_MASK
    IF 7,0 <> QUALIFY_VALUE THEN GOTO LABEL_0026
    LOAD INPUT_DATA
    LOAD INPUT_DATA
    CASE_OF 15,12
        GOTO LABEL_0061
        GOTO LABEL_00CE
        GOTO LABEL_00CE
        GOTO LABEL_00CE
        GOTO LABEL_00E4
        GOTO LABEL_01E1
        GOTO LABEL_0209
        GOTO LABEL_022F
        GOTO LABEL_0281
        GOTO LABEL_023A
        GOTO LABEL_02F2
        GOTO LABEL_0262
        GOTO LABEL_0281
        GOTO LABEL_023A
        GOTO LABEL_02CE
        GOTO LABEL_02F2
    CASE_END

LABEL_0061
    IF 8,8 = 1 THEN GOTO LABEL_0088
    CASE_OF 11,9
        OUTPUT STR_0040    * "OR"
        OUTPUT STR_0042    * "AND"
        OUTPUT STR_0044    * "SUB"
        OUTPUT STR_0048    * "ADD"
        GOTO LABEL_00B8
        OUTPUT STR_0046    * "EOR"
        OUTPUT "CMP"
        GOTO LABEL_0424
    CASE_END
    OUTPUT "I"
    CALL LABEL_03EA
    CALL LABEL_03AE
    OUTPUT STR_0039    * ","
    LOAD INITIAL_DATA
    CASE_OF 11,9
        SET VAR_004E,1
        SET VAR_004E,1
        SET VAR_004E,0
        SET VAR_004E,0
        NOP
        SET VAR_004E,1
        SET VAR_004E,0
        NOP
    CASE_END
    CALL LABEL_02F6
    IF VAR_004E = 0 THEN RETURN
    LOAD INITIAL_DATA
    IF 5,0 <> 60 THEN RETURN
    SET VAR_0054,2
    CALL LABEL_043D
    RETURN

LABEL_0088
    IF 5,3 = 1 THEN GOTO LABEL_00A1
    CALL LABEL_0090
    POSITION ABS,9
    CALL LABEL_042D
    OUTPUT STR_0039    * ","
    GOTO LABEL_02F6

LABEL_0090
    OUTPUT STR_003C    * "B"
    CASE_OF 7,6
        OUTPUT "TST"
        OUTPUT "CHG"
        OUTPUT STR_004A    * "CLR"
        OUTPUT "SET"
    CASE_END
    OUTPUT STR_005A    * "."
    IF 5,3 = 0 THEN GOTO LABEL_009E
    OUTPUT STR_003C    * "B"
    SET VAR_003A,0
    RETURN

LABEL_009E
    OUTPUT STR_003E    * "L"
    SET VAR_003A,2
    RETURN

LABEL_00A1
    OUTPUT STR_004C    * "MOVE"
    OUTPUT "P."
    CASE_OF 6,6
        OUTPUT STR_003D    * "W"
        OUTPUT STR_003E    * "L"
    CASE_END
    CASE_OF 6,6
        SET VAR_003A,1
        SET VAR_003A,2
    CASE_END
    SET VAR_0038,5
    POSITION ABS,9
    CASE_OF 7,7
        CALL LABEL_0305
        CALL LABEL_042D
    CASE_END
    LOAD INITIAL_DATA
    OUTPUT STR_0039    * ","
    CASE_OF 7,7
        CALL LABEL_042D
        CALL LABEL_0305
    CASE_END
    RETURN

LABEL_00B8
    CALL LABEL_0090
    POSITION ABS,9
    OUTPUT STR_003F    * "#"
    CALL LABEL_03CF
    IF INPUT_ERROR = 0 THEN GOTO LABEL_00C5
    LOAD VAR_003A
    CASE_OF 1,1
        OUTPUT "*"
        OUTPUT STR_0055    * "**"
    CASE_END
    GOTO LABEL_00CC

LABEL_00C5
    LOAD INPUT_DATA
    CASE_OF VAR_003A
        OUTPUT ACCUMULATOR,FMT_0067    * 3,HEX,1
        NOP
        OUTPUT ACCUMULATOR,FMT_006B    * 5,HEX,2
        NOP
    CASE_END

LABEL_00CC
    OUTPUT STR_0039    * ","
    GOTO LABEL_02F6

LABEL_00CE
    OUTPUT STR_004C    * "MOVE"
    IF 8,6 = 1 THEN OUTPUT STR_003B    * "A"
    OUTPUT STR_005A    * "."
    CASE_OF 13,12
        NOP
        OUTPUT STR_003C    * "B"
        OUTPUT STR_003E    * "L"
        OUTPUT STR_003D    * "W"
    CASE_END
    CASE_OF 13,12
        NOP
        SET VAR_003A,0
        SET VAR_003A,2
        SET VAR_003A,1
    CASE_END
    POSITION ABS,9
    CALL LABEL_02F6
    OUTPUT STR_0039    * ","
    LOAD INITIAL_DATA
    GOTO LABEL_02F8

LABEL_00E4
    IF 8,7 = 2 THEN GOTO LABEL_0424
    IF 8,8 = 1 THEN GOTO LABEL_010A
    IF 11,11 = 0 THEN GOTO LABEL_0117
    CASE_OF 10,9
        GOTO LABEL_00F4
        GOTO LABEL_0182
        GOTO LABEL_018B
        GOTO LABEL_018F
    CASE_END
    RETURN

LABEL_00F4
    CASE_OF 7,6
        OUTPUT "NBCD.B"
        GOTO LABEL_00FC
        GOTO LABEL_0157
        GOTO LABEL_0157
    CASE_END
    POSITION ABS,9
    GOTO LABEL_02F6

LABEL_00FC
    SET VAR_0050,0
    IF 5,3 <> 0 THEN SET VAR_0050,1
    CASE_OF VAR_0050
        OUTPUT "SWAP.W"
        OUTPUT "PEA.L"
    CASE_END
    POSITION ABS,9
    CASE_OF VAR_0050
        CALL LABEL_042F
        CALL LABEL_02F6
    CASE_END
    RETURN

LABEL_010A
    CASE_OF 6,6
        OUTPUT "CHK.W"
        OUTPUT "LEA.L"
    CASE_END
    POSITION ABS,9
    CALL LABEL_02F6
    LOAD INITIAL_DATA
    OUTPUT STR_0039    * ","
    CASE_OF 6,6
        CALL LABEL_042D
        CALL LABEL_0429
    CASE_END
    RETURN

LABEL_0117
    IF 7,6 = 3 THEN GOTO LABEL_0123
    CASE_OF 10,9
        OUTPUT "NEGX"
        OUTPUT STR_004A    * "CLR"
        OUTPUT "NEG"
        OUTPUT "NOT"
    CASE_END
    CALL LABEL_03EA
    CALL LABEL_02F6
    RETURN

LABEL_0123
    OUTPUT STR_004C    * "MOVE"
    OUTPUT STR_005A    * "."
    CASE_OF 10,9
        OUTPUT STR_003D    * "W"
        GOTO LABEL_0424
        OUTPUT STR_003C    * "B"
        OUTPUT STR_003D    * "W"
    CASE_END
    CASE_OF 10,9
        SET VAR_003A,1
        SET VAR_003A,1
        SET VAR_003A,0
        SET VAR_003A,1
    CASE_END
    POSITION ABS,9
    CASE_OF 10,9
        OUTPUT STR_004F    * "SR"
        OUTPUT STR_0051    * "CCR"
        CALL LABEL_02F6
        CALL LABEL_02F6
    CASE_END
    OUTPUT STR_0039    * ","
    LOAD INITIAL_DATA
    CASE_OF 10,9
        CALL LABEL_02F6
        CALL LABEL_02F6
        OUTPUT STR_0051    * "CCR"
        OUTPUT STR_004F    * "SR"
    CASE_END
    LOAD INITIAL_DATA
    IF 10,9 < 2 THEN RETURN
    CASE_OF 5,3
        SET VAR_0054,1
        NOP
        SET VAR_0054,1
        SET VAR_0054,1
        SET VAR_0054,1
        SET VAR_0054,2
        SET VAR_0054,2
        CALL LABEL_014F
    CASE_END
    GOTO LABEL_043D

LABEL_014F
    CASE_OF 2,0
        SET VAR_0054,2
        SET VAR_0054,3
        SET VAR_0054,2
        SET VAR_0054,2
        SET VAR_0054,2
    CASE_END
    RETURN

LABEL_0157
    IF 5,3 = 0 THEN GOTO LABEL_017B

LABEL_015A
    OUTPUT STR_004C    * "MOVE"
    OUTPUT "M."
    CASE_OF 6,6
        OUTPUT STR_003D    * "W"
        OUTPUT STR_003E    * "L"
    CASE_END
    CALL LABEL_03CF
    STORE VAR_0052
    IF INPUT_ERROR <> 0 THEN SET VAR_0052,0
    POSITION ABS,9
    LOAD INITIAL_DATA
    CASE_OF 10,10
        CALL LABEL_0172
        CALL LABEL_02F6
    CASE_END
    OUTPUT STR_0039    * ","
    LOAD INITIAL_DATA
    CASE_OF 10,10
        CALL LABEL_02F6
        CALL LABEL_0172
    CASE_END
    RETURN

LABEL_0172
    OUTPUT "rm="
    LOAD VAR_0052
    IF 15,0 <> 0 THEN GOTO LABEL_0179
    OUTPUT STR_0036    * "****"
    RETURN

LABEL_0179
    OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
    RETURN

LABEL_017B
    OUTPUT "EXT."
    CASE_OF 6,6
        OUTPUT STR_003D    * "W"
        OUTPUT STR_003E    * "L"
    CASE_END
    POSITION ABS,9
    GOTO LABEL_042F

LABEL_0182
    IF 7,6 <> 3 THEN GOTO LABEL_0187
    OUTPUT "TAS.B"
    GOTO LABEL_0189

LABEL_0187
    OUTPUT "TST"
    CALL LABEL_03EA

LABEL_0189
    POSITION ABS,9
    GOTO LABEL_02F6

LABEL_018B
    IF 7,7 = 0 THEN GOTO LABEL_0424
    GOTO LABEL_015A

LABEL_018F
    CASE_OF 8,6
        GOTO LABEL_0424
        GOTO LABEL_0197
        OUTPUT "JSR"
        OUTPUT "JMP"
    CASE_END
    POSITION ABS,9
    GOTO LABEL_02F6

LABEL_0197
    CASE_OF 5,4
        GOTO LABEL_01BD
        GOTO LABEL_01C4
        GOTO LABEL_01D4
        NOP
    CASE_END
    IF 5,3 = 7 THEN GOTO LABEL_0424
    CASE_OF 2,0
        OUTPUT "RESET"
        OUTPUT "NOP"
        OUTPUT "STOP"
        OUTPUT "RTE"
        GOTO LABEL_0424
        OUTPUT "RTS"
        OUTPUT "TRAPV"
        OUTPUT "RTR"
    CASE_END
    IF 2,0 <> 2 THEN GOTO LABEL_01B5
    POSITION ABS,9
    OUTPUT STR_003F    * "#"
    CALL LABEL_03CF
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_0427
    OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
    RETURN

LABEL_01B5
    IF 2,0 < 3 THEN RETURN
    IF 2,0 = 6 THEN RETURN
    SET VAR_0054,1
    GOTO LABEL_043D

LABEL_01BD
    OUTPUT "TRAP"
    POSITION ABS,9
    OUTPUT STR_003F    * "#"
    AND 15
    OUTPUT ACCUMULATOR,FMT_0065    * 4,HEX,1
    SET VAR_0054,1
    GOTO LABEL_043D

LABEL_01C4
    CASE_OF 3,3
        OUTPUT "LINK"
        OUTPUT "UNLK"
    CASE_END
    POSITION ABS,9
    CALL LABEL_042B
    IF 3,3 = 1 THEN RETURN
    OUTPUT ",#"
    CALL LABEL_03CF
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_0427
    OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
    RETURN

LABEL_01D4
    OUTPUT STR_004C    * "MOVE"
    OUTPUT ".L"
    POSITION ABS,9
    CASE_OF 3,3
        CALL LABEL_042B
        OUTPUT STR_0053    * "USP"
    CASE_END
    OUTPUT STR_0039    * ","
    CASE_OF 3,3
        OUTPUT STR_0053    * "USP"
        CALL LABEL_042B
    CASE_END
    RETURN

LABEL_01E1
    IF 7,6 <> 3 THEN GOTO LABEL_0201
    IF 5,3 = 1 THEN GOTO LABEL_01E9
    OUTPUT STR_0057    * "S"
    GOTO LABEL_01EA

LABEL_01E9
    OUTPUT "DB"

LABEL_01EA
    CALL LABEL_0401
    IF 5,3 = 1 THEN GOTO LABEL_01F1
    OUTPUT ".B"
    POSITION ABS,9
    GOTO LABEL_02F6

LABEL_01F1
    POSITION ABS,9
    OUTPUT STR_003A    * "D"
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    OUTPUT STR_0039    * ","
    CALL LABEL_03CF
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_0427
    IF 15,15 = 1 THEN INCLUSIVE_OR 000FF0000H
    ADD INPUT_ADDRESS

LABEL_01FD
    AND CONST_0062
    IF_NOT_MAPPED THEN OUTPUT ACCUMULATOR,FMT_0071    * 24,HEX,6
    RETURN

LABEL_0201
    CASE_OF 8,8
        OUTPUT "ADDQ"
        OUTPUT "SUBQ"
    CASE_END
    CALL LABEL_03EA
    CALL LABEL_03F7
    OUTPUT STR_0039    * ","
    GOTO LABEL_02F6

LABEL_0209
    OUTPUT STR_003C    * "B"
    CALL LABEL_0401
    IF 7,0 <> 0 THEN GOTO LABEL_0219
    OUTPUT ".W"
    SET VAR_003A,1
    CALL LABEL_03CF
    IF 15,15 = 1 THEN INCLUSIVE_OR 000FF0000H
    IF INPUT_ERROR = 0 THEN GOTO LABEL_021F
    OUTPUT "********"
    RETURN

LABEL_0219
    OUTPUT ".B"
    SET VAR_003A,0
    AND CONST_005E
    IF 7,7 = 1 THEN INCLUSIVE_OR 000FFFF00H

LABEL_021F
    POSITION ABS,9
    ADD INPUT_ADDRESS
    AND CONST_0062
    IF VAR_003A = 0 THEN ADD 2
    CALL LABEL_01FD
    LOAD INITIAL_DATA
    IF 15,9 <> 48 THEN RETURN
    IF 7,0 = 0 THEN RETURN
    SET VAR_0054,1
    GOTO LABEL_043D

LABEL_022F
    OUTPUT STR_004C    * "MOVE"
    OUTPUT "Q.L"
    POSITION ABS,9
    AND CONST_005E
    IF 7,7 = 1 THEN INCLUSIVE_OR 0FFFFFF00H
    OUTPUT STR_003F    * "#"
    OUTPUT ACCUMULATOR,FMT_0073    * 32,HEX,8
    OUTPUT STR_0039    * ","
    GOTO LABEL_042D

LABEL_023A
    CASE_OF 14,14
        OUTPUT STR_0044    * "SUB"
        OUTPUT STR_0048    * "ADD"
    CASE_END
    IF 7,6 = 3 THEN GOTO LABEL_0254
    IF 8,8 <> 1 THEN GOTO LABEL_0247
    IF 5,4 = 0 THEN GOTO LABEL_0433

LABEL_0247
    CALL LABEL_03EA
    POSITION ABS,9
    CASE_OF 8,8
        CALL LABEL_02F6
        CALL LABEL_042D
    CASE_END
    OUTPUT STR_0039    * ","
    LOAD INITIAL_DATA
    CASE_OF 8,8
        CALL LABEL_042D
        CALL LABEL_02F6
    CASE_END
    RETURN

LABEL_0254
    OUTPUT "A."

LABEL_0255
    CASE_OF 8,8
        OUTPUT STR_003D    * "W"
        OUTPUT STR_003E    * "L"
    CASE_END
    CASE_OF 8,8
        SET VAR_003A,1
        SET VAR_003A,2
    CASE_END
    POSITION ABS,9
    CALL LABEL_02F6
    OUTPUT STR_0039    * ","
    LOAD INITIAL_DATA
    GOTO LABEL_0429

LABEL_0262
    IF 7,6 = 3 THEN GOTO LABEL_026D
    IF 8,8 = 1 THEN GOTO LABEL_026F
    OUTPUT "CMP"
    CALL LABEL_03EA
    CALL LABEL_02F6
    OUTPUT STR_0039    * ","
    GOTO LABEL_042D

LABEL_026D
    OUTPUT "CMPA."
    GOTO LABEL_0255

LABEL_026F
    IF 5,3 <> 1 THEN GOTO LABEL_027C
    OUTPUT "CMPM"
    CALL LABEL_03EA
    POSITION ABS,9
    OUTPUT "[xx]+,[xx]+"
    POSITION REL,-10
    CALL LABEL_042B
    POSITION REL,4
    CALL LABEL_0429
    POSITION REL,2
    RETURN

LABEL_027C
    OUTPUT STR_0046    * "EOR"
    CALL LABEL_03EA
    CALL LABEL_042D
    OUTPUT STR_0039    * ","
    GOTO LABEL_02F6

LABEL_0281
    IF 7,6 = 3 THEN GOTO LABEL_0295
    IF 14,14 = 0 THEN GOTO LABEL_028D
    IF 8,4 = 20 THEN GOTO LABEL_02B4
    IF 8,4 = 24 THEN GOTO LABEL_02B4

LABEL_028D
    IF 8,4 = 16 THEN GOTO LABEL_02A2
    CASE_OF 14,14
        OUTPUT STR_0040    * "OR"
        OUTPUT STR_0042    * "AND"
    CASE_END
    GOTO LABEL_0247

LABEL_0295
    CASE_OF 14,14
        OUTPUT "DIV"
        OUTPUT "MUL"
    CASE_END
    CASE_OF 8,8
        OUTPUT "U"
        OUTPUT STR_0057    * "S"
    CASE_END
    OUTPUT ".W"
    POSITION ABS,9
    CALL LABEL_02F6
    OUTPUT STR_0039    * ","
    GOTO LABEL_042D

LABEL_02A2
    CASE_OF 14,14
        OUTPUT STR_0057    * "S"
        OUTPUT STR_003B    * "A"
    CASE_END
    OUTPUT "BCD.B"
    POSITION ABS,9
    IF 3,3 = 0 THEN GOTO LABEL_02B1
    OUTPUT "-["
    CALL LABEL_042B
    OUTPUT "],-["
    CALL LABEL_0429
    OUTPUT STR_0058    * "]"
    RETURN

LABEL_02B1
    CALL LABEL_042F
    OUTPUT STR_0039    * ","
    GOTO LABEL_042D

LABEL_02B4
    OUTPUT "EXG.L"
    POSITION ABS,9
    IF 7,3 = 8 THEN SET VAR_0050,0
    IF 7,3 = 9 THEN SET VAR_0050,1
    IF 7,3 = 17 THEN SET VAR_0050,2
    CASE_OF VAR_0050
        CALL LABEL_042D
        CALL LABEL_0429
        CALL LABEL_042D
        NOP
    CASE_END
    OUTPUT STR_0039    * ","
    LOAD INITIAL_DATA
    CASE_OF VAR_0050
        CALL LABEL_042F
        CALL LABEL_042B
        CALL LABEL_042B
        NOP
    CASE_END
    RETURN

LABEL_02CE
    IF 7,6 = 3 THEN GOTO LABEL_02E4
    CASE_OF 4,3
        OUTPUT "AS"
        OUTPUT "LS"
        OUTPUT "ROX"
        OUTPUT "RO"
    CASE_END
    CASE_OF 8,8
        OUTPUT STR_0059    * "R"
        OUTPUT STR_003E    * "L"
    CASE_END
    CALL LABEL_03EA
    IF 5,5 = 1 THEN GOTO LABEL_02E1
    CALL LABEL_03F7
    GOTO LABEL_02E2

LABEL_02E1
    CALL LABEL_042D

LABEL_02E2
    OUTPUT STR_0039    * ","
    GOTO LABEL_042F

LABEL_02E4
    CASE_OF 10,9
        OUTPUT "AS"
        OUTPUT "LS"
        OUTPUT "ROX"
        OUTPUT "RO"
    CASE_END
    CASE_OF 8,8
        OUTPUT STR_0059    * "R"
        OUTPUT STR_003E    * "L"
    CASE_END
    OUTPUT ".W"
    SET VAR_003A,1
    POSITION ABS,9
    GOTO LABEL_02F6

LABEL_02F2
    OUTPUT "Unimplemented Instruction:"
    OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
    SET VAR_0054,1
    GOTO LABEL_043D

LABEL_02F6
    SET VAR_0034,1
    GOTO LABEL_02F9

LABEL_02F8
    SET VAR_0034,0

LABEL_02F9
    LOAD INITIAL_DATA
    CASE_OF VAR_0034
        ROTATE RIGHT,6
        ROTATE RIGHT,3
    CASE_END
    AND 7
    STORE VAR_0038
    LOAD INITIAL_DATA
    CASE_OF VAR_0034
        ROTATE RIGHT,9
        NOP
    CASE_END

LABEL_0305
    AND 7
    STORE VAR_0036
    CASE_OF VAR_0038
        OUTPUT STR_003A    * "D"
        OUTPUT STR_003B    * "A"
        OUTPUT "[A"
        OUTPUT "[A"
        OUTPUT "-[A"
        GOTO LABEL_031F
        GOTO LABEL_0326
        GOTO LABEL_0347
    CASE_END
    LOAD VAR_0036
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    LOAD INITIAL_DATA
    CASE_OF VAR_0038
        RETURN
        RETURN
        OUTPUT STR_0058    * "]"
        OUTPUT "]+"
        OUTPUT STR_0058    * "]"
        NOP
        NOP
        NOP
    CASE_END
    RETURN

LABEL_031F
    CALL LABEL_03C9
    OUTPUT "[A"
    LOAD VAR_0036
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    OUTPUT STR_0058    * "]"
    LOAD INITIAL_DATA
    RETURN

LABEL_0326
    CALL LABEL_03CF
    IF INPUT_ERROR = 0 THEN GOTO LABEL_032F
    OUTPUT "**[A"
    LOAD VAR_0036
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    OUTPUT ",**.*]"
    RETURN

LABEL_032F
    AND CONST_005E
    OUTPUT ACCUMULATOR,FMT_0069    * 8,HEX,2
    OUTPUT "["
    LOAD INPUT_DATA
    OUTPUT STR_003B    * "A"
    LOAD VAR_0036
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    OUTPUT STR_0039    * ","
    CASE_OF 15,15
        OUTPUT STR_003A    * "D"
        OUTPUT STR_003B    * "A"
    CASE_END
    LOAD INPUT_DATA
    ROTATE RIGHT,12
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    OUTPUT STR_005A    * "."
    LOAD INPUT_DATA
    CASE_OF 11,11
        OUTPUT STR_003D    * "W"
        OUTPUT STR_003E    * "L"
    CASE_END
    OUTPUT STR_0058    * "]"
    LOAD INITIAL_DATA
    RETURN

LABEL_0347
    CASE_OF VAR_0036
        GOTO LABEL_034F
        GOTO LABEL_0359
        GOTO LABEL_037D
        GOTO LABEL_0388
        GOTO LABEL_03A4
    CASE_END
    GOTO LABEL_041E

LABEL_034F
    CALL LABEL_03CF
    IF INPUT_ERROR = 0 THEN GOTO LABEL_0355
    OUTPUT "******"
    RETURN

LABEL_0355
    IF 15,15 = 1 THEN INCLUSIVE_OR 000FF0000H
    GOTO LABEL_01FD

LABEL_0359
    CALL LABEL_03CF
    STORE VAR_0048
    SET VAR_0046,0
    IF INPUT_ERROR <> 0 THEN SET VAR_0046,1
    CALL LABEL_03CF
    STORE VAR_004A
    LOAD VAR_0046
    IF INPUT_ERROR <> 0 THEN INCLUSIVE_OR 2
    STORE VAR_0046
    IF VAR_0046 = 0 THEN GOTO LABEL_0378
    LOAD VAR_0048
    CASE_OF VAR_0046
        NOP
        OUTPUT STR_0036    * "****"
        OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
        OUTPUT STR_0036    * "****"
    CASE_END
    LOAD VAR_004A
    CASE_OF VAR_0046
        NOP
        OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
        OUTPUT STR_0036    * "****"
        OUTPUT STR_0036    * "****"
    CASE_END
    RETURN

LABEL_0378
    LOAD VAR_0048
    AND 0000000FFH
    ROTATE LEFT,16
    INCLUSIVE_OR VAR_004A
    GOTO LABEL_01FD

LABEL_037D
    CALL LABEL_03CF
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_0427
    IF 15,15 = 1 THEN INCLUSIVE_OR 000FF0000H
    ADD INPUT_ADDRESS
    CALL LABEL_01FD
    OUTPUT "[PC]"
    RETURN

LABEL_0388
    CALL LABEL_03CF
    IF INPUT_ERROR = 0 THEN GOTO LABEL_038E
    OUTPUT "**[PC,**.*]"
    RETURN

LABEL_038E
    AND 0000000FFH
    IF 7,7 = 1 THEN INCLUSIVE_OR 000FFFF00H
    ADD INPUT_ADDRESS
    CALL LABEL_01FD
    LOAD INPUT_DATA
    OUTPUT "[PC,"
    CASE_OF 15,15
        OUTPUT STR_003A    * "D"
        OUTPUT STR_003B    * "A"
    CASE_END
    ROTATE RIGHT,12
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    OUTPUT STR_005A    * "."
    LOAD INPUT_DATA
    CASE_OF 11,11
        OUTPUT STR_003D    * "W"
        OUTPUT STR_003E    * "L"
    CASE_END
    OUTPUT STR_0058    * "]"
    RETURN

LABEL_03A4
    IF VAR_004E = 0 THEN GOTO LABEL_03AE
    CASE_OF VAR_003A
        OUTPUT STR_0051    * "CCR"
        OUTPUT STR_004F    * "SR"
        GOTO LABEL_041E
        GOTO LABEL_041E
    CASE_END
    RETURN

LABEL_03AE
    OUTPUT STR_003F    * "#"
    CALL LABEL_03CF
    IF INPUT_ERROR = 0 THEN GOTO LABEL_03BA
    CASE_OF VAR_003A
        OUTPUT STR_0055    * "**"
        OUTPUT STR_0036    * "****"
        OUTPUT STR_0036    * "****"
        GOTO LABEL_0424
    CASE_END
    GOTO LABEL_03C0

LABEL_03BA
    CASE_OF VAR_003A
        OUTPUT ACCUMULATOR,FMT_0069    * 8,HEX,2
        OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
        OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
        GOTO LABEL_0424
    CASE_END

LABEL_03C0
    IF VAR_003A <> 2 THEN RETURN
    CALL LABEL_03CF
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_0427
    OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
    RETURN

LABEL_03C9
    CALL LABEL_03CF
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_0427
    OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
    RETURN

LABEL_03CF
    INCREMENT VAR_0056
    INCREMENT VAR_0056
    CALL LABEL_03D8
    CALL LABEL_03DA
    IF INPUT_ERROR = 0 THEN TAG_WITH 2
    LOAD INPUT_DATA
    RETURN

LABEL_03D8
    INPUT ABS,VAR_0056,QUALIFIED
    RETURN

LABEL_03DA
    IF TASK = 3 THEN RETURN
    IF VAR_0044 = 1 THEN SET INPUT_ERROR,1
    IF INPUT_ERROR <> 0 THEN RETURN
    LOAD INPUT_TAG
    IF 17,16 <> 3 THEN RETURN
    SET VAR_0044,1
    SET INPUT_ERROR,1
    RETURN

LABEL_03EA
    OUTPUT STR_005A    * "."
    CASE_OF 7,6
        OUTPUT STR_003C    * "B"
        OUTPUT STR_003D    * "W"
        OUTPUT STR_003E    * "L"
        GOTO LABEL_041E
    CASE_END
    ROTATE RIGHT,6
    AND 3
    STORE VAR_003A
    LOAD INITIAL_DATA
    POSITION ABS,9
    RETURN

LABEL_03F7
    OUTPUT STR_003F    * "#"
    IF 11,9 <> 0 THEN GOTO LABEL_03FD
    OUTPUT "8"
    RETURN

LABEL_03FD
    ROTATE RIGHT,9
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    LOAD INITIAL_DATA
    RETURN

LABEL_0401
    CASE_OF 11,8
        GOTO LABEL_0414
        GOTO LABEL_0419
        OUTPUT "HI"
        OUTPUT "LS"
        OUTPUT "CC"
        OUTPUT "CS"
        OUTPUT "NE"
        OUTPUT "EQ"
        OUTPUT "VC"
        OUTPUT "VS"
        OUTPUT "PL"
        OUTPUT "MI"
        OUTPUT "GE"
        OUTPUT "LT"
        OUTPUT "GT"
        OUTPUT "LE"
    CASE_END
    RETURN

LABEL_0414
    CASE_OF 12,12
        OUTPUT "RA"
        OUTPUT "T"
    CASE_END
    RETURN

LABEL_0419
    CASE_OF 12,12
        OUTPUT STR_004F    * "SR"
        OUTPUT "F"
    CASE_END
    RETURN

LABEL_041E
    POSITION ABS,9
    OUTPUT STR_005B    * "Illegal"
    OUTPUT " Operand    "
    ABORT

LABEL_0422
    OUTPUT "Data Error"
    ABORT

LABEL_0424
    OUTPUT STR_005B    * "Illegal"
    OUTPUT " Opcode"
    ABORT

LABEL_0427
    OUTPUT STR_0036    * "****"
    RETURN

LABEL_0429
    LOAD INITIAL_DATA
    ROTATE RIGHT,9

LABEL_042B
    OUTPUT STR_003B    * "A"
    GOTO LABEL_0430

LABEL_042D
    LOAD INITIAL_DATA
    ROTATE RIGHT,9

LABEL_042F
    OUTPUT STR_003A    * "D"

LABEL_0430
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    LOAD INITIAL_DATA
    RETURN

LABEL_0433
    OUTPUT "X"
    CALL LABEL_03EA
    CASE_OF 3,3
        SET VAR_0038,0
        SET VAR_0038,4
    CASE_END
    CALL LABEL_0305
    ROTATE RIGHT,9
    OUTPUT STR_0039    * ","
    GOTO LABEL_0305

LABEL_043D
    INPUT REL,VAR_0054,QUALIFIED
    CALL LABEL_03DA
    IF INPUT_ERROR <> 0 THEN RETURN
    LOAD VAR_0056
    ADD 2
    SUBTRACT INPUT_ADDRESS
    IF 31,0 <> 0 THEN RETURN
    TAG_WITH 1
    RETURN
    OUTPUT "unknown ("
    AND 000000070H
    ROTATE RIGHT,4
    OUTPUT ACCUMULATOR,FMT_005F    * 3,BIN,3
    OUTPUT ")"
    LOAD INPUT_STATUS
    RETURN
