"IAL"

*
* Original Source File Name: i68008_i.s
*

VAR_0034        VARIABLE 000000000H
VAR_0036        VARIABLE 000000000H
VAR_0038        VARIABLE 000000000H
VAR_003A        VARIABLE 000000000H
VAR_003C_UNREF  VARIABLE 000000000H
VAR_003E_UNREF  VARIABLE 000000000H
VAR_0040_UNREF  VARIABLE 000000000H
VAR_0042_UNREF  VARIABLE 000000000H
VAR_0044        VARIABLE 000000000H
VAR_0046        VARIABLE 000000000H
VAR_0048        VARIABLE 000000000H
VAR_004A        VARIABLE 000000000H
VAR_004C_UNREF  VARIABLE 000000000H
VAR_004E        VARIABLE 000000000H
VAR_0050        VARIABLE 000000000H
VAR_0052        VARIABLE 000000000H
VAR_0054        VARIABLE 000000000H
VAR_0056        VARIABLE 000000000H
VAR_0058        VARIABLE 000000000H
VAR_005A        VARIABLE 000000000H
VAR_005C_UNREF  VARIABLE 000000000H
CONST_005E      CONSTANT 0000000FFH
CONST_0060      CONSTANT 0000FFFFFH
VAR_0062_UNREF  VARIABLE 000FFFFFFH
CONST_0064      CONSTANT 0000000B9H
CONST_0066      CONSTANT 00000005DH
STR_0000        ASCII "supr data"
STR_0005        ASCII "supr program"
STR_000C        ASCII "user data"
STR_0011        ASCII "user program"
STR_0018        ASCII "interrupt ack"
STR_001F        ASCII "read"
STR_0022        ASCII "write"
STR_0025        ASCII " (6800)"
STR_0029        ASCII "DMA"
STR_002B        ASCII "incomplete opcode"
STR_0034_UNREF  ASCII "/"
STR_0035_UNREF  ASCII "-"
STR_0036        ASCII "****"
STR_0039        ASCII ","
STR_003A        ASCII "D"
STR_003B        ASCII "A"
STR_003C        ASCII "B"
STR_003D        ASCII "W"
STR_003E        ASCII "L"
STR_003F        ASCII "#"
STR_0040        ASCII "OR"
STR_0042        ASCII "AND"
STR_0044        ASCII "SUB"
STR_0046        ASCII "EOR"
STR_0048        ASCII "ADD"
STR_004A        ASCII "CLR"
STR_004C        ASCII "MOVE"
STR_004F        ASCII "SR"
STR_0051        ASCII "CCR"
STR_0053        ASCII "USP"
STR_0055        ASCII "**"
STR_0057        ASCII "S"
STR_0058        ASCII "]"
STR_0059        ASCII "R"
STR_005A        ASCII "."
STR_005B        ASCII "Illegal"
        SEARCH_LIMIT     34
FMT_005F        FORMAT 3,BIN,3
FMT_0061        FORMAT 3,DEC,1
FMT_0063_UNREF  FORMAT 5,DEC,2
FMT_0065        FORMAT 4,HEX,1
FMT_0067        FORMAT 3,HEX,1
FMT_0069        FORMAT 8,HEX,2
FMT_006B        FORMAT 5,HEX,2
FMT_006D        FORMAT 16,HEX,4
FMT_006F        FORMAT 20,HEX,5
FMT_0071_UNREF  FORMAT 24,HEX,6
FMT_0073        FORMAT 32,HEX,8
        LABEL_TITLE      "68008 Mnemonic"
        BASE_TITLE       "      hex"
        DEFAULT_WIDTH    31
        MAPPED_WIDTH     41
        ENHANCED_WIDTH   41

ENTRY_POINT
    SET VAR_0058,0
    CASE_OF TASK
        GOTO LABEL_0035
        GOTO LABEL_0035
        GOTO LABEL_0035
        GOTO LABEL_000C
        GOTO LABEL_0010
        GOTO LABEL_0010
    CASE_END
    OUTPUT STR_005B    * "Illegal"
    OUTPUT " Task Request"
    ABORT

LABEL_000C
    LOAD ID_CODE
    IF 7,0 = 0000000F0H THEN SET VAR_0058,1

LABEL_0010
    SET RETURN_FLAGS,1
    SET VAR_004E,0
    SET VAR_0044,0
    LOAD INPUT_ADDRESS
    STORE VAR_0056
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_04BD
    LOAD CONST_0064
    STORE QUALIFY_MASK
    LOAD 32
    STORE QUALIFY_VALUE
    IF VAR_0058 = 1 THEN GOTO LABEL_0027
    IF TASK = 3 THEN GOTO LABEL_002C
    LOAD CONST_0066
    STORE QUALIFY_MASK
    LOAD 16
    STORE QUALIFY_VALUE
    GOTO LABEL_002C

LABEL_0027
    LOAD 47
    STORE QUALIFY_MASK
    LOAD 43
    STORE QUALIFY_VALUE
    GOTO LABEL_002C

LABEL_002C
    LOAD INPUT_TAG
    IF 17,16 <> 0 THEN GOTO LABEL_00AA
    LOAD INPUT_STATUS
    AND QUALIFY_MASK
    IF 7,0 = QUALIFY_VALUE THEN GOTO LABEL_0036

LABEL_0035
    SET RETURN_FLAGS,0

LABEL_0036
    POSITION ABS,3
    LOAD INPUT_DATA
    OUTPUT ACCUMULATOR,FMT_0069    * 8,HEX,2
    POSITION REL,1
    LOAD INPUT_TAG
    IF 1,0 <> 1 THEN GOTO LABEL_0040
    OUTPUT "unused prefetch"
    RETURN

LABEL_0040
    LOAD VAR_0058
    CASE_OF 0,0
        GOTO LABEL_0045
        GOTO LABEL_007E
    CASE_END

LABEL_0045
    LOAD INPUT_STATUS
    IF TASK = 3 THEN GOTO LABEL_0056
    AND 00000007CH
    ROTATE LEFT,1
    STORE VAR_0050
    LOAD INPUT_STATUS
    AND 3
    INCLUSIVE_OR VAR_0050
    STORE VAR_0050
    LOAD INITIAL_ADDRESS
    COMPLEMENT
    AND 1
    ROTATE LEFT,2
    INCLUSIVE_OR VAR_0050
    STORE INPUT_STATUS

LABEL_0056
    IF 7,7 = 0 THEN GOTO LABEL_005B
    OUTPUT STR_0029    * "DMA"
    RETURN

LABEL_005B
    CASE_OF 6,4
        CALL LABEL_04F6
        OUTPUT STR_000C    * "user data"
        OUTPUT STR_0011    * "user program"
        CALL LABEL_04F6
        CALL LABEL_04F6
        OUTPUT STR_0000    * "supr data"
        OUTPUT STR_0005    * "supr program"
        OUTPUT STR_0018    * "interrupt ack"
    CASE_END
    IF 6,4 = 7 THEN GOTO LABEL_006D
    POSITION REL,1
    CASE_OF 0,0
        OUTPUT STR_001F    * "read"
        OUTPUT STR_0022    * "write"
    CASE_END

LABEL_006D
    CASE_OF 3,3
        NOP
        OUTPUT STR_0025    * " (6800)"
    CASE_END
    GOTO LABEL_007D
    CASE_OF 2,0
        RETURN
        RETURN
        POSITION ABS,3
        POSITION ABS,3
        RETURN
        RETURN
        POSITION ABS,5
        POSITION ABS,5
    CASE_END
    OUTPUT "xx"

LABEL_007D
    RETURN

LABEL_007E
    LOAD INPUT_STATUS
    ROTATE LEFT,2
    AND 0000000FCH
    CASE_OF 2,2
        EXCLUSIVE_OR 0
        EXCLUSIVE_OR 5
    CASE_END
    STORE INPUT_STATUS
    IF 7,7 = 1 THEN GOTO LABEL_008B
    OUTPUT STR_0029    * "DMA"
    RETURN

LABEL_008B
    CASE_OF 6,4
        CALL LABEL_04F6
        OUTPUT STR_000C    * "user data"
        OUTPUT STR_0011    * "user program"
        CALL LABEL_04F6
        CALL LABEL_04F6
        OUTPUT STR_0000    * "supr data"
        OUTPUT STR_0005    * "supr program"
        OUTPUT STR_0018    * "interrupt ack"
    CASE_END
    IF 6,4 = 7 THEN GOTO LABEL_009D
    POSITION REL,1
    CASE_OF 0,0
        OUTPUT STR_0022    * "write"
        OUTPUT STR_001F    * "read"
    CASE_END

LABEL_009D
    CASE_OF 3,3
        OUTPUT STR_0025    * " (6800)"
        NOP
    CASE_END
    GOTO LABEL_00A9
    CASE_OF 2,1
        RETURN
        POSITION ABS,5
        POSITION ABS,3
        RETURN
    CASE_END
    OUTPUT "xx"

LABEL_00A9
    RETURN

LABEL_00AA
    LOAD INPUT_TAG
    IF 1,0 = 2 THEN GOTO LABEL_0035
    IF 1,0 = 1 THEN GOTO LABEL_0035
    LOAD INPUT_STATUS
    AND QUALIFY_MASK
    IF 7,0 <> QUALIFY_VALUE THEN GOTO LABEL_0035
    LOAD INPUT_ADDRESS
    IF 0,0 = 1 THEN GOTO LABEL_0035
    LOAD INPUT_DATA
    ROTATE LEFT,8
    AND 00000FF00H
    STORE VAR_005A
    INCREMENT VAR_0056
    INPUT ABS,VAR_0056,QUALIFIED
    IF INPUT_ERROR = 0 THEN TAG_WITH 2
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_04C4
    LOAD INPUT_ADDRESS
    ADD -1
    STORE INPUT_ADDRESS
    DECREMENT VAR_0056
    LOAD INPUT_DATA
    AND 0000000FFH
    INCLUSIVE_OR VAR_005A
    STORE INPUT_DATA
    STORE INITIAL_DATA
    LOAD INPUT_DATA
    CASE_OF 15,12
        GOTO LABEL_00E2
        GOTO LABEL_014F
        GOTO LABEL_014F
        GOTO LABEL_014F
        GOTO LABEL_0165
        GOTO LABEL_0262
        GOTO LABEL_028A
        GOTO LABEL_02B0
        GOTO LABEL_0302
        GOTO LABEL_02BB
        GOTO LABEL_0373
        GOTO LABEL_02E3
        GOTO LABEL_0302
        GOTO LABEL_02BB
        GOTO LABEL_034F
        GOTO LABEL_0373
    CASE_END

LABEL_00E2
    IF 8,8 = 1 THEN GOTO LABEL_0109
    CASE_OF 11,9
        OUTPUT STR_0040    * "OR"
        OUTPUT STR_0042    * "AND"
        OUTPUT STR_0044    * "SUB"
        OUTPUT STR_0048    * "ADD"
        GOTO LABEL_0139
        OUTPUT STR_0046    * "EOR"
        OUTPUT "CMP"
        GOTO LABEL_04BF
    CASE_END
    OUTPUT "I"
    CALL LABEL_0485
    CALL LABEL_042F
    OUTPUT STR_0039    * ","
    LOAD INITIAL_DATA
    CASE_OF 11,9
        SET VAR_004E,1
        SET VAR_004E,1
        SET VAR_004E,0
        SET VAR_004E,0
        NOP
        SET VAR_004E,1
        SET VAR_004E,0
        NOP
    CASE_END
    CALL LABEL_0377
    IF VAR_004E = 0 THEN RETURN
    LOAD INITIAL_DATA
    IF 5,0 <> 60 THEN RETURN
    SET VAR_0054,2
    CALL LABEL_04DA
    RETURN

LABEL_0109
    IF 5,3 = 1 THEN GOTO LABEL_0122
    CALL LABEL_0111
    POSITION ABS,9
    CALL LABEL_04CA
    OUTPUT STR_0039    * ","
    GOTO LABEL_0377

LABEL_0111
    OUTPUT STR_003C    * "B"
    CASE_OF 7,6
        OUTPUT "TST"
        OUTPUT "CHG"
        OUTPUT STR_004A    * "CLR"
        OUTPUT "SET"
    CASE_END
    OUTPUT STR_005A    * "."
    IF 5,3 = 0 THEN GOTO LABEL_011F
    OUTPUT STR_003C    * "B"
    SET VAR_003A,0
    RETURN

LABEL_011F
    OUTPUT STR_003E    * "L"
    SET VAR_003A,2
    RETURN

LABEL_0122
    OUTPUT STR_004C    * "MOVE"
    OUTPUT "P."
    CASE_OF 6,6
        OUTPUT STR_003D    * "W"
        OUTPUT STR_003E    * "L"
    CASE_END
    CASE_OF 6,6
        SET VAR_003A,1
        SET VAR_003A,2
    CASE_END
    SET VAR_0038,5
    POSITION ABS,9
    CASE_OF 7,7
        CALL LABEL_0386
        CALL LABEL_04CA
    CASE_END
    LOAD INITIAL_DATA
    OUTPUT STR_0039    * ","
    CASE_OF 7,7
        CALL LABEL_04CA
        CALL LABEL_0386
    CASE_END
    RETURN

LABEL_0139
    CALL LABEL_0111
    POSITION ABS,9
    OUTPUT STR_003F    * "#"
    CALL LABEL_0450
    IF INPUT_ERROR = 0 THEN GOTO LABEL_0146
    LOAD VAR_003A
    CASE_OF 1,1
        OUTPUT "*"
        OUTPUT STR_0055    * "**"
    CASE_END
    GOTO LABEL_014D

LABEL_0146
    LOAD INPUT_DATA
    CASE_OF VAR_003A
        OUTPUT ACCUMULATOR,FMT_0067    * 3,HEX,1
        NOP
        OUTPUT ACCUMULATOR,FMT_006B    * 5,HEX,2
        NOP
    CASE_END

LABEL_014D
    OUTPUT STR_0039    * ","
    GOTO LABEL_0377

LABEL_014F
    OUTPUT STR_004C    * "MOVE"
    IF 8,6 = 1 THEN OUTPUT STR_003B    * "A"
    OUTPUT STR_005A    * "."
    CASE_OF 13,12
        NOP
        OUTPUT STR_003C    * "B"
        OUTPUT STR_003E    * "L"
        OUTPUT STR_003D    * "W"
    CASE_END
    CASE_OF 13,12
        NOP
        SET VAR_003A,0
        SET VAR_003A,2
        SET VAR_003A,1
    CASE_END
    POSITION ABS,9
    CALL LABEL_0377
    OUTPUT STR_0039    * ","
    LOAD INITIAL_DATA
    GOTO LABEL_0379

LABEL_0165
    IF 8,7 = 2 THEN GOTO LABEL_04BF
    IF 8,8 = 1 THEN GOTO LABEL_018B
    IF 11,11 = 0 THEN GOTO LABEL_0198
    CASE_OF 10,9
        GOTO LABEL_0175
        GOTO LABEL_0203
        GOTO LABEL_020C
        GOTO LABEL_0210
    CASE_END
    RETURN

LABEL_0175
    CASE_OF 7,6
        OUTPUT "NBCD.B"
        GOTO LABEL_017D
        GOTO LABEL_01D8
        GOTO LABEL_01D8
    CASE_END
    POSITION ABS,9
    GOTO LABEL_0377

LABEL_017D
    SET VAR_0050,0
    IF 5,3 <> 0 THEN SET VAR_0050,1
    CASE_OF VAR_0050
        OUTPUT "SWAP.W"
        OUTPUT "PEA.L"
    CASE_END
    POSITION ABS,9
    CASE_OF VAR_0050
        CALL LABEL_04CC
        CALL LABEL_0377
    CASE_END
    RETURN

LABEL_018B
    CASE_OF 6,6
        OUTPUT "CHK.W"
        OUTPUT "LEA.L"
    CASE_END
    POSITION ABS,9
    CALL LABEL_0377
    LOAD INITIAL_DATA
    OUTPUT STR_0039    * ","
    CASE_OF 6,6
        CALL LABEL_04CA
        CALL LABEL_04C6
    CASE_END
    RETURN

LABEL_0198
    IF 7,6 = 3 THEN GOTO LABEL_01A4
    CASE_OF 10,9
        OUTPUT "NEGX"
        OUTPUT STR_004A    * "CLR"
        OUTPUT "NEG"
        OUTPUT "NOT"
    CASE_END
    CALL LABEL_0485
    CALL LABEL_0377
    RETURN

LABEL_01A4
    OUTPUT STR_004C    * "MOVE"
    OUTPUT STR_005A    * "."
    CASE_OF 10,9
        OUTPUT STR_003D    * "W"
        GOTO LABEL_04BF
        OUTPUT STR_003C    * "B"
        OUTPUT STR_003D    * "W"
    CASE_END
    CASE_OF 10,9
        SET VAR_003A,1
        SET VAR_003A,1
        SET VAR_003A,0
        SET VAR_003A,1
    CASE_END
    POSITION ABS,9
    CASE_OF 10,9
        OUTPUT STR_004F    * "SR"
        OUTPUT STR_0051    * "CCR"
        CALL LABEL_0377
        CALL LABEL_0377
    CASE_END
    OUTPUT STR_0039    * ","
    LOAD INITIAL_DATA
    CASE_OF 10,9
        CALL LABEL_0377
        CALL LABEL_0377
        OUTPUT STR_0051    * "CCR"
        OUTPUT STR_004F    * "SR"
    CASE_END
    LOAD INITIAL_DATA
    IF 10,9 < 2 THEN RETURN
    CASE_OF 5,3
        SET VAR_0054,1
        NOP
        SET VAR_0054,1
        SET VAR_0054,1
        SET VAR_0054,1
        SET VAR_0054,2
        SET VAR_0054,2
        CALL LABEL_01D0
    CASE_END
    GOTO LABEL_04DA

LABEL_01D0
    CASE_OF 2,0
        SET VAR_0054,2
        SET VAR_0054,3
        SET VAR_0054,2
        SET VAR_0054,2
        SET VAR_0054,2
    CASE_END
    RETURN

LABEL_01D8
    IF 5,3 = 0 THEN GOTO LABEL_01FC

LABEL_01DB
    OUTPUT STR_004C    * "MOVE"
    OUTPUT "M."
    CASE_OF 6,6
        OUTPUT STR_003D    * "W"
        OUTPUT STR_003E    * "L"
    CASE_END
    CALL LABEL_0450
    STORE VAR_0052
    IF INPUT_ERROR <> 0 THEN SET VAR_0052,0
    POSITION ABS,9
    LOAD INITIAL_DATA
    CASE_OF 10,10
        CALL LABEL_01F3
        CALL LABEL_0377
    CASE_END
    OUTPUT STR_0039    * ","
    LOAD INITIAL_DATA
    CASE_OF 10,10
        CALL LABEL_0377
        CALL LABEL_01F3
    CASE_END
    RETURN

LABEL_01F3
    OUTPUT "rm="
    LOAD VAR_0052
    IF 15,0 <> 0 THEN GOTO LABEL_01FA
    OUTPUT STR_0036    * "****"
    RETURN

LABEL_01FA
    OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
    RETURN

LABEL_01FC
    OUTPUT "EXT."
    CASE_OF 6,6
        OUTPUT STR_003D    * "W"
        OUTPUT STR_003E    * "L"
    CASE_END
    POSITION ABS,9
    GOTO LABEL_04CC

LABEL_0203
    IF 7,6 <> 3 THEN GOTO LABEL_0208
    OUTPUT "TAS.B"
    GOTO LABEL_020A

LABEL_0208
    OUTPUT "TST"
    CALL LABEL_0485

LABEL_020A
    POSITION ABS,9
    GOTO LABEL_0377

LABEL_020C
    IF 7,7 = 0 THEN GOTO LABEL_04BF
    GOTO LABEL_01DB

LABEL_0210
    CASE_OF 8,6
        GOTO LABEL_04BF
        GOTO LABEL_0218
        OUTPUT "JSR"
        OUTPUT "JMP"
    CASE_END
    POSITION ABS,9
    GOTO LABEL_0377

LABEL_0218
    CASE_OF 5,4
        GOTO LABEL_023E
        GOTO LABEL_0245
        GOTO LABEL_0255
        NOP
    CASE_END
    IF 5,3 = 7 THEN GOTO LABEL_04BF
    CASE_OF 2,0
        OUTPUT "RESET"
        OUTPUT "NOP"
        OUTPUT "STOP"
        OUTPUT "RTE"
        GOTO LABEL_04BF
        OUTPUT "RTS"
        OUTPUT "TRAPV"
        OUTPUT "RTR"
    CASE_END
    IF 2,0 <> 2 THEN GOTO LABEL_0236
    POSITION ABS,9
    OUTPUT STR_003F    * "#"
    CALL LABEL_0450
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_04C2
    OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
    RETURN

LABEL_0236
    IF 2,0 < 3 THEN RETURN
    IF 2,0 = 6 THEN RETURN
    SET VAR_0054,1
    GOTO LABEL_04DA

LABEL_023E
    OUTPUT "TRAP"
    POSITION ABS,9
    OUTPUT STR_003F    * "#"
    AND 15
    OUTPUT ACCUMULATOR,FMT_0065    * 4,HEX,1
    SET VAR_0054,1
    GOTO LABEL_04DA

LABEL_0245
    CASE_OF 3,3
        OUTPUT "LINK"
        OUTPUT "UNLK"
    CASE_END
    POSITION ABS,9
    CALL LABEL_04C8
    IF 3,3 = 1 THEN RETURN
    OUTPUT ",#"
    CALL LABEL_0450
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_04C2
    OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
    RETURN

LABEL_0255
    OUTPUT STR_004C    * "MOVE"
    OUTPUT ".L"
    POSITION ABS,9
    CASE_OF 3,3
        CALL LABEL_04C8
        OUTPUT STR_0053    * "USP"
    CASE_END
    OUTPUT STR_0039    * ","
    CASE_OF 3,3
        OUTPUT STR_0053    * "USP"
        CALL LABEL_04C8
    CASE_END
    RETURN

LABEL_0262
    IF 7,6 <> 3 THEN GOTO LABEL_0282
    IF 5,3 = 1 THEN GOTO LABEL_026A
    OUTPUT STR_0057    * "S"
    GOTO LABEL_026B

LABEL_026A
    OUTPUT "DB"

LABEL_026B
    CALL LABEL_049C
    IF 5,3 = 1 THEN GOTO LABEL_0272
    OUTPUT ".B"
    POSITION ABS,9
    GOTO LABEL_0377

LABEL_0272
    POSITION ABS,9
    OUTPUT STR_003A    * "D"
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    OUTPUT STR_0039    * ","
    CALL LABEL_0450
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_04C2
    IF 15,15 = 1 THEN INCLUSIVE_OR 000FF0000H
    ADD INPUT_ADDRESS

LABEL_027E
    AND CONST_0060
    IF_NOT_MAPPED THEN OUTPUT ACCUMULATOR,FMT_006F    * 20,HEX,5
    RETURN

LABEL_0282
    CASE_OF 8,8
        OUTPUT "ADDQ"
        OUTPUT "SUBQ"
    CASE_END
    CALL LABEL_0485
    CALL LABEL_0492
    OUTPUT STR_0039    * ","
    GOTO LABEL_0377

LABEL_028A
    OUTPUT STR_003C    * "B"
    CALL LABEL_049C
    IF 7,0 <> 0 THEN GOTO LABEL_029A
    OUTPUT ".W"
    SET VAR_003A,1
    CALL LABEL_0450
    IF 15,15 = 1 THEN INCLUSIVE_OR 000FF0000H
    IF INPUT_ERROR = 0 THEN GOTO LABEL_02A0
    OUTPUT "********"
    RETURN

LABEL_029A
    OUTPUT ".B"
    SET VAR_003A,0
    AND CONST_005E
    IF 7,7 = 1 THEN INCLUSIVE_OR 000FFFF00H

LABEL_02A0
    POSITION ABS,9
    ADD INPUT_ADDRESS
    AND CONST_0060
    IF VAR_003A = 0 THEN ADD 2
    CALL LABEL_027E
    LOAD INITIAL_DATA
    IF 15,9 <> 48 THEN RETURN
    IF 7,0 = 0 THEN RETURN
    SET VAR_0054,1
    GOTO LABEL_04DA

LABEL_02B0
    OUTPUT STR_004C    * "MOVE"
    OUTPUT "Q.L"
    POSITION ABS,9
    AND CONST_005E
    IF 7,7 = 1 THEN INCLUSIVE_OR 0FFFFFF00H
    OUTPUT STR_003F    * "#"
    OUTPUT ACCUMULATOR,FMT_0073    * 32,HEX,8
    OUTPUT STR_0039    * ","
    GOTO LABEL_04CA

LABEL_02BB
    CASE_OF 14,14
        OUTPUT STR_0044    * "SUB"
        OUTPUT STR_0048    * "ADD"
    CASE_END
    IF 7,6 = 3 THEN GOTO LABEL_02D5
    IF 8,8 <> 1 THEN GOTO LABEL_02C8
    IF 5,4 = 0 THEN GOTO LABEL_04D0

LABEL_02C8
    CALL LABEL_0485
    POSITION ABS,9
    CASE_OF 8,8
        CALL LABEL_0377
        CALL LABEL_04CA
    CASE_END
    OUTPUT STR_0039    * ","
    LOAD INITIAL_DATA
    CASE_OF 8,8
        CALL LABEL_04CA
        CALL LABEL_0377
    CASE_END
    RETURN

LABEL_02D5
    OUTPUT "A."

LABEL_02D6
    CASE_OF 8,8
        OUTPUT STR_003D    * "W"
        OUTPUT STR_003E    * "L"
    CASE_END
    CASE_OF 8,8
        SET VAR_003A,1
        SET VAR_003A,2
    CASE_END
    POSITION ABS,9
    CALL LABEL_0377
    OUTPUT STR_0039    * ","
    LOAD INITIAL_DATA
    GOTO LABEL_04C6

LABEL_02E3
    IF 7,6 = 3 THEN GOTO LABEL_02EE
    IF 8,8 = 1 THEN GOTO LABEL_02F0
    OUTPUT "CMP"
    CALL LABEL_0485
    CALL LABEL_0377
    OUTPUT STR_0039    * ","
    GOTO LABEL_04CA

LABEL_02EE
    OUTPUT "CMPA."
    GOTO LABEL_02D6

LABEL_02F0
    IF 5,3 <> 1 THEN GOTO LABEL_02FD
    OUTPUT "CMPM"
    CALL LABEL_0485
    POSITION ABS,9
    OUTPUT "[xx]+,[xx]+"
    POSITION REL,-10
    CALL LABEL_04C8
    POSITION REL,4
    CALL LABEL_04C6
    POSITION REL,2
    RETURN

LABEL_02FD
    OUTPUT STR_0046    * "EOR"
    CALL LABEL_0485
    CALL LABEL_04CA
    OUTPUT STR_0039    * ","
    GOTO LABEL_0377

LABEL_0302
    IF 7,6 = 3 THEN GOTO LABEL_0316
    IF 14,14 = 0 THEN GOTO LABEL_030E
    IF 8,4 = 20 THEN GOTO LABEL_0335
    IF 8,4 = 24 THEN GOTO LABEL_0335

LABEL_030E
    IF 8,4 = 16 THEN GOTO LABEL_0323
    CASE_OF 14,14
        OUTPUT STR_0040    * "OR"
        OUTPUT STR_0042    * "AND"
    CASE_END
    GOTO LABEL_02C8

LABEL_0316
    CASE_OF 14,14
        OUTPUT "DIV"
        OUTPUT "MUL"
    CASE_END
    CASE_OF 8,8
        OUTPUT "U"
        OUTPUT STR_0057    * "S"
    CASE_END
    OUTPUT ".W"
    POSITION ABS,9
    CALL LABEL_0377
    OUTPUT STR_0039    * ","
    GOTO LABEL_04CA

LABEL_0323
    CASE_OF 14,14
        OUTPUT STR_0057    * "S"
        OUTPUT STR_003B    * "A"
    CASE_END
    OUTPUT "BCD.B"
    POSITION ABS,9
    IF 3,3 = 0 THEN GOTO LABEL_0332
    OUTPUT "-["
    CALL LABEL_04C8
    OUTPUT "],-["
    CALL LABEL_04C6
    OUTPUT STR_0058    * "]"
    RETURN

LABEL_0332
    CALL LABEL_04CC
    OUTPUT STR_0039    * ","
    GOTO LABEL_04CA

LABEL_0335
    OUTPUT "EXG.L"
    POSITION ABS,9
    IF 7,3 = 8 THEN SET VAR_0050,0
    IF 7,3 = 9 THEN SET VAR_0050,1
    IF 7,3 = 17 THEN SET VAR_0050,2
    CASE_OF VAR_0050
        CALL LABEL_04CA
        CALL LABEL_04C6
        CALL LABEL_04CA
        NOP
    CASE_END
    OUTPUT STR_0039    * ","
    LOAD INITIAL_DATA
    CASE_OF VAR_0050
        CALL LABEL_04CC
        CALL LABEL_04C8
        CALL LABEL_04C8
        NOP
    CASE_END
    RETURN

LABEL_034F
    IF 7,6 = 3 THEN GOTO LABEL_0365
    CASE_OF 4,3
        OUTPUT "AS"
        OUTPUT "LS"
        OUTPUT "ROX"
        OUTPUT "RO"
    CASE_END
    CASE_OF 8,8
        OUTPUT STR_0059    * "R"
        OUTPUT STR_003E    * "L"
    CASE_END
    CALL LABEL_0485
    IF 5,5 = 1 THEN GOTO LABEL_0362
    CALL LABEL_0492
    GOTO LABEL_0363

LABEL_0362
    CALL LABEL_04CA

LABEL_0363
    OUTPUT STR_0039    * ","
    GOTO LABEL_04CC

LABEL_0365
    CASE_OF 10,9
        OUTPUT "AS"
        OUTPUT "LS"
        OUTPUT "ROX"
        OUTPUT "RO"
    CASE_END
    CASE_OF 8,8
        OUTPUT STR_0059    * "R"
        OUTPUT STR_003E    * "L"
    CASE_END
    OUTPUT ".W"
    SET VAR_003A,1
    POSITION ABS,9
    GOTO LABEL_0377

LABEL_0373
    OUTPUT "Unimplemented Instruction:"
    OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
    SET VAR_0054,1
    GOTO LABEL_04DA

LABEL_0377
    SET VAR_0034,1
    GOTO LABEL_037A

LABEL_0379
    SET VAR_0034,0

LABEL_037A
    LOAD INITIAL_DATA
    CASE_OF VAR_0034
        ROTATE RIGHT,6
        ROTATE RIGHT,3
    CASE_END
    AND 7
    STORE VAR_0038
    LOAD INITIAL_DATA
    CASE_OF VAR_0034
        ROTATE RIGHT,9
        NOP
    CASE_END

LABEL_0386
    AND 7
    STORE VAR_0036
    CASE_OF VAR_0038
        OUTPUT STR_003A    * "D"
        OUTPUT STR_003B    * "A"
        OUTPUT "[A"
        OUTPUT "[A"
        OUTPUT "-[A"
        GOTO LABEL_03A0
        GOTO LABEL_03A7
        GOTO LABEL_03C8
    CASE_END
    LOAD VAR_0036
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    LOAD INITIAL_DATA
    CASE_OF VAR_0038
        RETURN
        RETURN
        OUTPUT STR_0058    * "]"
        OUTPUT "]+"
        OUTPUT STR_0058    * "]"
        NOP
        NOP
        NOP
    CASE_END
    RETURN

LABEL_03A0
    CALL LABEL_044A
    OUTPUT "[A"
    LOAD VAR_0036
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    OUTPUT STR_0058    * "]"
    LOAD INITIAL_DATA
    RETURN

LABEL_03A7
    CALL LABEL_0450
    IF INPUT_ERROR = 0 THEN GOTO LABEL_03B0
    OUTPUT "**[A"
    LOAD VAR_0036
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    OUTPUT ",**.*]"
    RETURN

LABEL_03B0
    AND CONST_005E
    OUTPUT ACCUMULATOR,FMT_0069    * 8,HEX,2
    OUTPUT "["
    LOAD INPUT_DATA
    OUTPUT STR_003B    * "A"
    LOAD VAR_0036
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    OUTPUT STR_0039    * ","
    CASE_OF 15,15
        OUTPUT STR_003A    * "D"
        OUTPUT STR_003B    * "A"
    CASE_END
    LOAD INPUT_DATA
    ROTATE RIGHT,12
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    OUTPUT STR_005A    * "."
    LOAD INPUT_DATA
    CASE_OF 11,11
        OUTPUT STR_003D    * "W"
        OUTPUT STR_003E    * "L"
    CASE_END
    OUTPUT STR_0058    * "]"
    LOAD INITIAL_DATA
    RETURN

LABEL_03C8
    CASE_OF VAR_0036
        GOTO LABEL_03D0
        GOTO LABEL_03DA
        GOTO LABEL_03FE
        GOTO LABEL_0409
        GOTO LABEL_0425
    CASE_END
    GOTO LABEL_04B9

LABEL_03D0
    CALL LABEL_0450
    IF INPUT_ERROR = 0 THEN GOTO LABEL_03D6
    OUTPUT "******"
    RETURN

LABEL_03D6
    IF 15,15 = 1 THEN INCLUSIVE_OR 000FF0000H
    GOTO LABEL_027E

LABEL_03DA
    CALL LABEL_0450
    STORE VAR_0048
    SET VAR_0046,0
    IF INPUT_ERROR <> 0 THEN SET VAR_0046,1
    CALL LABEL_0450
    STORE VAR_004A
    LOAD VAR_0046
    IF INPUT_ERROR <> 0 THEN INCLUSIVE_OR 2
    STORE VAR_0046
    IF VAR_0046 = 0 THEN GOTO LABEL_03F9
    LOAD VAR_0048
    CASE_OF VAR_0046
        NOP
        OUTPUT STR_0036    * "****"
        OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
        OUTPUT STR_0036    * "****"
    CASE_END
    LOAD VAR_004A
    CASE_OF VAR_0046
        NOP
        OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
        OUTPUT STR_0036    * "****"
        OUTPUT STR_0036    * "****"
    CASE_END
    RETURN

LABEL_03F9
    LOAD VAR_0048
    AND 0000000FFH
    ROTATE LEFT,16
    INCLUSIVE_OR VAR_004A
    GOTO LABEL_027E

LABEL_03FE
    CALL LABEL_0450
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_04C2
    IF 15,15 = 1 THEN INCLUSIVE_OR 000FF0000H
    ADD INPUT_ADDRESS
    CALL LABEL_027E
    OUTPUT "[PC]"
    RETURN

LABEL_0409
    CALL LABEL_0450
    IF INPUT_ERROR = 0 THEN GOTO LABEL_040F
    OUTPUT "**[PC,**.*]"
    RETURN

LABEL_040F
    AND 0000000FFH
    IF 7,7 = 1 THEN INCLUSIVE_OR 000FFFF00H
    ADD INPUT_ADDRESS
    CALL LABEL_027E
    LOAD INPUT_DATA
    OUTPUT "[PC,"
    CASE_OF 15,15
        OUTPUT STR_003A    * "D"
        OUTPUT STR_003B    * "A"
    CASE_END
    ROTATE RIGHT,12
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    OUTPUT STR_005A    * "."
    LOAD INPUT_DATA
    CASE_OF 11,11
        OUTPUT STR_003D    * "W"
        OUTPUT STR_003E    * "L"
    CASE_END
    OUTPUT STR_0058    * "]"
    RETURN

LABEL_0425
    IF VAR_004E = 0 THEN GOTO LABEL_042F
    CASE_OF VAR_003A
        OUTPUT STR_0051    * "CCR"
        OUTPUT STR_004F    * "SR"
        GOTO LABEL_04B9
        GOTO LABEL_04B9
    CASE_END
    RETURN

LABEL_042F
    OUTPUT STR_003F    * "#"
    CALL LABEL_0450
    IF INPUT_ERROR = 0 THEN GOTO LABEL_043B
    CASE_OF VAR_003A
        OUTPUT STR_0055    * "**"
        OUTPUT STR_0036    * "****"
        OUTPUT STR_0036    * "****"
        GOTO LABEL_04BF
    CASE_END
    GOTO LABEL_0441

LABEL_043B
    CASE_OF VAR_003A
        OUTPUT ACCUMULATOR,FMT_0069    * 8,HEX,2
        OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
        OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
        GOTO LABEL_04BF
    CASE_END

LABEL_0441
    IF VAR_003A <> 2 THEN RETURN
    CALL LABEL_0450
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_04C2
    OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
    RETURN

LABEL_044A
    CALL LABEL_0450
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_04C2
    OUTPUT ACCUMULATOR,FMT_006D    * 16,HEX,4
    RETURN

LABEL_0450
    INCREMENT VAR_0056
    INCREMENT VAR_0056
    CALL LABEL_0473
    CALL LABEL_0475
    IF INPUT_ERROR = 0 THEN TAG_WITH 2
    LOAD INPUT_ADDRESS
    IF 0,0 = 1 THEN RETURN
    LOAD INPUT_DATA
    IF INPUT_ERROR <> 0 THEN RETURN
    ROTATE LEFT,8
    AND 00000FF00H
    STORE VAR_005A
    INCREMENT VAR_0056
    CALL LABEL_0473
    IF INPUT_ERROR = 0 THEN TAG_WITH 2
    IF INPUT_ERROR <> 0 THEN RETURN
    LOAD INPUT_ADDRESS
    ADD -1
    STORE INPUT_ADDRESS
    DECREMENT VAR_0056
    LOAD INPUT_DATA
    AND 0000000FFH
    INCLUSIVE_OR VAR_005A
    STORE INPUT_DATA
    RETURN

LABEL_0473
    INPUT ABS,VAR_0056,QUALIFIED
    RETURN

LABEL_0475
    IF TASK = 3 THEN RETURN
    IF VAR_0044 = 1 THEN SET INPUT_ERROR,1
    IF INPUT_ERROR <> 0 THEN RETURN
    LOAD INPUT_TAG
    IF 17,16 <> 3 THEN RETURN
    SET VAR_0044,1
    SET INPUT_ERROR,1
    RETURN

LABEL_0485
    OUTPUT STR_005A    * "."
    CASE_OF 7,6
        OUTPUT STR_003C    * "B"
        OUTPUT STR_003D    * "W"
        OUTPUT STR_003E    * "L"
        GOTO LABEL_04B9
    CASE_END
    ROTATE RIGHT,6
    AND 3
    STORE VAR_003A
    LOAD INITIAL_DATA
    POSITION ABS,9
    RETURN

LABEL_0492
    OUTPUT STR_003F    * "#"
    IF 11,9 <> 0 THEN GOTO LABEL_0498
    OUTPUT "8"
    RETURN

LABEL_0498
    ROTATE RIGHT,9
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    LOAD INITIAL_DATA
    RETURN

LABEL_049C
    CASE_OF 11,8
        GOTO LABEL_04AF
        GOTO LABEL_04B4
        OUTPUT "HI"
        OUTPUT "LS"
        OUTPUT "CC"
        OUTPUT "CS"
        OUTPUT "NE"
        OUTPUT "EQ"
        OUTPUT "VC"
        OUTPUT "VS"
        OUTPUT "PL"
        OUTPUT "MI"
        OUTPUT "GE"
        OUTPUT "LT"
        OUTPUT "GT"
        OUTPUT "LE"
    CASE_END
    RETURN

LABEL_04AF
    CASE_OF 12,12
        OUTPUT "RA"
        OUTPUT "T"
    CASE_END
    RETURN

LABEL_04B4
    CASE_OF 12,12
        OUTPUT STR_004F    * "SR"
        OUTPUT "F"
    CASE_END
    RETURN

LABEL_04B9
    POSITION ABS,9
    OUTPUT STR_005B    * "Illegal"
    OUTPUT " Operand    "
    ABORT

LABEL_04BD
    OUTPUT "Data Error"
    ABORT

LABEL_04BF
    OUTPUT STR_005B    * "Illegal"
    OUTPUT " Opcode"
    ABORT

LABEL_04C2
    OUTPUT STR_0036    * "****"
    RETURN

LABEL_04C4
    OUTPUT STR_002B    * "incomplete opcode"
    ABORT

LABEL_04C6
    LOAD INITIAL_DATA
    ROTATE RIGHT,9

LABEL_04C8
    OUTPUT STR_003B    * "A"
    GOTO LABEL_04CD

LABEL_04CA
    LOAD INITIAL_DATA
    ROTATE RIGHT,9

LABEL_04CC
    OUTPUT STR_003A    * "D"

LABEL_04CD
    OUTPUT ACCUMULATOR,FMT_0061    * 3,DEC,1
    LOAD INITIAL_DATA
    RETURN

LABEL_04D0
    OUTPUT "X"
    CALL LABEL_0485
    CASE_OF 3,3
        SET VAR_0038,0
        SET VAR_0038,4
    CASE_END
    CALL LABEL_0386
    ROTATE RIGHT,9
    OUTPUT STR_0039    * ","
    GOTO LABEL_0386

LABEL_04DA
    LOAD VAR_0054
    ADD VAR_0054
    STORE VAR_0054
    INPUT REL,VAR_0054,QUALIFIED
    CALL LABEL_0475
    IF INPUT_ERROR <> 0 THEN RETURN
    LOAD VAR_0056
    ADD 2
    SUBTRACT INPUT_ADDRESS
    IF 31,0 <> 0 THEN RETURN
    TAG_WITH 1
    INCREMENT VAR_0054
    INPUT REL,VAR_0054,QUALIFIED
    CALL LABEL_0475
    IF INPUT_ERROR <> 0 THEN RETURN
    LOAD VAR_0056
    ADD 3
    SUBTRACT INPUT_ADDRESS
    IF 31,0 = 0 THEN TAG_WITH 1
    RETURN

LABEL_04F6
    OUTPUT "unknown ("
    AND 000000070H
    ROTATE RIGHT,4
    OUTPUT ACCUMULATOR,FMT_005F    * 3,BIN,3
    OUTPUT ")"
    LOAD INPUT_STATUS
    RETURN
