"IAL"

*
* Original Source File Name: d:\ial\procs\i68010_p8.s
*

VAR_0034        VARIABLE 000000000H
VAR_0036        VARIABLE 000000000H
VAR_0038        VARIABLE 000000000H
VAR_003A        VARIABLE 000000000H
VAR_003C_UNREF  VARIABLE 000000000H
VAR_003E_UNREF  VARIABLE 000000000H
VAR_0040_UNREF  VARIABLE 000000000H
VAR_0042_UNREF  VARIABLE 000000000H
VAR_0044        VARIABLE 000000000H
VAR_0046        VARIABLE 000000000H
VAR_0048        VARIABLE 000000000H
VAR_004A        VARIABLE 000000000H
VAR_004C        VARIABLE 000000000H
VAR_004E        VARIABLE 000000000H
VAR_0050        VARIABLE 000000000H
VAR_0052        VARIABLE 000000000H
VAR_0054        VARIABLE 000000000H
VAR_0056        VARIABLE 000000000H
VAR_0058        VARIABLE 000000000H
VAR_005A        VARIABLE 000000000H
VAR_005C_UNREF  VARIABLE 000000000H
VAR_005E        VARIABLE 0000FFFFFH
CONST_0060      CONSTANT 0000000FFH
CONST_0062      CONSTANT 0000FFFFFH
CONST_0064      CONSTANT 000FFFFFFH
VAR_0066_UNREF  VARIABLE 0000000BBH
VAR_0068_UNREF  VARIABLE 00000005FH
CONST_006A      CONSTANT 0000000BFH
CONST_006C      CONSTANT 0000000A9H
STR_0000        ASCII "supr data"
STR_0005        ASCII "supr program"
STR_000C        ASCII "user data"
STR_0011        ASCII "user program"
STR_0018        ASCII "read"
STR_001B        ASCII "write"
STR_001E        ASCII " (6800)"
STR_0022        ASCII "DMA"
STR_0024_UNREF  ASCII "incomplete opcode"
STR_002D_UNREF  ASCII "/"
STR_002E_UNREF  ASCII "-"
STR_002F        ASCII "****"
STR_0032        ASCII ","
STR_0033        ASCII "D"
STR_0034        ASCII "A"
STR_0035        ASCII "B"
STR_0036        ASCII "W"
STR_0037        ASCII "L"
STR_0038        ASCII "#"
STR_0039        ASCII "OR"
STR_003B        ASCII "AND"
STR_003D        ASCII "SUB"
STR_003F        ASCII "EOR"
STR_0041        ASCII "ADD"
STR_0043        ASCII "CLR"
STR_0045        ASCII "MOVE"
STR_0048        ASCII "SR"
STR_004A        ASCII "CCR"
STR_004C        ASCII "USP"
STR_004E        ASCII "**"
STR_0050        ASCII "S"
STR_0051        ASCII "]"
STR_0052        ASCII "R"
STR_0053        ASCII "."
STR_0054        ASCII "Illegal"
        SEARCH_LIMIT     34
FMT_0058        FORMAT 3,BIN,3
FMT_005A        FORMAT 3,DEC,1
FMT_005C_UNREF  FORMAT 5,DEC,2
FMT_005E        FORMAT 4,HEX,1
FMT_0060        FORMAT 3,HEX,1
FMT_0062        FORMAT 8,HEX,2
FMT_0064        FORMAT 5,HEX,2
FMT_0066        FORMAT 16,HEX,4
FMT_0068_UNREF  FORMAT 20,HEX,5
FMT_006A        FORMAT 24,HEX,6
FMT_006C        FORMAT 32,HEX,8
        LABEL_TITLE      "68010 Mnemonic"
        BASE_TITLE       "      hex"
        DEFAULT_WIDTH    31
        MAPPED_WIDTH     41
        ENHANCED_WIDTH   41

ENTRY_POINT
    SET VAR_0058,0
    LOAD CONST_0062
    STORE VAR_005E
    CASE_OF TASK
        GOTO LABEL_0028
        GOTO LABEL_0028
        GOTO LABEL_0028
        GOTO LABEL_000E
        GOTO LABEL_0012
        GOTO LABEL_0012
    CASE_END
    OUTPUT STR_0054    * "Illegal"
    OUTPUT " Task Request"
    ABORT

LABEL_000E
    LOAD ID_CODE
    IF 7,0 = 0000000F0H THEN SET VAR_0058,1

LABEL_0012
    SET RETURN_FLAGS,1
    SET VAR_004E,0
    SET VAR_0044,0
    LOAD INPUT_ADDRESS
    STORE VAR_0056
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_0483
    LOAD CONST_006A
    STORE QUALIFY_MASK
    LOAD CONST_006C
    STORE QUALIFY_VALUE
    GOTO LABEL_001F

LABEL_001F
    LOAD INPUT_TAG
    IF 17,16 <> 0 THEN GOTO LABEL_0057
    LOAD INPUT_STATUS
    AND QUALIFY_MASK
    IF 7,0 = QUALIFY_VALUE THEN GOTO LABEL_0029

LABEL_0028
    SET RETURN_FLAGS,0

LABEL_0029
    POSITION ABS,3
    LOAD INPUT_DATA
    OUTPUT ACCUMULATOR,FMT_0066    * 16,HEX,4
    POSITION REL,1
    LOAD INPUT_TAG
    IF 1,0 <> 1 THEN GOTO LABEL_0033
    OUTPUT "unused prefetch"
    RETURN

LABEL_0033
    LOAD INPUT_STATUS
    IF 7,7 = 1 THEN GOTO LABEL_0039
    OUTPUT STR_0022    * "DMA"
    RETURN

LABEL_0039
    CASE_OF 6,4
        CALL LABEL_04AD
        OUTPUT STR_000C    * "user data"
        OUTPUT STR_0011    * "user program"
        CALL LABEL_04AD
        CALL LABEL_04AD
        OUTPUT STR_0000    * "supr data"
        OUTPUT STR_0005    * "supr program"
        CALL LABEL_04B4
    CASE_END
    IF VAR_004C = 1 THEN GOTO LABEL_004B
    POSITION REL,1
    CASE_OF 0,0
        OUTPUT STR_001B    * "write"
        OUTPUT STR_0018    * "read"
    CASE_END

LABEL_004B
    CASE_OF 3,3
        OUTPUT STR_001E    * " (6800)"
        NOP
    CASE_END
    CASE_OF 2,1
        RETURN
        POSITION ABS,5
        POSITION ABS,3
        RETURN
    CASE_END
    OUTPUT "xx"
    RETURN

LABEL_0057
    LOAD INPUT_TAG
    IF 1,0 = 2 THEN GOTO LABEL_0028
    IF 1,0 = 1 THEN GOTO LABEL_0028
    LOAD INPUT_STATUS
    AND QUALIFY_MASK
    IF 7,0 <> QUALIFY_VALUE THEN GOTO LABEL_0028
    LOAD INPUT_DATA
    LOAD INPUT_DATA
    CASE_OF 15,12
        GOTO LABEL_0077
        GOTO LABEL_00FF
        GOTO LABEL_00FF
        GOTO LABEL_00FF
        GOTO LABEL_0115
        GOTO LABEL_0242
        GOTO LABEL_026A
        GOTO LABEL_0290
        GOTO LABEL_02E2
        GOTO LABEL_029B
        GOTO LABEL_0353
        GOTO LABEL_02C3
        GOTO LABEL_02E2
        GOTO LABEL_029B
        GOTO LABEL_032F
        GOTO LABEL_0353
    CASE_END

LABEL_0077
    IF 8,8 = 1 THEN GOTO LABEL_00B9
    CASE_OF 11,9
        OUTPUT STR_0039    * "OR"
        OUTPUT STR_003B    * "AND"
        OUTPUT STR_003D    * "SUB"
        OUTPUT STR_0041    * "ADD"
        GOTO LABEL_00E9
        OUTPUT STR_003F    * "EOR"
        OUTPUT "CMP"
        GOTO LABEL_009C
    CASE_END
    OUTPUT "I"
    CALL LABEL_044B
    CALL LABEL_040F
    OUTPUT STR_0032    * ","
    LOAD INITIAL_DATA
    CASE_OF 11,9
        SET VAR_004E,1
        SET VAR_004E,1
        SET VAR_004E,0
        SET VAR_004E,0
        NOP
        SET VAR_004E,1
        SET VAR_004E,0
        NOP
    CASE_END
    CALL LABEL_0357
    IF VAR_004E = 0 THEN RETURN
    LOAD INITIAL_DATA
    IF 5,0 <> 60 THEN RETURN
    RETURN

LABEL_009C
    OUTPUT STR_0045    * "MOVE"
    OUTPUT STR_0050    * "S"
    CALL LABEL_044B
    CALL LABEL_0430
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_048A
    LOAD INPUT_DATA
    STORE VAR_005A
    CASE_OF 11,11
        CALL LABEL_0357
        CALL LABEL_00B0
    CASE_END
    OUTPUT STR_0032    * ","
    LOAD VAR_005A
    CASE_OF 11,11
        CALL LABEL_00B0
        CALL LABEL_0357
    CASE_END
    RETURN

LABEL_00B0
    LOAD VAR_005A
    CASE_OF 15,15
        OUTPUT STR_0033    * "D"
        OUTPUT STR_0034    * "A"
    CASE_END
    AND 000007000H
    ROTATE RIGHT,12
    OUTPUT ACCUMULATOR,FMT_005A    * 3,DEC,1
    RETURN

LABEL_00B9
    IF 5,3 = 1 THEN GOTO LABEL_00D2
    CALL LABEL_00C1
    POSITION ABS,9
    CALL LABEL_0490
    OUTPUT STR_0032    * ","
    GOTO LABEL_0357

LABEL_00C1
    OUTPUT STR_0035    * "B"
    CASE_OF 7,6
        OUTPUT "TST"
        OUTPUT "CHG"
        OUTPUT STR_0043    * "CLR"
        OUTPUT "SET"
    CASE_END
    OUTPUT STR_0053    * "."
    IF 5,3 = 0 THEN GOTO LABEL_00CF
    OUTPUT STR_0035    * "B"
    SET VAR_003A,0
    RETURN

LABEL_00CF
    OUTPUT STR_0037    * "L"
    SET VAR_003A,2
    RETURN

LABEL_00D2
    OUTPUT STR_0045    * "MOVE"
    OUTPUT "P."
    CASE_OF 6,6
        OUTPUT STR_0036    * "W"
        OUTPUT STR_0037    * "L"
    CASE_END
    CASE_OF 6,6
        SET VAR_003A,1
        SET VAR_003A,2
    CASE_END
    SET VAR_0038,5
    POSITION ABS,9
    CASE_OF 7,7
        CALL LABEL_0366
        CALL LABEL_0490
    CASE_END
    LOAD INITIAL_DATA
    OUTPUT STR_0032    * ","
    CASE_OF 7,7
        CALL LABEL_0490
        CALL LABEL_0366
    CASE_END
    RETURN

LABEL_00E9
    CALL LABEL_00C1
    POSITION ABS,9
    OUTPUT STR_0038    * "#"
    CALL LABEL_0430
    IF INPUT_ERROR = 0 THEN GOTO LABEL_00F6
    LOAD VAR_003A
    CASE_OF 1,1
        OUTPUT "*"
        OUTPUT STR_004E    * "**"
    CASE_END
    GOTO LABEL_00FD

LABEL_00F6
    LOAD INPUT_DATA
    CASE_OF VAR_003A
        OUTPUT ACCUMULATOR,FMT_0060    * 3,HEX,1
        NOP
        OUTPUT ACCUMULATOR,FMT_0064    * 5,HEX,2
        NOP
    CASE_END

LABEL_00FD
    OUTPUT STR_0032    * ","
    GOTO LABEL_0357

LABEL_00FF
    OUTPUT STR_0045    * "MOVE"
    IF 8,6 = 1 THEN OUTPUT STR_0034    * "A"
    OUTPUT STR_0053    * "."
    CASE_OF 13,12
        NOP
        OUTPUT STR_0035    * "B"
        OUTPUT STR_0037    * "L"
        OUTPUT STR_0036    * "W"
    CASE_END
    CASE_OF 13,12
        NOP
        SET VAR_003A,0
        SET VAR_003A,2
        SET VAR_003A,1
    CASE_END
    POSITION ABS,9
    CALL LABEL_0357
    OUTPUT STR_0032    * ","
    LOAD INITIAL_DATA
    GOTO LABEL_0359

LABEL_0115
    IF 8,7 = 2 THEN GOTO LABEL_0485
    IF 8,8 = 1 THEN GOTO LABEL_013B
    IF 11,11 = 0 THEN GOTO LABEL_0148
    CASE_OF 10,9
        GOTO LABEL_0125
        GOTO LABEL_01B3
        GOTO LABEL_01BC
        GOTO LABEL_01C0
    CASE_END
    RETURN

LABEL_0125
    CASE_OF 7,6
        OUTPUT "NBCD.B"
        GOTO LABEL_012D
        GOTO LABEL_0188
        GOTO LABEL_0188
    CASE_END
    POSITION ABS,9
    GOTO LABEL_0357

LABEL_012D
    SET VAR_0050,0
    IF 5,3 <> 0 THEN SET VAR_0050,1
    CASE_OF VAR_0050
        OUTPUT "SWAP.W"
        OUTPUT "PEA.L"
    CASE_END
    POSITION ABS,9
    CASE_OF VAR_0050
        CALL LABEL_0492
        CALL LABEL_0357
    CASE_END
    RETURN

LABEL_013B
    CASE_OF 6,6
        OUTPUT "CHK.W"
        OUTPUT "LEA.L"
    CASE_END
    POSITION ABS,9
    CALL LABEL_0357
    LOAD INITIAL_DATA
    OUTPUT STR_0032    * ","
    CASE_OF 6,6
        CALL LABEL_0490
        CALL LABEL_048C
    CASE_END
    RETURN

LABEL_0148
    IF 7,6 = 3 THEN GOTO LABEL_0154
    CASE_OF 10,9
        OUTPUT "NEGX"
        OUTPUT STR_0043    * "CLR"
        OUTPUT "NEG"
        OUTPUT "NOT"
    CASE_END
    CALL LABEL_044B
    CALL LABEL_0357
    RETURN

LABEL_0154
    OUTPUT STR_0045    * "MOVE"
    OUTPUT STR_0053    * "."
    CASE_OF 10,9
        OUTPUT STR_0036    * "W"
        OUTPUT STR_0036    * "W"
        OUTPUT STR_0035    * "B"
        OUTPUT STR_0036    * "W"
    CASE_END
    CASE_OF 10,9
        SET VAR_003A,1
        SET VAR_003A,1
        SET VAR_003A,0
        SET VAR_003A,1
    CASE_END
    POSITION ABS,9
    CASE_OF 10,9
        OUTPUT STR_0048    * "SR"
        OUTPUT STR_004A    * "CCR"
        CALL LABEL_0357
        CALL LABEL_0357
    CASE_END
    OUTPUT STR_0032    * ","
    LOAD INITIAL_DATA
    CASE_OF 10,9
        CALL LABEL_0357
        CALL LABEL_0357
        OUTPUT STR_004A    * "CCR"
        OUTPUT STR_0048    * "SR"
    CASE_END
    LOAD INITIAL_DATA
    IF 10,9 < 2 THEN RETURN
    CASE_OF 5,3
        SET VAR_0054,1
        NOP
        SET VAR_0054,1
        SET VAR_0054,1
        SET VAR_0054,1
        SET VAR_0054,2
        SET VAR_0054,2
        CALL LABEL_0180
    CASE_END
    GOTO LABEL_04A0

LABEL_0180
    CASE_OF 2,0
        SET VAR_0054,2
        SET VAR_0054,3
        SET VAR_0054,2
        SET VAR_0054,2
        SET VAR_0054,2
    CASE_END
    RETURN

LABEL_0188
    IF 5,3 = 0 THEN GOTO LABEL_01AC

LABEL_018B
    OUTPUT STR_0045    * "MOVE"
    OUTPUT "M."
    CASE_OF 6,6
        OUTPUT STR_0036    * "W"
        OUTPUT STR_0037    * "L"
    CASE_END
    CALL LABEL_0430
    STORE VAR_0052
    IF INPUT_ERROR <> 0 THEN SET VAR_0052,0
    POSITION ABS,9
    LOAD INITIAL_DATA
    CASE_OF 10,10
        CALL LABEL_01A3
        CALL LABEL_0357
    CASE_END
    OUTPUT STR_0032    * ","
    LOAD INITIAL_DATA
    CASE_OF 10,10
        CALL LABEL_0357
        CALL LABEL_01A3
    CASE_END
    RETURN

LABEL_01A3
    OUTPUT "rm="
    LOAD VAR_0052
    IF 15,0 <> 0 THEN GOTO LABEL_01AA
    OUTPUT STR_002F    * "****"
    RETURN

LABEL_01AA
    OUTPUT ACCUMULATOR,FMT_0066    * 16,HEX,4
    RETURN

LABEL_01AC
    OUTPUT "EXT."
    CASE_OF 6,6
        OUTPUT STR_0036    * "W"
        OUTPUT STR_0037    * "L"
    CASE_END
    POSITION ABS,9
    GOTO LABEL_0492

LABEL_01B3
    IF 7,6 <> 3 THEN GOTO LABEL_01B8
    OUTPUT "TAS.B"
    GOTO LABEL_01BA

LABEL_01B8
    OUTPUT "TST"
    CALL LABEL_044B

LABEL_01BA
    POSITION ABS,9
    GOTO LABEL_0357

LABEL_01BC
    IF 7,7 = 0 THEN GOTO LABEL_0485
    GOTO LABEL_018B

LABEL_01C0
    CASE_OF 8,6
        GOTO LABEL_0485
        GOTO LABEL_01C8
        OUTPUT "JSR"
        OUTPUT "JMP"
    CASE_END
    POSITION ABS,9
    GOTO LABEL_0357

LABEL_01C8
    CASE_OF 5,4
        GOTO LABEL_021E
        GOTO LABEL_0225
        GOTO LABEL_0235
        NOP
    CASE_END
    IF 5,3 = 7 THEN GOTO LABEL_01F0
    CASE_OF 2,0
        OUTPUT "RESET"
        OUTPUT "NOP"
        OUTPUT "STOP"
        OUTPUT "RTE"
        GOTO LABEL_01E6
        OUTPUT "RTS"
        OUTPUT "TRAPV"
        OUTPUT "RTR"
    CASE_END
    IF 2,0 <> 2 THEN GOTO LABEL_0216
    POSITION ABS,9
    OUTPUT STR_0038    * "#"
    CALL LABEL_0430
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_0488
    OUTPUT ACCUMULATOR,FMT_0066    * 16,HEX,4
    RETURN

LABEL_01E6
    OUTPUT "RTD"
    POSITION ABS,9
    OUTPUT STR_0038    * "#"
    CALL LABEL_0430
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_0488
    LOAD INPUT_DATA
    OUTPUT ACCUMULATOR,FMT_0066    * 16,HEX,4
    RETURN

LABEL_01F0
    OUTPUT STR_0045    * "MOVE"
    OUTPUT "C.L"
    POSITION ABS,9
    CALL LABEL_0430
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_048A
    LOAD INPUT_DATA
    STORE VAR_005A
    LOAD INITIAL_DATA
    CASE_OF 0,0
        CALL LABEL_0205
        CALL LABEL_00B0
    CASE_END
    OUTPUT STR_0032    * ","
    LOAD INITIAL_DATA
    CASE_OF 0,0
        CALL LABEL_00B0
        CALL LABEL_0205
    CASE_END
    RETURN

LABEL_0205
    LOAD VAR_005A
    IF 11,0 = 0 THEN OUTPUT "SFC"
    IF 11,0 = 1 THEN OUTPUT "DFC"
    IF 11,0 = 000000800H THEN OUTPUT STR_004C    * "USP"
    IF 11,0 = 000000801H THEN OUTPUT "VBR"
    IF 10,1 <> 0 THEN GOTO LABEL_047F
    RETURN

LABEL_0216
    IF 2,0 < 3 THEN RETURN
    IF 2,0 = 6 THEN RETURN
    SET VAR_0054,1
    GOTO LABEL_04A0

LABEL_021E
    OUTPUT "TRAP"
    POSITION ABS,9
    OUTPUT STR_0038    * "#"
    AND 15
    OUTPUT ACCUMULATOR,FMT_005E    * 4,HEX,1
    SET VAR_0054,1
    GOTO LABEL_04A0

LABEL_0225
    CASE_OF 3,3
        OUTPUT "LINK"
        OUTPUT "UNLK"
    CASE_END
    POSITION ABS,9
    CALL LABEL_048E
    IF 3,3 = 1 THEN RETURN
    OUTPUT ",#"
    CALL LABEL_0430
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_0488
    OUTPUT ACCUMULATOR,FMT_0066    * 16,HEX,4
    RETURN

LABEL_0235
    OUTPUT STR_0045    * "MOVE"
    OUTPUT ".L"
    POSITION ABS,9
    CASE_OF 3,3
        CALL LABEL_048E
        OUTPUT STR_004C    * "USP"
    CASE_END
    OUTPUT STR_0032    * ","
    CASE_OF 3,3
        OUTPUT STR_004C    * "USP"
        CALL LABEL_048E
    CASE_END
    RETURN

LABEL_0242
    IF 7,6 <> 3 THEN GOTO LABEL_0262
    IF 5,3 = 1 THEN GOTO LABEL_024A
    OUTPUT STR_0050    * "S"
    GOTO LABEL_024B

LABEL_024A
    OUTPUT "DB"

LABEL_024B
    CALL LABEL_0462
    IF 5,3 = 1 THEN GOTO LABEL_0252
    OUTPUT ".B"
    POSITION ABS,9
    GOTO LABEL_0357

LABEL_0252
    POSITION ABS,9
    OUTPUT STR_0033    * "D"
    OUTPUT ACCUMULATOR,FMT_005A    * 3,DEC,1
    OUTPUT STR_0032    * ","
    CALL LABEL_0430
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_0488
    IF 15,15 = 1 THEN INCLUSIVE_OR 000FF0000H
    ADD INPUT_ADDRESS

LABEL_025E
    AND CONST_0064
    IF_NOT_MAPPED THEN OUTPUT ACCUMULATOR,FMT_006A    * 24,HEX,6
    RETURN

LABEL_0262
    CASE_OF 8,8
        OUTPUT "ADDQ"
        OUTPUT "SUBQ"
    CASE_END
    CALL LABEL_044B
    CALL LABEL_0458
    OUTPUT STR_0032    * ","
    GOTO LABEL_0357

LABEL_026A
    OUTPUT STR_0035    * "B"
    CALL LABEL_0462
    IF 7,0 <> 0 THEN GOTO LABEL_027A
    OUTPUT ".W"
    SET VAR_003A,1
    CALL LABEL_0430
    IF 15,15 = 1 THEN INCLUSIVE_OR 000FF0000H
    IF INPUT_ERROR = 0 THEN GOTO LABEL_0280
    OUTPUT "********"
    RETURN

LABEL_027A
    OUTPUT ".B"
    SET VAR_003A,0
    AND CONST_0060
    IF 7,7 = 1 THEN INCLUSIVE_OR 000FFFF00H

LABEL_0280
    POSITION ABS,9
    ADD INPUT_ADDRESS
    AND CONST_0064
    IF VAR_003A = 0 THEN ADD 2
    CALL LABEL_025E
    LOAD INITIAL_DATA
    IF 15,9 <> 48 THEN RETURN
    IF 7,0 = 0 THEN RETURN
    SET VAR_0054,1
    GOTO LABEL_04A0

LABEL_0290
    OUTPUT STR_0045    * "MOVE"
    OUTPUT "Q.L"
    POSITION ABS,9
    AND CONST_0060
    IF 7,7 = 1 THEN INCLUSIVE_OR 0FFFFFF00H
    OUTPUT STR_0038    * "#"
    OUTPUT ACCUMULATOR,FMT_006C    * 32,HEX,8
    OUTPUT STR_0032    * ","
    GOTO LABEL_0490

LABEL_029B
    CASE_OF 14,14
        OUTPUT STR_003D    * "SUB"
        OUTPUT STR_0041    * "ADD"
    CASE_END
    IF 7,6 = 3 THEN GOTO LABEL_02B5
    IF 8,8 <> 1 THEN GOTO LABEL_02A8
    IF 5,4 = 0 THEN GOTO LABEL_0496

LABEL_02A8
    CALL LABEL_044B
    POSITION ABS,9
    CASE_OF 8,8
        CALL LABEL_0357
        CALL LABEL_0490
    CASE_END
    OUTPUT STR_0032    * ","
    LOAD INITIAL_DATA
    CASE_OF 8,8
        CALL LABEL_0490
        CALL LABEL_0357
    CASE_END
    RETURN

LABEL_02B5
    OUTPUT "A."

LABEL_02B6
    CASE_OF 8,8
        OUTPUT STR_0036    * "W"
        OUTPUT STR_0037    * "L"
    CASE_END
    CASE_OF 8,8
        SET VAR_003A,1
        SET VAR_003A,2
    CASE_END
    POSITION ABS,9
    CALL LABEL_0357
    OUTPUT STR_0032    * ","
    LOAD INITIAL_DATA
    GOTO LABEL_048C

LABEL_02C3
    IF 7,6 = 3 THEN GOTO LABEL_02CE
    IF 8,8 = 1 THEN GOTO LABEL_02D0
    OUTPUT "CMP"
    CALL LABEL_044B
    CALL LABEL_0357
    OUTPUT STR_0032    * ","
    GOTO LABEL_0490

LABEL_02CE
    OUTPUT "CMPA."
    GOTO LABEL_02B6

LABEL_02D0
    IF 5,3 <> 1 THEN GOTO LABEL_02DD
    OUTPUT "CMPM"
    CALL LABEL_044B
    POSITION ABS,9
    OUTPUT "[xx]+,[xx]+"
    POSITION REL,-10
    CALL LABEL_048E
    POSITION REL,4
    CALL LABEL_048C
    POSITION REL,2
    RETURN

LABEL_02DD
    OUTPUT STR_003F    * "EOR"
    CALL LABEL_044B
    CALL LABEL_0490
    OUTPUT STR_0032    * ","
    GOTO LABEL_0357

LABEL_02E2
    IF 7,6 = 3 THEN GOTO LABEL_02F6
    IF 14,14 = 0 THEN GOTO LABEL_02EE
    IF 8,4 = 20 THEN GOTO LABEL_0315
    IF 8,4 = 24 THEN GOTO LABEL_0315

LABEL_02EE
    IF 8,4 = 16 THEN GOTO LABEL_0303
    CASE_OF 14,14
        OUTPUT STR_0039    * "OR"
        OUTPUT STR_003B    * "AND"
    CASE_END
    GOTO LABEL_02A8

LABEL_02F6
    CASE_OF 14,14
        OUTPUT "DIV"
        OUTPUT "MUL"
    CASE_END
    CASE_OF 8,8
        OUTPUT "U"
        OUTPUT STR_0050    * "S"
    CASE_END
    OUTPUT ".W"
    POSITION ABS,9
    CALL LABEL_0357
    OUTPUT STR_0032    * ","
    GOTO LABEL_0490

LABEL_0303
    CASE_OF 14,14
        OUTPUT STR_0050    * "S"
        OUTPUT STR_0034    * "A"
    CASE_END
    OUTPUT "BCD.B"
    POSITION ABS,9
    IF 3,3 = 0 THEN GOTO LABEL_0312
    OUTPUT "-["
    CALL LABEL_048E
    OUTPUT "],-["
    CALL LABEL_048C
    OUTPUT STR_0051    * "]"
    RETURN

LABEL_0312
    CALL LABEL_0492
    OUTPUT STR_0032    * ","
    GOTO LABEL_0490

LABEL_0315
    OUTPUT "EXG.L"
    POSITION ABS,9
    IF 7,3 = 8 THEN SET VAR_0050,0
    IF 7,3 = 9 THEN SET VAR_0050,1
    IF 7,3 = 17 THEN SET VAR_0050,2
    CASE_OF VAR_0050
        CALL LABEL_0490
        CALL LABEL_048C
        CALL LABEL_0490
        NOP
    CASE_END
    OUTPUT STR_0032    * ","
    LOAD INITIAL_DATA
    CASE_OF VAR_0050
        CALL LABEL_0492
        CALL LABEL_048E
        CALL LABEL_048E
        NOP
    CASE_END
    RETURN

LABEL_032F
    IF 7,6 = 3 THEN GOTO LABEL_0345
    CASE_OF 4,3
        OUTPUT "AS"
        OUTPUT "LS"
        OUTPUT "ROX"
        OUTPUT "RO"
    CASE_END
    CASE_OF 8,8
        OUTPUT STR_0052    * "R"
        OUTPUT STR_0037    * "L"
    CASE_END
    CALL LABEL_044B
    IF 5,5 = 1 THEN GOTO LABEL_0342
    CALL LABEL_0458
    GOTO LABEL_0343

LABEL_0342
    CALL LABEL_0490

LABEL_0343
    OUTPUT STR_0032    * ","
    GOTO LABEL_0492

LABEL_0345
    CASE_OF 10,9
        OUTPUT "AS"
        OUTPUT "LS"
        OUTPUT "ROX"
        OUTPUT "RO"
    CASE_END
    CASE_OF 8,8
        OUTPUT STR_0052    * "R"
        OUTPUT STR_0037    * "L"
    CASE_END
    OUTPUT ".W"
    SET VAR_003A,1
    POSITION ABS,9
    GOTO LABEL_0357

LABEL_0353
    OUTPUT "Unimplemented Instruction:"
    OUTPUT ACCUMULATOR,FMT_0066    * 16,HEX,4
    SET VAR_0054,1
    GOTO LABEL_04A0

LABEL_0357
    SET VAR_0034,1
    GOTO LABEL_035A

LABEL_0359
    SET VAR_0034,0

LABEL_035A
    LOAD INITIAL_DATA
    CASE_OF VAR_0034
        ROTATE RIGHT,6
        ROTATE RIGHT,3
    CASE_END
    AND 7
    STORE VAR_0038
    LOAD INITIAL_DATA
    CASE_OF VAR_0034
        ROTATE RIGHT,9
        NOP
    CASE_END

LABEL_0366
    AND 7
    STORE VAR_0036
    CASE_OF VAR_0038
        OUTPUT STR_0033    * "D"
        OUTPUT STR_0034    * "A"
        OUTPUT "[A"
        OUTPUT "[A"
        OUTPUT "-[A"
        GOTO LABEL_0380
        GOTO LABEL_0387
        GOTO LABEL_03A8
    CASE_END
    LOAD VAR_0036
    OUTPUT ACCUMULATOR,FMT_005A    * 3,DEC,1
    LOAD INITIAL_DATA
    CASE_OF VAR_0038
        RETURN
        RETURN
        OUTPUT STR_0051    * "]"
        OUTPUT "]+"
        OUTPUT STR_0051    * "]"
        NOP
        NOP
        NOP
    CASE_END
    RETURN

LABEL_0380
    CALL LABEL_042A
    OUTPUT "[A"
    LOAD VAR_0036
    OUTPUT ACCUMULATOR,FMT_005A    * 3,DEC,1
    OUTPUT STR_0051    * "]"
    LOAD INITIAL_DATA
    RETURN

LABEL_0387
    CALL LABEL_0430
    IF INPUT_ERROR = 0 THEN GOTO LABEL_0390
    OUTPUT "**[A"
    LOAD VAR_0036
    OUTPUT ACCUMULATOR,FMT_005A    * 3,DEC,1
    OUTPUT ",**.*]"
    RETURN

LABEL_0390
    AND CONST_0060
    OUTPUT ACCUMULATOR,FMT_0062    * 8,HEX,2
    OUTPUT "["
    LOAD INPUT_DATA
    OUTPUT STR_0034    * "A"
    LOAD VAR_0036
    OUTPUT ACCUMULATOR,FMT_005A    * 3,DEC,1
    OUTPUT STR_0032    * ","
    CASE_OF 15,15
        OUTPUT STR_0033    * "D"
        OUTPUT STR_0034    * "A"
    CASE_END
    LOAD INPUT_DATA
    ROTATE RIGHT,12
    OUTPUT ACCUMULATOR,FMT_005A    * 3,DEC,1
    OUTPUT STR_0053    * "."
    LOAD INPUT_DATA
    CASE_OF 11,11
        OUTPUT STR_0036    * "W"
        OUTPUT STR_0037    * "L"
    CASE_END
    OUTPUT STR_0051    * "]"
    LOAD INITIAL_DATA
    RETURN

LABEL_03A8
    CASE_OF VAR_0036
        GOTO LABEL_03B0
        GOTO LABEL_03BA
        GOTO LABEL_03DE
        GOTO LABEL_03E9
        GOTO LABEL_0405
    CASE_END
    GOTO LABEL_047F

LABEL_03B0
    CALL LABEL_0430
    IF INPUT_ERROR = 0 THEN GOTO LABEL_03B6
    OUTPUT "******"
    RETURN

LABEL_03B6
    IF 15,15 = 1 THEN INCLUSIVE_OR 000FF0000H
    GOTO LABEL_025E

LABEL_03BA
    CALL LABEL_0430
    STORE VAR_0048
    SET VAR_0046,0
    IF INPUT_ERROR <> 0 THEN SET VAR_0046,1
    CALL LABEL_0430
    STORE VAR_004A
    LOAD VAR_0046
    IF INPUT_ERROR <> 0 THEN INCLUSIVE_OR 2
    STORE VAR_0046
    IF VAR_0046 = 0 THEN GOTO LABEL_03D9
    LOAD VAR_0048
    CASE_OF VAR_0046
        NOP
        OUTPUT STR_002F    * "****"
        OUTPUT ACCUMULATOR,FMT_0066    * 16,HEX,4
        OUTPUT STR_002F    * "****"
    CASE_END
    LOAD VAR_004A
    CASE_OF VAR_0046
        NOP
        OUTPUT ACCUMULATOR,FMT_0066    * 16,HEX,4
        OUTPUT STR_002F    * "****"
        OUTPUT STR_002F    * "****"
    CASE_END
    RETURN

LABEL_03D9
    LOAD VAR_0048
    AND 0000000FFH
    ROTATE LEFT,16
    INCLUSIVE_OR VAR_004A
    GOTO LABEL_025E

LABEL_03DE
    CALL LABEL_0430
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_0488
    IF 15,15 = 1 THEN INCLUSIVE_OR 000FF0000H
    ADD INPUT_ADDRESS
    CALL LABEL_025E
    OUTPUT "[PC]"
    RETURN

LABEL_03E9
    CALL LABEL_0430
    IF INPUT_ERROR = 0 THEN GOTO LABEL_03EF
    OUTPUT "**[PC,**.*]"
    RETURN

LABEL_03EF
    AND 0000000FFH
    IF 7,7 = 1 THEN INCLUSIVE_OR 000FFFF00H
    ADD INPUT_ADDRESS
    CALL LABEL_025E
    LOAD INPUT_DATA
    OUTPUT "[PC,"
    CASE_OF 15,15
        OUTPUT STR_0033    * "D"
        OUTPUT STR_0034    * "A"
    CASE_END
    ROTATE RIGHT,12
    OUTPUT ACCUMULATOR,FMT_005A    * 3,DEC,1
    OUTPUT STR_0053    * "."
    LOAD INPUT_DATA
    CASE_OF 11,11
        OUTPUT STR_0036    * "W"
        OUTPUT STR_0037    * "L"
    CASE_END
    OUTPUT STR_0051    * "]"
    RETURN

LABEL_0405
    IF VAR_004E = 0 THEN GOTO LABEL_040F
    CASE_OF VAR_003A
        OUTPUT STR_004A    * "CCR"
        OUTPUT STR_0048    * "SR"
        GOTO LABEL_047F
        GOTO LABEL_047F
    CASE_END
    RETURN

LABEL_040F
    OUTPUT STR_0038    * "#"
    CALL LABEL_0430
    IF INPUT_ERROR = 0 THEN GOTO LABEL_041B
    CASE_OF VAR_003A
        OUTPUT STR_004E    * "**"
        OUTPUT STR_002F    * "****"
        OUTPUT STR_002F    * "****"
        GOTO LABEL_0485
    CASE_END
    GOTO LABEL_0421

LABEL_041B
    CASE_OF VAR_003A
        OUTPUT ACCUMULATOR,FMT_0062    * 8,HEX,2
        OUTPUT ACCUMULATOR,FMT_0066    * 16,HEX,4
        OUTPUT ACCUMULATOR,FMT_0066    * 16,HEX,4
        GOTO LABEL_0485
    CASE_END

LABEL_0421
    IF VAR_003A <> 2 THEN RETURN
    CALL LABEL_0430
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_0488
    OUTPUT ACCUMULATOR,FMT_0066    * 16,HEX,4
    RETURN

LABEL_042A
    CALL LABEL_0430
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_0488
    OUTPUT ACCUMULATOR,FMT_0066    * 16,HEX,4
    RETURN

LABEL_0430
    INCREMENT VAR_0056
    INCREMENT VAR_0056
    CALL LABEL_0439
    CALL LABEL_043B
    IF INPUT_ERROR = 0 THEN TAG_WITH 2
    LOAD INPUT_DATA
    RETURN

LABEL_0439
    INPUT ABS,VAR_0056,QUALIFIED
    RETURN

LABEL_043B
    IF TASK = 3 THEN RETURN
    IF VAR_0044 = 1 THEN SET INPUT_ERROR,1
    IF INPUT_ERROR <> 0 THEN RETURN
    LOAD INPUT_TAG
    IF 17,16 <> 3 THEN RETURN
    SET VAR_0044,1
    SET INPUT_ERROR,1
    RETURN

LABEL_044B
    OUTPUT STR_0053    * "."
    CASE_OF 7,6
        OUTPUT STR_0035    * "B"
        OUTPUT STR_0036    * "W"
        OUTPUT STR_0037    * "L"
        GOTO LABEL_047F
    CASE_END
    ROTATE RIGHT,6
    AND 3
    STORE VAR_003A
    LOAD INITIAL_DATA
    POSITION ABS,9
    RETURN

LABEL_0458
    OUTPUT STR_0038    * "#"
    IF 11,9 <> 0 THEN GOTO LABEL_045E
    OUTPUT "8"
    RETURN

LABEL_045E
    ROTATE RIGHT,9
    OUTPUT ACCUMULATOR,FMT_005A    * 3,DEC,1
    LOAD INITIAL_DATA
    RETURN

LABEL_0462
    CASE_OF 11,8
        GOTO LABEL_0475
        GOTO LABEL_047A
        OUTPUT "HI"
        OUTPUT "LS"
        OUTPUT "CC"
        OUTPUT "CS"
        OUTPUT "NE"
        OUTPUT "EQ"
        OUTPUT "VC"
        OUTPUT "VS"
        OUTPUT "PL"
        OUTPUT "MI"
        OUTPUT "GE"
        OUTPUT "LT"
        OUTPUT "GT"
        OUTPUT "LE"
    CASE_END
    RETURN

LABEL_0475
    CASE_OF 12,12
        OUTPUT "RA"
        OUTPUT "T"
    CASE_END
    RETURN

LABEL_047A
    CASE_OF 12,12
        OUTPUT STR_0048    * "SR"
        OUTPUT "F"
    CASE_END
    RETURN

LABEL_047F
    POSITION ABS,9
    OUTPUT STR_0054    * "Illegal"
    OUTPUT " Operand    "
    ABORT

LABEL_0483
    OUTPUT "Data Error"
    ABORT

LABEL_0485
    OUTPUT STR_0054    * "Illegal"
    OUTPUT " Opcode"
    ABORT

LABEL_0488
    OUTPUT STR_002F    * "****"
    RETURN

LABEL_048A
    OUTPUT "incomplete opcode"
    ABORT

LABEL_048C
    LOAD INITIAL_DATA
    ROTATE RIGHT,9

LABEL_048E
    OUTPUT STR_0034    * "A"
    GOTO LABEL_0493

LABEL_0490
    LOAD INITIAL_DATA
    ROTATE RIGHT,9

LABEL_0492
    OUTPUT STR_0033    * "D"

LABEL_0493
    OUTPUT ACCUMULATOR,FMT_005A    * 3,DEC,1
    LOAD INITIAL_DATA
    RETURN

LABEL_0496
    OUTPUT "X"
    CALL LABEL_044B
    CASE_OF 3,3
        SET VAR_0038,0
        SET VAR_0038,4
    CASE_END
    CALL LABEL_0366
    ROTATE RIGHT,9
    OUTPUT STR_0032    * ","
    GOTO LABEL_0366

LABEL_04A0
    INPUT REL,VAR_0054,QUALIFIED
    CALL LABEL_043B
    IF INPUT_ERROR <> 0 THEN RETURN
    LOAD VAR_0056
    ADD 2
    SUBTRACT INPUT_ADDRESS
    IF 31,0 <> 0 THEN RETURN
    TAG_WITH 1
    RETURN

LABEL_04AD
    OUTPUT "unknown ("
    AND 000000070H
    ROTATE RIGHT,4
    OUTPUT ACCUMULATOR,FMT_0058    * 3,BIN,3
    OUTPUT ")"
    LOAD INPUT_STATUS
    RETURN

LABEL_04B4
    LOAD INPUT_ADDRESS
    SET VAR_004C,1
    IF 23,4 <> VAR_005E THEN GOTO LABEL_04BC
    OUTPUT "int_ack"
    LOAD INPUT_STATUS
    RETURN

LABEL_04BC
    SET VAR_004C,0
    OUTPUT "cpu space"
    LOAD INPUT_STATUS
    RETURN
