"IAL"

*
* Original Source File Name: d:\ial\procs\i80286_i.s
*

CONST_0034      CONSTANT 0000000FFH
CONST_0036      CONSTANT 000000081H
STR_0000        ASCII ","
STR_0001        ASCII "OUT"
STR_0003        ASCII "IN"
STR_0005        ASCII "xx"
STR_0007        ASCII "**"
STR_0009        ASCII "JMP"
STR_000B        ASCII "MOV"
STR_000D_UNREF  ASCII "RET"
STR_000F        ASCII "code fetch"
STR_0015        ASCII "*"
STR_0016        ASCII "INC"
STR_0018        ASCII "DEC"
STR_001A        ASCII "POP"
STR_001C        ASCII "PUSH"
STR_001F        ASCII "CALL"
STR_0022        ASCII "ADD"
STR_0024        ASCII "SUB"
STR_0026        ASCII "CMP"
STR_0028        ASCII "dwp "
STR_002B        ASCII "reserved"
STR_0030        ASCII "not status"
STR_0036        ASCII "XCHG"
STR_0039        ASCII "S"
STR_003A        ASCII "TEST"
STR_003D        ASCII "RET(near)"
STR_0042        ASCII "RET(far)"
STR_0047        ASCII "INT"
STR_0049        ASCII "#"
STR_004A        ASCII "MUL"
STR_004C        ASCII "COM"
STR_004E        ASCII "COMP"
STR_0051        ASCII "DIV"
STR_0053        ASCII " "
STR_0054        ASCII "P"
STR_0055        ASCII "F"
STR_0056        ASCII "SUBR"
STR_0059        ASCII "DIVR"
STR_005C        ASCII "I"
STR_005D        ASCII " - 80287"
VAR_0038        VARIABLE 000000000H
VAR_003A        VARIABLE 000000000H
VAR_003C        VARIABLE 000000000H
VAR_003E        VARIABLE 000000000H
VAR_0040        VARIABLE 000000000H
VAR_0042        VARIABLE 000000000H
VAR_0044        VARIABLE 000000000H
VAR_0046        VARIABLE 000000000H
VAR_0048        VARIABLE 000000000H
VAR_004A_UNREF  VARIABLE 000000000H
VAR_004C        VARIABLE 000000000H
VAR_004E        VARIABLE 000000000H
VAR_0050        VARIABLE 000000000H
VAR_0052_UNREF  VARIABLE 000000000H
VAR_0054        VARIABLE 000000000H
VAR_0056        VARIABLE 000000000H
VAR_0058        VARIABLE 000000000H
VAR_005A        VARIABLE 000000000H
VAR_005C        VARIABLE 000000000H
VAR_005E        VARIABLE 000000039H
VAR_0060        VARIABLE 000000038H
VAR_0062        VARIABLE 000000038H
VAR_0064        VARIABLE 000000030H
VAR_0066        VARIABLE 000000011H
VAR_0068        VARIABLE 000000018H
VAR_006A        VARIABLE 000000000H
VAR_006C        VARIABLE 000000000H
VAR_006E        VARIABLE 000000000H
VAR_0070        VARIABLE 000000000H
FMT_0062        FORMAT 8,HEX,2
FMT_0064        FORMAT 16,HEX,4
FMT_0066        FORMAT 20,HEX,5
FMT_0068_UNREF  FORMAT 3,OCT,1
FMT_006A        FORMAT 8,DEC,LEFT_JUSTIFIED
FMT_006C        FORMAT 16,DEC,LEFT_JUSTIFIED
        LABEL_TITLE      "80286 Mnemonic"
        BASE_TITLE       "     hex"
        DEFAULT_WIDTH    39
        MAPPED_WIDTH     39
        SEARCH_LIMIT     5

ENTRY_POINT
    LOAD INPUT_STATUS
    STORE VAR_006C
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_059C
    LOAD INPUT_DATA
    STORE VAR_0058
    LOAD INPUT_ADDRESS
    STORE VAR_006E
    SET VAR_0040,0
    SET RETURN_FLAGS,0
    SET VAR_0054,0
    SET VAR_005A,1
    SET VAR_005C,0
    SET VAR_006A,0
    SET VAR_0070,0
    LOAD 57
    STORE VAR_005E
    LOAD 56
    STORE VAR_0060
    LOAD 56
    STORE VAR_0062
    LOAD 48
    STORE VAR_0064
    LOAD 17
    STORE VAR_0066
    LOAD 24
    STORE VAR_0068
    IF TASK = 3 THEN GOTO LABEL_003D
    IF TASK = 5 THEN GOTO LABEL_003D
    IF TASK = 4 THEN GOTO LABEL_0027
    OUTPUT "Illegal Task Request"
    RETURN

LABEL_0027
    LOAD 0
    STORE ID_CODE
    LOAD INPUT_STATUS
    AND 3
    STORE VAR_0038
    LOAD INPUT_STATUS
    AND 00000007CH
    ROTATE LEFT,1
    INCLUSIVE_OR VAR_0038
    STORE INPUT_STATUS
    LOAD 29
    STORE VAR_005E
    LOAD 28
    STORE VAR_0060
    LOAD 28
    STORE VAR_0062
    LOAD 24
    STORE VAR_0064
    LOAD 9
    STORE VAR_0066
    LOAD 12
    STORE VAR_0068

LABEL_003D
    LOAD 0
    IF TASK = 5 THEN STORE ID_CODE
    LOAD INPUT_STATUS
    EXTRACT_BIT 0
    STORE VAR_0038
    LOAD INPUT_STATUS
    ROTATE RIGHT,2
    AND 14
    INCLUSIVE_OR VAR_0038
    STORE VAR_0038
    LOAD VAR_0038
    IF 3,0 = 14 THEN GOTO LABEL_008F

LABEL_004D
    POSITION ABS,5
    LOAD INPUT_DATA
    OUTPUT ACCUMULATOR,FMT_0064    * 16,HEX,4
    LOAD ID_CODE
    IF 7,0 <> CONST_0036 THEN GOTO LABEL_005C
    LOAD INPUT_STATUS
    CASE_OF 2,1
        LOAD 0
        LOAD 2
        LOAD 0
        LOAD 1
    CASE_END
    GOTO LABEL_0062

LABEL_005C
    LOAD INPUT_ADDRESS
    EXTRACT_BIT 0
    STORE VAR_003A
    LOAD INPUT_STATUS
    AND 2
    INCLUSIVE_OR VAR_003A

LABEL_0062
    POSITION ABS,5
    CASE_OF 1,0
        GOTO LABEL_006A
        POSITION REL,2
        NOP
        GOTO LABEL_006A
    CASE_END
    OUTPUT STR_0005    * "xx"

LABEL_006A
    SET RETURN_FLAGS,0
    POSITION ABS,10
    LOAD VAR_0038
    CASE_OF 3,0
        OUTPUT "interrupt ack"
        OUTPUT STR_002B    * "reserved"
        OUTPUT STR_002B    * "reserved"
        OUTPUT STR_0030    * "not status"
        GOTO LABEL_0080
        OUTPUT "memory write"
        OUTPUT "memory read"
        OUTPUT STR_0030    * "not status"
        OUTPUT STR_002B    * "reserved"
        GOTO LABEL_0086
        GOTO LABEL_0086
        OUTPUT STR_0030    * "not status"
        OUTPUT STR_002B    * "reserved"
        OUTPUT STR_002B    * "reserved"
        OUTPUT STR_000F    * "code fetch"
        OUTPUT STR_0030    * "not status"
    CASE_END
    RETURN

LABEL_0080
    LOAD INPUT_ADDRESS
    CASE_OF 1,1
        OUTPUT "shutdown"
        OUTPUT "halt"
    CASE_END
    RETURN

LABEL_0086
    CASE_OF 1,1
        OUTPUT "i/o write"
        OUTPUT "i/o read "
    CASE_END
    LOAD INPUT_ADDRESS
    IF 15,3 = 31 THEN OUTPUT STR_005D    * " - 80287"
    RETURN

LABEL_008F
    LOAD INPUT_TAG
    IF 17,16 = 0 THEN GOTO LABEL_004D
    LOAD INPUT_TAG
    IF 1,0 = 3 THEN GOTO LABEL_00C8
    LOAD INPUT_ADDRESS
    IF 0,0 = 0 THEN GOTO LABEL_00A0
    TAG_WITH 1
    SET VAR_0056,0
    LOAD INPUT_DATA
    ROTATE RIGHT,8
    GOTO LABEL_00AB

LABEL_00A0
    LOAD INPUT_TAG
    EXTRACT_BIT 0
    STORE VAR_0038
    CASE_OF VAR_0038
        SET VAR_0056,1
        SET VAR_0056,0
    CASE_END
    LOAD VAR_0058
    IF VAR_0038 = 1 THEN ROTATE RIGHT,8

LABEL_00AB
    AND CONST_0034
    STORE INPUT_DATA
    LOAD ID_CODE
    IF 7,0 = CONST_0036 THEN GOTO LABEL_00CE
    IF TASK = 4 THEN GOTO LABEL_00BA
    LOAD 56
    STORE VAR_0062
    STORE VAR_0060
    LOAD 57
    STORE VAR_005E
    GOTO LABEL_00CE

LABEL_00BA
    LOAD 28
    STORE VAR_0062
    STORE VAR_0060
    LOAD 29
    STORE VAR_005E
    GOTO LABEL_00CE
    LOAD INPUT_TAG
    IF 1,0 = 3 THEN GOTO LABEL_00C8
    LOAD INPUT_STATUS
    IF 5,5 = 0 THEN GOTO LABEL_00CE

LABEL_00C8
    POSITION ABS,5
    LOAD INPUT_DATA
    OUTPUT ACCUMULATOR,FMT_0064    * 16,HEX,4
    POSITION REL,1
    OUTPUT STR_000F    * "code fetch"
    RETURN

LABEL_00CE
    POSITION ABS,3
    IF VAR_0056 = 1 THEN GOTO LABEL_00DA
    OUTPUT " "
    SET VAR_006A,1
    LOAD INPUT_ADDRESS
    IF 0,0 = 0 THEN ADD 1
    STORE INPUT_ADDRESS
    STORE VAR_006E

LABEL_00DA
    SET RETURN_FLAGS,1
    LOAD INPUT_DATA
    STORE VAR_0042
    CASE_OF 7,4
        GOTO LABEL_00EF
        GOTO LABEL_00EF
        GOTO LABEL_00EF
        GOTO LABEL_00EF
        GOTO LABEL_0184
        GOTO LABEL_018B
        GOTO LABEL_0192
        GOTO LABEL_01D1
        GOTO LABEL_01E7
        GOTO LABEL_024B
        GOTO LABEL_026E
        GOTO LABEL_0295
        GOTO LABEL_02A1
        GOTO LABEL_030C
        GOTO LABEL_042F
        GOTO LABEL_044F
    CASE_END

LABEL_00EF
    IF 2,0 >= 6 THEN GOTO LABEL_00FC
    CASE_OF 3,3
        CALL LABEL_04E2
        CALL LABEL_04E9
    CASE_END
    CALL LABEL_062D
    CASE_OF 2,2
        CALL LABEL_04F0
        CALL LABEL_059F
    CASE_END
    GOTO LABEL_04B1

LABEL_00FC
    IF 2,0 = 6 THEN GOTO LABEL_0106
    IF 3,0 = 7 THEN GOTO LABEL_0118
    IF 3,0 = 15 THEN GOTO LABEL_0127
    GOTO LABEL_0596

LABEL_0106
    IF 5,5 = 1 THEN GOTO LABEL_010D
    OUTPUT STR_001C    * "PUSH"
    CALL LABEL_062A
    CALL LABEL_04DA
    GOTO LABEL_04B1

LABEL_010D
    STORE VAR_0040
    CALL LABEL_0570
    IF INPUT_ERROR = 0 THEN GOTO LABEL_0117
    OUTPUT "***"
    CALL LABEL_062D
    CALL LABEL_05A6
    OUTPUT STR_0015    * "*"
    GOTO LABEL_04B1

LABEL_0117
    GOTO LABEL_00DA

LABEL_0118
    CASE_OF 5,4
        OUTPUT STR_001A    * "POP"
        OUTPUT STR_001A    * "POP"
        OUTPUT "DAA"
        OUTPUT "AAA"
    CASE_END
    IF VAR_0056 = 1 THEN SET VAR_005C,1
    IF 5,5 = 1 THEN GOTO LABEL_04B1
    CALL LABEL_062D
    CALL LABEL_04DA
    GOTO LABEL_04B1

LABEL_0127
    CASE_OF 5,4
        GOTO LABEL_0133
        OUTPUT STR_001A    * "POP"
        OUTPUT "DAS"
        OUTPUT "AAS"
    CASE_END
    IF 5,5 = 1 THEN GOTO LABEL_04AE
    CALL LABEL_062A
    OUTPUT "DS"
    GOTO LABEL_04B1

LABEL_0133
    CALL LABEL_0572
    IF INPUT_ERROR = 0 THEN GOTO LABEL_013B
    OUTPUT "2byte"
    CALL LABEL_062D
    OUTPUT STR_0015    * "*"
    GOTO LABEL_04B1

LABEL_013B
    IF 7,4 <> 0 THEN GOTO LABEL_0596
    IF 3,3 <> 0 THEN GOTO LABEL_0596
    CASE_OF 2,0
        GOTO LABEL_014B
        GOTO LABEL_0162
        GOTO LABEL_0179
        GOTO LABEL_0179
        GOTO LABEL_0596
        GOTO LABEL_0596
        GOTO LABEL_0182
        GOTO LABEL_0596
    CASE_END

LABEL_014B
    CALL LABEL_0572
    IF INPUT_ERROR = 0 THEN GOTO LABEL_0153
    OUTPUT "2byte Grp1"
    CALL LABEL_062D
    OUTPUT STR_0015    * "*"
    GOTO LABEL_04B1

LABEL_0153
    CASE_OF 5,3
        OUTPUT "SLDT"
        OUTPUT "STR"
        OUTPUT "LLDT"
        OUTPUT "LTR"
        OUTPUT "VERR"
        OUTPUT "VERW"
        GOTO LABEL_0599
        GOTO LABEL_0599
    CASE_END
    CALL LABEL_062D
    SET VAR_0054,0
    SET VAR_003E,1
    CALL LABEL_0512
    GOTO LABEL_04B1

LABEL_0162
    CALL LABEL_0572
    IF INPUT_ERROR = 0 THEN GOTO LABEL_016A
    OUTPUT "2byte Grp2"
    CALL LABEL_062D
    OUTPUT STR_0015    * "*"
    GOTO LABEL_04B1

LABEL_016A
    CASE_OF 5,3
        OUTPUT "SGDT"
        OUTPUT "SIDT"
        OUTPUT "LGDT"
        OUTPUT "LIDT"
        OUTPUT "SMSW"
        GOTO LABEL_0599
        OUTPUT "LMSW"
        GOTO LABEL_0599
    CASE_END
    CALL LABEL_062D
    SET VAR_0054,0
    SET VAR_003E,1
    CALL LABEL_0512
    GOTO LABEL_04B1

LABEL_0179
    CASE_OF 0,0
        OUTPUT "LAR"
        OUTPUT "LSL"
    CASE_END
    CALL LABEL_062D
    SET VAR_0054,0
    SET VAR_003E,1
    CALL LABEL_0506
    GOTO LABEL_04B1

LABEL_0182
    OUTPUT "CLTS"
    GOTO LABEL_04AE

LABEL_0184
    CASE_OF 3,3
        OUTPUT STR_0016    * "INC"
        OUTPUT STR_0018    * "DEC"
    CASE_END
    CALL LABEL_062A
    CALL LABEL_04CF
    GOTO LABEL_04B1

LABEL_018B
    CASE_OF 3,3
        OUTPUT STR_001C    * "PUSH"
        OUTPUT STR_001A    * "POP"
    CASE_END
    CALL LABEL_062A
    CALL LABEL_04CF
    GOTO LABEL_04B1

LABEL_0192
    IF 2,0 > 3 THEN GOTO LABEL_01C7
    IF 3,3 = 1 THEN GOTO LABEL_01B0
    IF 3,0 > 1 THEN GOTO LABEL_01A1
    CASE_OF 0,0
        OUTPUT STR_001C    * "PUSH"
        OUTPUT STR_001A    * "POP"
    CASE_END
    OUTPUT "A"
    GOTO LABEL_04AE

LABEL_01A1
    IF 0,0 = 1 THEN GOTO LABEL_01AA
    OUTPUT "BOUND"
    CALL LABEL_062D
    SET VAR_0054,0
    SET VAR_003E,1
    CALL LABEL_0506
    GOTO LABEL_04B1

LABEL_01AA
    OUTPUT "ARPL"
    CALL LABEL_062D
    SET VAR_0054,0
    SET VAR_003E,1
    CALL LABEL_04F8
    GOTO LABEL_04B1

LABEL_01B0
    CASE_OF 0,0
        GOTO LABEL_01B4
        GOTO LABEL_01BB
    CASE_END

LABEL_01B4
    OUTPUT STR_001C    * "PUSH"
    CALL LABEL_062D
    CASE_OF 1,1
        CALL LABEL_0560
        CALL LABEL_0557
    CASE_END
    GOTO LABEL_04B1

LABEL_01BB
    OUTPUT "IMUL"
    CALL LABEL_062D
    SET VAR_0054,0
    SET VAR_003E,1
    CALL LABEL_0506
    OUTPUT STR_0000    * ","
    LOAD VAR_0042
    CASE_OF 1,1
        CALL LABEL_0560
        CALL LABEL_0557
    CASE_END
    GOTO LABEL_04B1

LABEL_01C7
    IF 3,3 = 0 THEN GOTO LABEL_0596
    CASE_OF 1,1
        OUTPUT STR_0003    * "IN"
        OUTPUT STR_0001    * "OUT"
    CASE_END
    OUTPUT STR_0039    * "S"
    CALL LABEL_0600
    GOTO LABEL_04AE

LABEL_01D1
    OUTPUT "J"
    CASE_OF 3,0
        OUTPUT "O"
        OUTPUT "NO"
        OUTPUT "B/NAE/C"
        OUTPUT "NB/AE/NC"
        OUTPUT "E/Z"
        OUTPUT "NE/NZ"
        OUTPUT "BE/NA"
        OUTPUT "A/NBE"
        OUTPUT STR_0039    * "S"
        OUTPUT "NS"
        OUTPUT "P/PE"
        OUTPUT "NP/PO"
        OUTPUT "L/NGE"
        OUTPUT "GE/NL"
        OUTPUT "LE/NG"
        OUTPUT "G/NLE"
    CASE_END
    CALL LABEL_062D
    CALL LABEL_05B0
    GOTO LABEL_04B1

LABEL_01E7
    CASE_OF 3,2
        GOTO LABEL_01ED
        GOTO LABEL_0210
        GOTO LABEL_0219
        GOTO LABEL_021D
    CASE_END

LABEL_01ED
    EXTRACT_BIT 0
    STORE VAR_003E
    CALL LABEL_0572
    IF INPUT_ERROR = 0 THEN GOTO LABEL_01F7
    OUTPUT "Immed"
    CALL LABEL_062D
    OUTPUT STR_0015    * "*"
    GOTO LABEL_04B1

LABEL_01F7
    CASE_OF 5,3
        OUTPUT STR_0022    * "ADD"
        OUTPUT "OR"
        OUTPUT "ADC"
        OUTPUT "SBB"
        OUTPUT "AND"
        OUTPUT STR_0024    * "SUB"
        OUTPUT "XOR"
        OUTPUT STR_0026    * "CMP"
    CASE_END
    CALL LABEL_062D
    SET VAR_0050,0
    IF 5,3 = 7 THEN SET VAR_0050,1
    CALL LABEL_0512
    OUTPUT STR_0000    * ","
    LOAD VAR_0042
    CASE_OF 1,0
        CALL LABEL_0557
        CALL LABEL_0560
        CALL LABEL_0557
        CALL LABEL_0557
    CASE_END
    GOTO LABEL_04B1

LABEL_0210
    CASE_OF 1,1
        OUTPUT STR_003A    * "TEST"
        OUTPUT STR_0036    * "XCHG"
    CASE_END
    CALL LABEL_062D
    EXTRACT_BIT 0
    STORE VAR_003E
    CALL LABEL_0506
    GOTO LABEL_04B1

LABEL_0219
    OUTPUT STR_000B    * "MOV"
    CALL LABEL_062D
    CALL LABEL_04F0
    GOTO LABEL_04B1

LABEL_021D
    CASE_OF 1,0
        OUTPUT STR_000B    * "MOV"
        OUTPUT "LEA"
        OUTPUT STR_000B    * "MOV"
        OUTPUT STR_001A    * "POP"
    CASE_END
    CALL LABEL_062D
    IF 1,0 <> 1 THEN GOTO LABEL_022A
    SET VAR_003E,1
    CALL LABEL_0506
    GOTO LABEL_04B1

LABEL_022A
    IF 1,0 <> 3 THEN GOTO LABEL_0236
    CALL LABEL_0572
    IF INPUT_ERROR = 0 THEN GOTO LABEL_0233
    OUTPUT STR_0015    * "*"
    GOTO LABEL_04B1

LABEL_0233
    SET VAR_0050,0
    CALL LABEL_0512
    GOTO LABEL_04B1

LABEL_0236
    EXTRACT_BIT 1
    STORE VAR_0050
    SET VAR_003E,1
    CALL LABEL_0572
    IF INPUT_ERROR = 0 THEN GOTO LABEL_023F
    OUTPUT STR_0015    * "*"
    GOTO LABEL_04B1

LABEL_023F
    STORE VAR_0044
    CASE_OF VAR_0050
        CALL LABEL_0512
        CALL LABEL_04DA
    CASE_END
    OUTPUT STR_0000    * ","
    LOAD VAR_0044
    CASE_OF VAR_0050
        CALL LABEL_04DA
        CALL LABEL_0512
    CASE_END
    GOTO LABEL_04B1

LABEL_024B
    IF 3,0 = 10 THEN GOTO LABEL_0251
    IF VAR_0056 = 1 THEN SET VAR_005C,1

LABEL_0251
    IF 3,0 >= 8 THEN GOTO LABEL_025E
    IF 7,0 <> 000000090H THEN GOTO LABEL_0259
    OUTPUT "NOP"
    GOTO LABEL_04B1

LABEL_0259
    OUTPUT STR_0036    * "XCHG"
    CALL LABEL_062D
    OUTPUT "AX,"
    CALL LABEL_04CF
    GOTO LABEL_04B1

LABEL_025E
    CASE_OF 2,0
        OUTPUT "CBW"
        OUTPUT "CWD"
        OUTPUT STR_001F    * "CALL"
        OUTPUT "WAIT"
        OUTPUT "PUSHF"
        OUTPUT "POPF"
        OUTPUT "SAHF"
        OUTPUT "LAHF"
    CASE_END
    IF 2,0 <> 2 THEN GOTO LABEL_04B1
    CALL LABEL_062D
    CALL LABEL_05D8
    GOTO LABEL_04B1

LABEL_026E
    CASE_OF 3,1
        GOTO LABEL_0284
        GOTO LABEL_0284
        OUTPUT STR_000B    * "MOV"
        OUTPUT STR_0026    * "CMP"
        GOTO LABEL_027B
        OUTPUT "STO"
        OUTPUT "LOD"
        OUTPUT "SCA"
    CASE_END
    OUTPUT STR_0039    * "S"
    CALL LABEL_0600
    GOTO LABEL_04AE

LABEL_027B
    OUTPUT STR_003A    * "TEST"
    CALL LABEL_062D
    CALL LABEL_060D
    OUTPUT STR_0000    * ","
    CASE_OF 0,0
        CALL LABEL_0557
        CALL LABEL_0560
    CASE_END
    GOTO LABEL_04B1

LABEL_0284
    OUTPUT STR_000B    * "MOV"
    CALL LABEL_062D
    CASE_OF 1,1
        SET VAR_0050,1
        SET VAR_0050,0
    CASE_END
    CASE_OF 1,1
        CALL LABEL_060D
        CALL LABEL_0534
    CASE_END
    OUTPUT STR_0000    * ","
    LOAD VAR_0042
    CASE_OF 1,1
        CALL LABEL_0534
        CALL LABEL_060D
    CASE_END
    GOTO LABEL_04B1

LABEL_0295
    OUTPUT STR_000B    * "MOV"
    CALL LABEL_062D
    EXTRACT_BIT 3
    STORE VAR_003E
    LOAD INPUT_DATA
    CALL LABEL_04BF
    OUTPUT STR_0000    * ","
    CASE_OF VAR_003E
        CALL LABEL_0557
        CALL LABEL_0560
    CASE_END
    GOTO LABEL_04B1

LABEL_02A1
    IF 2,0 <= 1 THEN GOTO LABEL_02A8
    CASE_OF 3,3
        GOTO LABEL_02B7
        GOTO LABEL_02DF
    CASE_END

LABEL_02A8
    CASE_OF 3,3
        GOTO LABEL_040B
        GOTO LABEL_02AC
    CASE_END

LABEL_02AC
    IF 0,0 = 0 THEN GOTO LABEL_02B1
    OUTPUT "LEAVE"
    GOTO LABEL_04AE

LABEL_02B1
    OUTPUT "ENTER"
    CALL LABEL_062D
    CALL LABEL_0560
    OUTPUT STR_0000    * ","
    CALL LABEL_0557
    GOTO LABEL_04B1

LABEL_02B7
    CASE_OF 2,0
        NOP
        NOP
        OUTPUT STR_003D    * "RET(near)"
        OUTPUT STR_003D    * "RET(near)"
        OUTPUT "LES"
        OUTPUT "LDS"
        OUTPUT STR_000B    * "MOV"
        OUTPUT STR_000B    * "MOV"
    CASE_END
    IF 2,0 = 3 THEN GOTO LABEL_04AE
    CALL LABEL_062D
    IF 2,0 <> 2 THEN GOTO LABEL_02CA
    CALL LABEL_0561
    GOTO LABEL_04B1

LABEL_02CA
    IF 2,1 = 3 THEN GOTO LABEL_02D0
    SET VAR_003E,1
    CALL LABEL_0506
    GOTO LABEL_04B1

LABEL_02D0
    CALL LABEL_0572
    IF INPUT_ERROR = 0 THEN GOTO LABEL_02D6
    OUTPUT STR_0015    * "*"
    GOTO LABEL_04B1

LABEL_02D6
    SET VAR_0050,0
    CALL LABEL_0512
    OUTPUT STR_0000    * ","
    LOAD VAR_0042
    CASE_OF 0,0
        CALL LABEL_0557
        CALL LABEL_0560
    CASE_END
    GOTO LABEL_04B1

LABEL_02DF
    CASE_OF 2,0
        NOP
        NOP
        OUTPUT STR_0042    * "RET(far)"
        OUTPUT STR_0042    * "RET(far)"
        OUTPUT STR_0047    * "INT"
        OUTPUT STR_0047    * "INT"
        OUTPUT "INTO"
        OUTPUT "IRET"
    CASE_END
    IF 2,0 = 2 THEN GOTO LABEL_02F2
    IF 2,0 = 5 THEN GOTO LABEL_02F2
    IF VAR_0056 = 1 THEN SET VAR_005C,1

LABEL_02F2
    IF 7,0 = 0000000CBH THEN GOTO LABEL_04B1
    IF 7,0 >= 0000000CEH THEN GOTO LABEL_04B1
    CALL LABEL_062D
    CASE_OF 1,0
        OUTPUT "3d"
        CALL LABEL_0572
        CALL LABEL_0561
        NOP
    CASE_END
    LOAD VAR_0042
    IF 1,0 <> 1 THEN GOTO LABEL_04B1
    IF INPUT_ERROR = 0 THEN GOTO LABEL_0308
    OUTPUT STR_0007    * "**"
    GOTO LABEL_04B1

LABEL_0308
    LOAD INPUT_DATA
    OUTPUT ACCUMULATOR,FMT_006A    * 8,DEC,LEFT_JUSTIFIED
    OUTPUT "d"
    GOTO LABEL_04B1

LABEL_030C
    IF 3,3 = 0 THEN GOTO LABEL_03F6
    ROTATE LEFT,8
    STORE VAR_003C
    CALL LABEL_0572
    IF INPUT_ERROR = 0 THEN GOTO LABEL_0317
    OUTPUT "ESC **"
    GOTO LABEL_04B1

LABEL_0317
    LOAD INPUT_DATA
    AND 0000000FFH
    INCLUSIVE_OR VAR_003C
    IF 10,5 = 31 THEN GOTO LABEL_03D9
    IF 10,5 = 15 THEN GOTO LABEL_03B6
    IF 7,6 = 3 THEN GOTO LABEL_036B
    IF 8,8 <> 1 THEN GOTO LABEL_034B
    IF 5,5 <> 1 THEN GOTO LABEL_034B
    CASE_OF 10,9
        GOTO LABEL_032F
        GOTO LABEL_0336
        GOTO LABEL_033D
        GOTO LABEL_0344
    CASE_END

LABEL_032F
    CASE_OF 4,3
        OUTPUT "FLDENV"
        OUTPUT "FLDCW"
        OUTPUT "FSTENV"
        OUTPUT "FSTCW"
    CASE_END
    GOTO LABEL_03F0

LABEL_0336
    CASE_OF 4,3
        GOTO LABEL_03F4
        OUTPUT "FLD"
        GOTO LABEL_03F4
        OUTPUT "FSTP"
    CASE_END
    GOTO LABEL_03F0

LABEL_033D
    CASE_OF 4,3
        OUTPUT "FRSTOR"
        GOTO LABEL_03F4
        OUTPUT "FSAVE"
        OUTPUT "FSTSW"
    CASE_END
    GOTO LABEL_03F0

LABEL_0344
    CASE_OF 4,3
        OUTPUT "FBLD"
        OUTPUT "FILD"
        OUTPUT "FBSTP"
        OUTPUT "FISTP"
    CASE_END
    GOTO LABEL_03F0

LABEL_034B
    IF 8,8 = 1 THEN GOTO LABEL_035D
    OUTPUT STR_0055    * "F"
    IF 9,9 = 1 THEN OUTPUT STR_005C    * "I"
    CASE_OF 5,3
        OUTPUT STR_0022    * "ADD"
        OUTPUT STR_004A    * "MUL"
        OUTPUT STR_004C    * "COM"
        OUTPUT STR_004E    * "COMP"
        OUTPUT STR_0024    * "SUB"
        OUTPUT STR_0056    * "SUBR"
        OUTPUT STR_0051    * "DIV"
        OUTPUT STR_0059    * "DIVR"
    CASE_END
    GOTO LABEL_03F0

LABEL_035D
    IF 4,3 = 1 THEN GOTO LABEL_03F4
    OUTPUT STR_0055    * "F"
    IF 9,9 = 1 THEN OUTPUT STR_005C    * "I"
    CASE_OF 4,3
        OUTPUT "LD"
        GOTO LABEL_03F4
        OUTPUT "ST"
        OUTPUT "STP"
    CASE_END
    GOTO LABEL_03F0

LABEL_036B
    CASE_OF 10,8
        GOTO LABEL_0375
        GOTO LABEL_0398
        GOTO LABEL_03F4
        GOTO LABEL_03F4
        GOTO LABEL_0375
        GOTO LABEL_039E
        GOTO LABEL_038E
        GOTO LABEL_039E
    CASE_END

LABEL_0375
    OUTPUT STR_0055    * "F"
    CASE_OF 5,3
        OUTPUT STR_0022    * "ADD"
        OUTPUT STR_004A    * "MUL"
        GOTO LABEL_0387
        GOTO LABEL_038C
        OUTPUT STR_0024    * "SUB"
        OUTPUT STR_0056    * "SUBR"
        OUTPUT STR_0051    * "DIV"
        OUTPUT STR_0059    * "DIVR"
    CASE_END
    IF 9,9 = 1 THEN OUTPUT STR_0054    * "P"
    CASE_OF 10,10
        GOTO LABEL_03E3
        GOTO LABEL_03E6
    CASE_END

LABEL_0387
    OUTPUT STR_004C    * "COM"
    IF 9,9 = 1 THEN OUTPUT STR_0054    * "P"
    GOTO LABEL_03EA

LABEL_038C
    OUTPUT STR_004E    * "COMP"
    GOTO LABEL_03EA

LABEL_038E
    IF 5,3 <> 3 THEN GOTO LABEL_0375
    IF 2,0 <> 1 THEN GOTO LABEL_03F4
    OUTPUT STR_0055    * "F"
    OUTPUT STR_004E    * "COMP"
    OUTPUT STR_0054    * "P"
    GOTO LABEL_04B1

LABEL_0398
    CASE_OF 4,3
        GOTO LABEL_03A7
        GOTO LABEL_03A9
        GOTO LABEL_03AB
        GOTO LABEL_03B0
    CASE_END

LABEL_039E
    IF 5,5 = 1 THEN GOTO LABEL_03F4
    CASE_OF 4,3
        GOTO LABEL_03B2
        GOTO LABEL_03A9
        GOTO LABEL_03B4
        GOTO LABEL_03B0
    CASE_END

LABEL_03A7
    OUTPUT "FLD"
    GOTO LABEL_03EA

LABEL_03A9
    OUTPUT "FXCH"
    GOTO LABEL_03EA

LABEL_03AB
    IF 3,0 <> 0 THEN GOTO LABEL_03F4
    OUTPUT "FNOP"
    GOTO LABEL_04B1

LABEL_03B0
    OUTPUT "FSTP"
    GOTO LABEL_03EA

LABEL_03B2
    OUTPUT "FFREE"
    GOTO LABEL_03EA

LABEL_03B4
    OUTPUT "FST"
    GOTO LABEL_03EA

LABEL_03B6
    CASE_OF 4,0
        OUTPUT "FCHS"
        OUTPUT "FABS"
        GOTO LABEL_03F4
        GOTO LABEL_03F4
        OUTPUT "FTST"
        OUTPUT "FXAM"
        GOTO LABEL_03F4
        GOTO LABEL_03F4
        OUTPUT "FLD1"
        OUTPUT "FLDL2T"
        OUTPUT "FLDL2E"
        OUTPUT "FLDPI"
        OUTPUT "FLDLG2"
        OUTPUT "FLDLN2"
        OUTPUT "FLDZ"
        GOTO LABEL_03F4
        OUTPUT "F2XM1"
        OUTPUT "FYL2X"
        OUTPUT "FPTAN"
        OUTPUT "FPATAN"
        OUTPUT "FXTRACT"
        GOTO LABEL_03F4
        OUTPUT "FDECSTP"
        OUTPUT "FINCSTP"
        OUTPUT "FPREM"
        OUTPUT "FYL2XP1"
        OUTPUT "FSQRT"
        GOTO LABEL_03F4
        OUTPUT "FRNDINT"
        OUTPUT "FSCALE"
        GOTO LABEL_03F4
        GOTO LABEL_03F4
    CASE_END
    GOTO LABEL_04B1

LABEL_03D9
    IF 4,2 <> 0 THEN GOTO LABEL_03F4
    CASE_OF 1,0
        OUTPUT "FENI"
        OUTPUT "FDISI"
        OUTPUT "FCLEX"
        OUTPUT "FINIT"
    CASE_END
    GOTO LABEL_04B1

LABEL_03E3
    OUTPUT " ST,"
    CALL LABEL_03EB
    GOTO LABEL_04B1

LABEL_03E6
    OUTPUT STR_0053    * " "
    CALL LABEL_03EB
    OUTPUT ",ST"
    RETURN

LABEL_03EA
    OUTPUT STR_0053    * " "

LABEL_03EB
    OUTPUT "ST["
    AND 7
    OUTPUT ACCUMULATOR,FMT_006C    * 16,DEC,LEFT_JUSTIFIED
    OUTPUT "]"
    RETURN

LABEL_03F0
    AND 0000000FFH
    OUTPUT STR_0053    * " "
    CALL LABEL_0512
    GOTO LABEL_04B1

LABEL_03F4
    OUTPUT "reserved opcode"
    ABORT

LABEL_03F6
    CASE_OF 2,0
        GOTO LABEL_040B
        GOTO LABEL_040B
        GOTO LABEL_040B
        GOTO LABEL_040B
        OUTPUT "AAM"
        OUTPUT "AAD"
        GOTO LABEL_0596
        OUTPUT "XLAT"
    CASE_END
    IF 2,0 <> 7 THEN GOTO LABEL_0409
    IF VAR_0040 = 0 THEN GOTO LABEL_04AE
    CALL LABEL_062D
    CALL LABEL_05A6
    GOTO LABEL_04B1

LABEL_0409
    CALL LABEL_0572
    GOTO LABEL_04B1

LABEL_040B
    EXTRACT_BIT 0
    STORE VAR_003E
    CALL LABEL_0572
    IF INPUT_ERROR = 0 THEN GOTO LABEL_0415
    OUTPUT "Shift"
    CALL LABEL_062D
    OUTPUT STR_0015    * "*"
    GOTO LABEL_04B1

LABEL_0415
    CASE_OF 5,3
        OUTPUT "ROL"
        OUTPUT "ROR"
        OUTPUT "RCL"
        OUTPUT "RCR"
        OUTPUT "SAL/SHL"
        OUTPUT "SHR"
        GOTO LABEL_0599
        OUTPUT "SAR"
    CASE_END
    CALL LABEL_062D
    SET VAR_0050,0
    SET VAR_0054,1
    CALL LABEL_0512
    OUTPUT STR_0000    * ","
    LOAD VAR_0042
    IF 7,4 <> 12 THEN GOTO LABEL_042A
    CALL LABEL_0557
    GOTO LABEL_04B1

LABEL_042A
    CASE_OF 1,1
        OUTPUT "1"
        OUTPUT "CL"
    CASE_END
    GOTO LABEL_04B1

LABEL_042F
    CASE_OF 3,0
        OUTPUT "LOOPNE/NZ"
        OUTPUT "LOOPE/Z"
        OUTPUT "LOOP"
        OUTPUT "JCXZ"
        OUTPUT STR_0003    * "IN"
        OUTPUT STR_0003    * "IN"
        OUTPUT STR_0001    * "OUT"
        OUTPUT STR_0001    * "OUT"
        OUTPUT STR_001F    * "CALL"
        OUTPUT STR_0009    * "JMP"
        OUTPUT STR_0009    * "JMP"
        OUTPUT STR_0009    * "JMP"
        OUTPUT STR_0003    * "IN"
        OUTPUT STR_0003    * "IN"
        OUTPUT STR_0001    * "OUT"
        OUTPUT STR_0001    * "OUT"
    CASE_END
    IF 3,2 <> 3 THEN GOTO LABEL_0447
    IF VAR_0056 = 1 THEN SET VAR_005C,1

LABEL_0447
    CALL LABEL_062D
    CASE_OF 3,2
        CALL LABEL_05B0
        CALL LABEL_0613
        CALL LABEL_0623
        CALL LABEL_0613
    CASE_END
    GOTO LABEL_04B1

LABEL_044F
    CASE_OF 3,0
        OUTPUT "lock"
        GOTO LABEL_0599
        OUTPUT "repne/nz"
        OUTPUT "rep/e/z"
        OUTPUT "HLT"
        OUTPUT "CMC"
        GOTO LABEL_0462
        GOTO LABEL_0462
        OUTPUT "CLC"
        OUTPUT "STC"
        OUTPUT "CLI"
        OUTPUT "STI"
        OUTPUT "CLD"
        OUTPUT "STD"
        GOTO LABEL_0487
        GOTO LABEL_0487
    CASE_END
    GOTO LABEL_04AE

LABEL_0462
    EXTRACT_BIT 0
    STORE VAR_003E
    CALL LABEL_0572
    IF INPUT_ERROR = 0 THEN GOTO LABEL_046C
    OUTPUT "Grp_1"
    CALL LABEL_062D
    OUTPUT STR_0015    * "*"
    GOTO LABEL_04B1

LABEL_046C
    STORE VAR_0044
    CASE_OF 5,3
        OUTPUT STR_003A    * "TEST"
        GOTO LABEL_0599
        OUTPUT "NOT"
        OUTPUT "NEG"
        OUTPUT STR_004A    * "MUL"
        OUTPUT "IMUL"
        OUTPUT STR_0051    * "DIV"
        OUTPUT "IDIV"
    CASE_END
    CALL LABEL_062D
    IF 5,3 > 0 THEN SET VAR_0054,1
    SET VAR_0050,1
    CALL LABEL_0512
    LOAD VAR_0044
    IF 5,3 <> 0 THEN RETURN
    OUTPUT STR_0000    * ","
    CASE_OF VAR_003E
        CALL LABEL_0557
        CALL LABEL_0560
    CASE_END
    GOTO LABEL_04B1

LABEL_0487
    EXTRACT_BIT 0
    STORE VAR_003E
    CALL LABEL_0572
    IF INPUT_ERROR = 0 THEN GOTO LABEL_0491
    OUTPUT "Grp_2"
    CALL LABEL_062D
    OUTPUT STR_0015    * "*"
    GOTO LABEL_04B1

LABEL_0491
    IF VAR_003E = 1 THEN GOTO LABEL_0497
    IF 5,3 > 1 THEN GOTO LABEL_0599

LABEL_0497
    CASE_OF 5,3
        OUTPUT STR_0016    * "INC"
        OUTPUT STR_0018    * "DEC"
        OUTPUT STR_001F    * "CALL"
        OUTPUT STR_001F    * "CALL"
        OUTPUT STR_0009    * "JMP"
        OUTPUT STR_0009    * "JMP"
        OUTPUT STR_001C    * "PUSH"
        GOTO LABEL_0599
    CASE_END
    CALL LABEL_062D
    IF 5,3 <= 1 THEN SET VAR_0054,1
    SET VAR_0050,1
    IF 5,3 = 3 THEN OUTPUT STR_0028    * "dwp "
    IF 5,3 = 5 THEN OUTPUT STR_0028    * "dwp "
    CALL LABEL_0512
    GOTO LABEL_04B1

LABEL_04AE
    IF VAR_0056 = 1 THEN SET VAR_005C,1

LABEL_04B1
    LOAD VAR_006C
    IF VAR_005A <> 1 THEN RETURN
    IF VAR_0056 <> 1 THEN RETURN
    CALL LABEL_0570
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_059C
    SET VAR_005A,1
    OUTPUT "  "
    GOTO LABEL_00DA

LABEL_04BF
    CASE_OF VAR_003E
        CALL LABEL_04C4
        CALL LABEL_04CF
    CASE_END
    RETURN

LABEL_04C4
    CASE_OF 2,0
        OUTPUT "AL"
        OUTPUT "CL"
        OUTPUT "DL"
        OUTPUT "BL"
        OUTPUT "AH"
        OUTPUT "CH"
        OUTPUT "DH"
        OUTPUT "BH"
    CASE_END
    RETURN

LABEL_04CF
    CASE_OF 2,0
        OUTPUT "AX"
        OUTPUT "CX"
        OUTPUT "DX"
        OUTPUT "BX"
        OUTPUT "SP"
        OUTPUT "BP"
        OUTPUT "SI"
        OUTPUT "DI"
    CASE_END
    RETURN

LABEL_04DA
    CASE_OF 4,3
        OUTPUT "E"
        OUTPUT "C"
        OUTPUT STR_0039    * "S"
        OUTPUT "D"
    CASE_END
    OUTPUT STR_0039    * "S"
    RETURN

LABEL_04E2
    CASE_OF 5,4
        OUTPUT STR_0022    * "ADD"
        OUTPUT "ADC"
        OUTPUT "AND"
        OUTPUT "XOR"
    CASE_END
    RETURN

LABEL_04E9
    CASE_OF 5,4
        OUTPUT "OR"
        OUTPUT "SBB"
        OUTPUT STR_0024    * "SUB"
        OUTPUT STR_0026    * "CMP"
    CASE_END
    RETURN

LABEL_04F0
    EXTRACT_BIT 0
    STORE VAR_003E
    LOAD INPUT_DATA
    CASE_OF 1,1
        CALL LABEL_04F8
        CALL LABEL_0506
    CASE_END
    RETURN

LABEL_04F8
    CALL LABEL_0572
    IF INPUT_ERROR = 0 THEN GOTO LABEL_04FE
    OUTPUT STR_0015    * "*"
    RETURN

LABEL_04FE
    STORE VAR_0044
    SET VAR_0050,0
    CALL LABEL_0512
    OUTPUT STR_0000    * ","
    LOAD VAR_0044
    ROTATE RIGHT,3
    CALL LABEL_04BF
    RETURN

LABEL_0506
    CALL LABEL_0572
    IF INPUT_ERROR = 0 THEN GOTO LABEL_050C
    OUTPUT STR_0015    * "*"
    RETURN

LABEL_050C
    ROTATE RIGHT,3
    CALL LABEL_04BF
    OUTPUT STR_0000    * ","
    SET VAR_0050,1
    CALL LABEL_0512
    RETURN

LABEL_0512
    LOAD INPUT_DATA
    STORE VAR_0044
    IF 7,6 = 3 THEN GOTO LABEL_04BF
    IF VAR_0054 = 1 THEN CALL LABEL_0605
    AND 0000000C7H
    IF 7,0 = 6 THEN GOTO LABEL_0534
    CALL LABEL_05A6
    OUTPUT "["
    CASE_OF 2,0
        OUTPUT "BX][SI"
        OUTPUT "BX][DI"
        OUTPUT "BP][SI"
        OUTPUT "BP][DI"
        OUTPUT "SI"
        OUTPUT "DI"
        OUTPUT "BP"
        OUTPUT "BX"
    CASE_END
    IF 7,6 = 0 THEN GOTO LABEL_0532
    OUTPUT "+"
    CASE_OF 7,7
        CALL LABEL_0558
        CALL LABEL_0561
    CASE_END

LABEL_0532
    OUTPUT "]"
    RETURN

LABEL_0534
    SET VAR_004E,0
    CALL LABEL_0572
    IF INPUT_ERROR <> 0 THEN SET VAR_004E,1
    AND CONST_0034
    STORE VAR_004C
    CALL LABEL_0572
    IF INPUT_ERROR = 0 THEN GOTO LABEL_0542
    LOAD VAR_004E
    INCLUSIVE_OR 2
    STORE VAR_004E

LABEL_0542
    AND CONST_0034
    ROTATE LEFT,8
    INCLUSIVE_OR VAR_004C
    STORE VAR_004C
    CALL LABEL_05A6
    LOAD VAR_004C
    ROTATE RIGHT,8
    CASE_OF VAR_004E
        OUTPUT ACCUMULATOR,FMT_0062    * 8,HEX,2
        OUTPUT ACCUMULATOR,FMT_0062    * 8,HEX,2
        OUTPUT STR_0007    * "**"
        OUTPUT STR_0007    * "**"
    CASE_END
    LOAD VAR_004C
    CASE_OF VAR_004E
        OUTPUT ACCUMULATOR,FMT_0062    * 8,HEX,2
        OUTPUT STR_0007    * "**"
        OUTPUT ACCUMULATOR,FMT_0062    * 8,HEX,2
        OUTPUT STR_0007    * "**"
    CASE_END
    RETURN

LABEL_0557
    OUTPUT STR_0049    * "#"

LABEL_0558
    CALL LABEL_0572
    IF INPUT_ERROR = 0 THEN GOTO LABEL_055E
    OUTPUT STR_0007    * "**"
    RETURN

LABEL_055E
    OUTPUT ACCUMULATOR,FMT_0062    * 8,HEX,2
    RETURN

LABEL_0560
    OUTPUT STR_0049    * "#"

LABEL_0561
    POSITION REL,2
    CALL LABEL_0558
    STORE VAR_0038
    POSITION REL,-4
    CALL LABEL_0558
    ROTATE LEFT,8
    INCLUSIVE_OR VAR_0038
    POSITION REL,2
    RETURN
    POSITION REL,4
    CALL LABEL_0561
    POSITION REL,-8
    CALL LABEL_0561
    POSITION REL,4
    RETURN

LABEL_0570
    LOAD VAR_0062
    GOTO LABEL_0574

LABEL_0572
    LOAD VAR_0060
    GOTO LABEL_0574

LABEL_0574
    INCREMENT VAR_005A
    STORE QUALIFY_VALUE
    LOAD VAR_005E
    STORE QUALIFY_MASK
    IF VAR_0056 = 1 THEN GOTO LABEL_058B
    INCREMENT VAR_006E
    INPUT ABS,VAR_006E,QUALIFIED
    CALL LABEL_0637
    IF INPUT_ERROR <> 0 THEN RETURN
    LOAD INPUT_TAG
    INCLUSIVE_OR 1
    STORE VAR_003A
    TAG_WITH VAR_003A
    SET VAR_0056,1
    LOAD INPUT_DATA
    STORE VAR_0058
    AND CONST_0034
    STORE INPUT_DATA
    RETURN

LABEL_058B
    LOAD INPUT_TAG
    INCLUSIVE_OR 2
    STORE VAR_003A
    TAG_WITH VAR_003A
    SET VAR_0056,0
    LOAD VAR_0058
    ROTATE RIGHT,8
    AND CONST_0034
    STORE INPUT_DATA
    INCREMENT VAR_006E
    RETURN

LABEL_0596
    POSITION ABS,3
    OUTPUT "Illegal Opcode"
    ABORT

LABEL_0599
    POSITION ABS,3
    OUTPUT "Illegal Instruction"
    ABORT

LABEL_059C
    POSITION ABS,3
    OUTPUT "Data Acquisition Error "
    ABORT

LABEL_059F
    CALL LABEL_060D
    OUTPUT ",#"
    CASE_OF 0,0
        CALL LABEL_0558
        CALL LABEL_0561
    CASE_END
    RETURN

LABEL_05A6
    IF VAR_0040 = 0 THEN RETURN
    STORE VAR_0038
    LOAD VAR_0040
    CALL LABEL_04DA
    OUTPUT ":"
    LOAD VAR_0038
    RETURN

LABEL_05AF
    OUTPUT "s "

LABEL_05B0
    CALL LABEL_0572
    IF INPUT_ERROR = 0 THEN GOTO LABEL_05B5
    GOTO LABEL_05FE

LABEL_05B5
    AND CONST_0034
    IF 7,7 = 1 THEN INCLUSIVE_OR 0000FFF00H
    ADD VAR_006E
    ADD 1
    AND 0000FFFFFH
    IF_NOT_MAPPED THEN OUTPUT ACCUMULATOR,FMT_0066    * 20,HEX,5
    RETURN

LABEL_05BF
    OUTPUT "np "
    CALL LABEL_0572
    IF INPUT_ERROR = 0 THEN GOTO LABEL_05C5
    GOTO LABEL_05FE

LABEL_05C5
    AND CONST_0034
    STORE VAR_0038
    CALL LABEL_0572
    IF INPUT_ERROR = 0 THEN GOTO LABEL_05CC
    GOTO LABEL_05FE

LABEL_05CC
    AND CONST_0034
    ROTATE LEFT,8
    INCLUSIVE_OR VAR_0038
    IF 15,15 = 1 THEN INCLUSIVE_OR 0000F0000H
    ADD VAR_006E
    ADD 1
    AND 0000FFFFFH
    IF_NOT_MAPPED THEN OUTPUT ACCUMULATOR,FMT_0066    * 20,HEX,5
    RETURN

LABEL_05D8
    OUTPUT "fp "
    CALL LABEL_0572
    IF INPUT_ERROR = 0 THEN GOTO LABEL_05DE
    GOTO LABEL_05FE

LABEL_05DE
    AND CONST_0034
    STORE VAR_0046
    CALL LABEL_0572
    IF INPUT_ERROR = 0 THEN GOTO LABEL_05E5
    GOTO LABEL_05FE

LABEL_05E5
    AND CONST_0034
    ROTATE LEFT,8
    INCLUSIVE_OR VAR_0046
    STORE VAR_0046
    CALL LABEL_0572
    IF INPUT_ERROR = 0 THEN GOTO LABEL_05EE
    GOTO LABEL_05FE

LABEL_05EE
    AND CONST_0034
    STORE VAR_0048
    CALL LABEL_0572
    IF INPUT_ERROR = 0 THEN GOTO LABEL_05F5
    GOTO LABEL_05FE

LABEL_05F5
    AND CONST_0034
    ROTATE LEFT,8
    INCLUSIVE_OR VAR_0048
    ROTATE LEFT,4
    STORE VAR_0048
    ADD VAR_0046
    IF_NOT_MAPPED THEN OUTPUT ACCUMULATOR,FMT_0066    * 20,HEX,5
    RETURN

LABEL_05FE
    OUTPUT "*****"
    RETURN

LABEL_0600
    CASE_OF 0,0
        OUTPUT "B"
        OUTPUT "W"
    CASE_END
    RETURN

LABEL_0605
    LOAD VAR_0042
    CASE_OF 0,0
        OUTPUT "b"
        OUTPUT "w"
    CASE_END
    OUTPUT "p "
    LOAD VAR_0044
    RETURN

LABEL_060D
    OUTPUT "A"
    CASE_OF 0,0
        OUTPUT "L"
        OUTPUT "X"
    CASE_END
    RETURN

LABEL_0613
    CASE_OF 1,1
        CALL LABEL_060D
        CALL LABEL_061E
    CASE_END
    OUTPUT STR_0000    * ","
    LOAD VAR_0042
    CASE_OF 1,1
        CALL LABEL_061E
        CALL LABEL_060D
    CASE_END
    RETURN

LABEL_061E
    CASE_OF 3,3
        CALL LABEL_0557
        OUTPUT "DX"
    CASE_END
    RETURN

LABEL_0623
    CASE_OF 1,0
        CALL LABEL_05BF
        CALL LABEL_05BF
        CALL LABEL_05D8
        CALL LABEL_05AF
    CASE_END
    RETURN

LABEL_062A
    IF VAR_0056 = 1 THEN SET VAR_005C,1

LABEL_062D
    CASE_OF VAR_005C
        CALL LABEL_0632
        POSITION REL,1
    CASE_END
    RETURN

LABEL_0632
    CASE_OF VAR_006A
        POSITION ABS,13
        POSITION ABS,15
    CASE_END
    RETURN

LABEL_0637
    IF VAR_0070 = 1 THEN SET INPUT_ERROR,1
    IF INPUT_ERROR <> 0 THEN RETURN
    LOAD INPUT_TAG
    IF 17,16 <> 3 THEN RETURN
    IF 0,0 = 1 THEN RETURN
    SET VAR_0070,1
    SET INPUT_ERROR,1
    RETURN
