"IAL"

*
* Original Source File Name: d:\ial\procs\i8088_i.s
*

CONST_0034      CONSTANT 00000007FH
CONST_0036      CONSTANT 0000000DDH
CONST_0038      CONSTANT 000000091H
CONST_003A      CONSTANT 000000098H
CONST_003C      CONSTANT 0000000DDH
CONST_003E      CONSTANT 000000090H
CONST_0040      CONSTANT 00000006DH
CONST_0042      CONSTANT 000000049H
CONST_0044      CONSTANT 00000004CH
CONST_0046      CONSTANT 00000006DH
CONST_0048      CONSTANT 000000048H
CONST_004A      CONSTANT 000000059H
CONST_004C      CONSTANT 000000059H
VAR_004E_UNREF  VARIABLE 000000059H
CONST_0050      CONSTANT 000000069H
CONST_0052      CONSTANT 000000060H
CONST_0054      CONSTANT 0000000FFH
CONST_0056      CONSTANT 0000FFFFFH
CONST_0058      CONSTANT 000000081H
STR_0000        ASCII ","
STR_0001        ASCII "OUT"
STR_0003        ASCII "IN"
STR_0005        ASCII "xx"
STR_0007        ASCII "**"
STR_0009        ASCII "JMP"
STR_000B        ASCII "MOV"
STR_000D_UNREF  ASCII "RET"
STR_000F        ASCII "executed code"
STR_0016        ASCII "code fetch"
VAR_005A        VARIABLE 000000000H
VAR_005C        VARIABLE 000000000H
VAR_005E        VARIABLE 000000000H
VAR_0060        VARIABLE 000000000H
VAR_0062        VARIABLE 000000000H
VAR_0064        VARIABLE 000000000H
VAR_0066        VARIABLE 000000000H
VAR_0068        VARIABLE 000000000H
VAR_006A_UNREF  VARIABLE 000000000H
VAR_006C        VARIABLE 000000000H
VAR_006E        VARIABLE 000000000H
VAR_0070        VARIABLE 000000000H
VAR_0072_UNREF  VARIABLE 000000000H
VAR_0074        VARIABLE 000000000H
VAR_0076        VARIABLE 000000000H
VAR_0078        VARIABLE 000000000H
VAR_007A        VARIABLE 000000000H
VAR_007C        VARIABLE 000000000H
VAR_007E        VARIABLE 000000000H
VAR_0080        VARIABLE 000000000H
VAR_0082        VARIABLE 000000039H
VAR_0084        VARIABLE 000000039H
VAR_0086        VARIABLE 000000019H
VAR_0088        VARIABLE 0000000DDH
VAR_008A        VARIABLE 000000091H
VAR_008C        VARIABLE 000000098H
VAR_008E        VARIABLE 000000000H
VAR_0090        VARIABLE 000000000H
VAR_0092        VARIABLE 000000000H
VAR_0094        VARIABLE 000000000H
FMT_001C        FORMAT 8,HEX,2
FMT_001E        FORMAT 16,HEX,4
FMT_0020        FORMAT 20,HEX,5
FMT_0022        FORMAT 3,OCT,1
FMT_0024        FORMAT 8,DEC,LEFT_JUSTIFIED
        LABEL_TITLE      "8088 Mnemonic"
        BASE_TITLE       "       hex"
        DEFAULT_WIDTH    39
        MAPPED_WIDTH     39
        SEARCH_LIMIT     5

ENTRY_POINT
    LOAD INPUT_STATUS
    STORE VAR_0090
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_04BF
    LOAD INPUT_DATA
    STORE VAR_007C
    LOAD INPUT_ADDRESS
    STORE VAR_0092
    SET VAR_0060,0
    SET RETURN_FLAGS,0
    SET VAR_0074,0
    SET VAR_0078,0
    SET VAR_007E,1
    SET VAR_0080,0
    SET VAR_008E,0
    SET VAR_0094,0
    LOAD ID_CODE
    EXTRACT_BIT 8
    STORE VAR_0076
    IF TASK = 4 THEN SET VAR_0076,0
    IF TASK = 5 THEN SET VAR_0076,0
    LOAD CONST_0034
    STORE VAR_0082
    LOAD 59
    STORE VAR_0084
    LOAD 27
    STORE VAR_0086
    LOAD CONST_0036
    STORE VAR_0088
    LOAD CONST_0038
    STORE VAR_008A
    LOAD CONST_003A
    STORE VAR_008C
    IF TASK = 3 THEN GOTO LABEL_0047
    IF TASK = 4 THEN GOTO LABEL_0031
    IF TASK = 5 THEN GOTO LABEL_0031
    OUTPUT "Illegal Task Request"
    RETURN

LABEL_0031
    LOAD 0
    STORE ID_CODE
    LOAD INPUT_STATUS
    AND 3
    STORE VAR_005A
    LOAD INPUT_STATUS
    AND 00000007CH
    ROTATE LEFT,1
    INCLUSIVE_OR VAR_005A
    STORE INPUT_STATUS
    LOAD 63
    STORE VAR_0082
    LOAD 31
    STORE VAR_0084
    LOAD 15
    STORE VAR_0086
    LOAD CONST_0040
    STORE VAR_0088
    LOAD CONST_0042
    STORE VAR_008A
    LOAD CONST_0044
    STORE VAR_008C

LABEL_0047
    LOAD ID_CODE
    IF 7,0 <> CONST_0058 THEN GOTO LABEL_0057
    LOAD CONST_004A
    STORE VAR_0082
    LOAD 16
    STORE VAR_0084
    LOAD 16
    STORE VAR_0086
    LOAD CONST_004C
    STORE VAR_0088
    LOAD 17
    STORE VAR_008A
    LOAD 24
    STORE VAR_008C

LABEL_0057
    LOAD INPUT_STATUS
    EXTRACT_BIT 0
    STORE VAR_005A
    LOAD INPUT_STATUS
    ROTATE RIGHT,2
    AND 6
    INCLUSIVE_OR VAR_005A
    STORE VAR_005A
    LOAD INPUT_STATUS
    IF 6,6 = 1 THEN GOTO LABEL_006A
    LOAD VAR_005A
    IF 2,0 = 7 THEN GOTO LABEL_00F9
    IF 2,0 = 4 THEN GOTO LABEL_00B2

LABEL_006A
    POSITION ABS,5
    LOAD INPUT_DATA
    CASE_OF VAR_0076
        OUTPUT ACCUMULATOR,FMT_001C    * 8,HEX,2
        OUTPUT ACCUMULATOR,FMT_001E    * 16,HEX,4
    CASE_END
    LOAD ID_CODE
    IF 7,0 <> CONST_0058 THEN GOTO LABEL_007C
    LOAD INPUT_STATUS
    CASE_OF 2,1
        LOAD 0
        LOAD 2
        LOAD 0
        LOAD 1
    CASE_END
    GOTO LABEL_0082

LABEL_007C
    LOAD INPUT_ADDRESS
    EXTRACT_BIT 0
    STORE VAR_005C
    LOAD INPUT_STATUS
    AND 2
    INCLUSIVE_OR VAR_005C

LABEL_0082
    IF VAR_0076 = 0 THEN GOTO LABEL_008D
    POSITION ABS,5
    CASE_OF 1,0
        GOTO LABEL_008D
        POSITION REL,2
        NOP
        GOTO LABEL_008D
    CASE_END
    OUTPUT "xx"

LABEL_008D
    SET RETURN_FLAGS,0
    POSITION ABS,10
    LOAD INPUT_STATUS
    AND CONST_0050
    IF 7,0 = CONST_0052 THEN GOTO LABEL_00A0
    LOAD VAR_005A
    CASE_OF 2,0
        OUTPUT "interrupt ack"
        OUTPUT "i/o write"
        OUTPUT "i/o read"
        OUTPUT "halt ack"
        OUTPUT STR_0016    * "code fetch"
        OUTPUT "memory write"
        OUTPUT "memory read"
        OUTPUT STR_000F    * "executed code"
    CASE_END
    GOTO LABEL_00A7

LABEL_00A0
    OUTPUT STR_0016    * "code fetch"
    OUTPUT " - "
    LOAD INPUT_STATUS
    CASE_OF 4,4
        OUTPUT "i/o space"
        OUTPUT "sys memory"
    CASE_END

LABEL_00A7
    LOAD INPUT_STATUS
    IF 6,6 = 0 THEN RETURN
    POSITION REL,1
    OUTPUT "808"
    CASE_OF 5,5
        OUTPUT "7"
        OUTPUT "9"
    CASE_END
    RETURN

LABEL_00B2
    SET VAR_0078,1
    IF TASK = 5 THEN GOTO LABEL_00B9
    IF TASK <> 4 THEN GOTO LABEL_00BD

LABEL_00B9
    LOAD INPUT_TAG
    IF 17,16 = 0 THEN GOTO LABEL_006A

LABEL_00BD
    LOAD ID_CODE
    IF 7,0 <> CONST_0058 THEN GOTO LABEL_00C6
    LOAD INPUT_STATUS
    CASE_OF 7,7
        OUTPUT "  "
        OUTPUT "Q "
    CASE_END

LABEL_00C6
    LOAD INPUT_TAG
    IF 1,0 = 3 THEN GOTO LABEL_0101
    IF VAR_0076 = 0 THEN GOTO LABEL_00E3
    LOAD INPUT_ADDRESS
    IF 0,0 = 0 THEN GOTO LABEL_00D6
    TAG_WITH 1
    SET VAR_007A,0
    LOAD INPUT_DATA
    ROTATE RIGHT,8
    GOTO LABEL_00E1

LABEL_00D6
    LOAD INPUT_TAG
    EXTRACT_BIT 0
    STORE VAR_005A
    CASE_OF VAR_005A
        SET VAR_007A,1
        SET VAR_007A,0
    CASE_END
    LOAD VAR_007C
    IF VAR_005A = 1 THEN ROTATE RIGHT,8

LABEL_00E1
    AND CONST_0054
    STORE INPUT_DATA

LABEL_00E3
    LOAD ID_CODE
    IF 7,0 = CONST_0058 THEN GOTO LABEL_0118
    IF TASK = 4 THEN GOTO LABEL_00F3
    IF TASK = 5 THEN GOTO LABEL_00F3
    LOAD CONST_003E
    STORE VAR_0086
    STORE VAR_0084
    LOAD CONST_003C
    STORE VAR_0082
    GOTO LABEL_0118

LABEL_00F3
    LOAD CONST_0048
    STORE VAR_0086
    STORE VAR_0084
    LOAD CONST_0046
    STORE VAR_0082
    GOTO LABEL_0118

LABEL_00F9
    LOAD INPUT_TAG
    IF 1,0 = 3 THEN GOTO LABEL_0101
    LOAD INPUT_STATUS
    IF 5,5 = 0 THEN GOTO LABEL_0118

LABEL_0101
    POSITION ABS,5
    LOAD INPUT_DATA
    IF VAR_0076 = 0 THEN GOTO LABEL_010D
    CASE_OF VAR_0078
        OUTPUT STR_0005    * "xx"
        OUTPUT ACCUMULATOR,FMT_001E    * 16,HEX,4
    CASE_END
    IF VAR_0078 = 1 THEN GOTO LABEL_010E

LABEL_010D
    OUTPUT ACCUMULATOR,FMT_001C    * 8,HEX,2

LABEL_010E
    POSITION REL,1
    CASE_OF VAR_0078
        OUTPUT STR_000F    * "executed code"
        OUTPUT STR_0016    * "code fetch"
    CASE_END
    LOAD INPUT_STATUS
    IF VAR_0078 = 0 THEN CALL LABEL_0592
    RETURN

LABEL_0118
    POSITION ABS,3
    IF VAR_0078 = 1 THEN GOTO LABEL_0121
    CALL LABEL_0565
    LOAD INPUT_TAG
    IF 1,0 = 3 THEN GOTO LABEL_0101

LABEL_0121
    IF VAR_0078 = 0 THEN GOTO LABEL_0132
    IF VAR_0076 = 0 THEN GOTO LABEL_0132
    IF VAR_007A = 1 THEN GOTO LABEL_0132
    OUTPUT " "
    SET VAR_008E,1
    LOAD INPUT_ADDRESS
    IF 0,0 = 0 THEN ADD 1
    STORE INPUT_ADDRESS
    STORE VAR_0092

LABEL_0132
    SET RETURN_FLAGS,1
    LOAD INPUT_DATA
    STORE VAR_0062
    CASE_OF 7,4
        GOTO LABEL_0147
        GOTO LABEL_0147
        GOTO LABEL_0147
        GOTO LABEL_0147
        GOTO LABEL_018E
        GOTO LABEL_0195
        GOTO LABEL_04B9
        GOTO LABEL_019C
        GOTO LABEL_01B2
        GOTO LABEL_0216
        GOTO LABEL_0239
        GOTO LABEL_0260
        GOTO LABEL_026C
        GOTO LABEL_02C8
        GOTO LABEL_0317
        GOTO LABEL_0337
    CASE_END

LABEL_0147
    IF 2,0 >= 6 THEN GOTO LABEL_0154
    CASE_OF 3,3
        CALL LABEL_03D3
        CALL LABEL_03DA
    CASE_END
    CALL LABEL_0555
    CASE_OF 2,2
        CALL LABEL_03E1
        CALL LABEL_04C2
    CASE_END
    GOTO LABEL_0399

LABEL_0154
    IF 2,0 = 6 THEN GOTO LABEL_015E
    IF 3,0 = 7 THEN GOTO LABEL_0173
    IF 3,0 = 15 THEN GOTO LABEL_0182
    GOTO LABEL_04B9

LABEL_015E
    IF 5,5 = 1 THEN GOTO LABEL_0165
    OUTPUT "PUSH"
    CALL LABEL_0552
    CALL LABEL_03CB
    GOTO LABEL_0399

LABEL_0165
    STORE VAR_0060
    CALL LABEL_047D
    IF INPUT_ERROR = 0 THEN GOTO LABEL_016F
    OUTPUT "***"
    CALL LABEL_0555
    CALL LABEL_04C9
    OUTPUT "*"
    GOTO LABEL_0399

LABEL_016F
    IF VAR_0078 = 0 THEN TAG_WITH 3
    GOTO LABEL_0132

LABEL_0173
    CASE_OF 5,4
        OUTPUT "POP"
        OUTPUT "POP"
        OUTPUT "DAA"
        OUTPUT "AAA"
    CASE_END
    IF VAR_007A = 1 THEN SET VAR_0080,1
    IF 5,5 = 1 THEN GOTO LABEL_0399
    CALL LABEL_0555
    CALL LABEL_03CB
    GOTO LABEL_0399

LABEL_0182
    CASE_OF 5,4
        GOTO LABEL_04B9
        OUTPUT "POP"
        OUTPUT "DAS"
        OUTPUT "AAS"
    CASE_END
    IF 5,5 = 1 THEN GOTO LABEL_0396
    CALL LABEL_0552
    OUTPUT "DS"
    GOTO LABEL_0399

LABEL_018E
    CASE_OF 3,3
        OUTPUT "INC"
        OUTPUT "DEC"
    CASE_END
    CALL LABEL_0552
    CALL LABEL_03C0
    GOTO LABEL_0399

LABEL_0195
    CASE_OF 3,3
        OUTPUT "PUSH"
        OUTPUT "POP"
    CASE_END
    CALL LABEL_0552
    CALL LABEL_03C0
    GOTO LABEL_0399

LABEL_019C
    OUTPUT "J"
    CASE_OF 3,0
        OUTPUT "O"
        OUTPUT "NO"
        OUTPUT "B/NAE/C"
        OUTPUT "NB/AE/NC"
        OUTPUT "E/Z"
        OUTPUT "NE/NZ"
        OUTPUT "BE/NA"
        OUTPUT "A/NBE"
        OUTPUT "S"
        OUTPUT "NS"
        OUTPUT "P/PE"
        OUTPUT "NP/PO"
        OUTPUT "L/NGE"
        OUTPUT "GE/NL"
        OUTPUT "LE/NG"
        OUTPUT "G/NLE"
    CASE_END
    CALL LABEL_0555
    CALL LABEL_04D3
    GOTO LABEL_0399

LABEL_01B2
    CASE_OF 3,2
        GOTO LABEL_01B8
        GOTO LABEL_01DB
        GOTO LABEL_01E4
        GOTO LABEL_01E8
    CASE_END

LABEL_01B8
    EXTRACT_BIT 0
    STORE VAR_005E
    CALL LABEL_047F
    IF INPUT_ERROR = 0 THEN GOTO LABEL_01C2
    OUTPUT "Immed"
    CALL LABEL_0555
    OUTPUT "*"
    GOTO LABEL_0399

LABEL_01C2
    CASE_OF 5,3
        OUTPUT "ADD"
        OUTPUT "OR"
        OUTPUT "ADC"
        OUTPUT "SBB"
        OUTPUT "AND"
        OUTPUT "SUB"
        OUTPUT "XOR"
        OUTPUT "CMP"
    CASE_END
    CALL LABEL_0555
    SET VAR_0070,0
    IF 5,3 = 7 THEN SET VAR_0070,1
    CALL LABEL_0403
    OUTPUT STR_0000    * ","
    LOAD VAR_0062
    CASE_OF 1,0
        CALL LABEL_0464
        CALL LABEL_046D
        CALL LABEL_0464
        CALL LABEL_0464
    CASE_END
    GOTO LABEL_0399

LABEL_01DB
    CASE_OF 1,1
        OUTPUT "TEST"
        OUTPUT "XCHG"
    CASE_END
    CALL LABEL_0555
    EXTRACT_BIT 0
    STORE VAR_005E
    CALL LABEL_03F7
    GOTO LABEL_0399

LABEL_01E4
    OUTPUT STR_000B    * "MOV"
    CALL LABEL_0555
    CALL LABEL_03E1
    GOTO LABEL_0399

LABEL_01E8
    CASE_OF 1,0
        OUTPUT STR_000B    * "MOV"
        OUTPUT "LEA"
        OUTPUT STR_000B    * "MOV"
        OUTPUT "POP"
    CASE_END
    CALL LABEL_0555
    IF 1,0 <> 1 THEN GOTO LABEL_01F5
    SET VAR_005E,1
    CALL LABEL_03F7
    GOTO LABEL_0399

LABEL_01F5
    IF 1,0 <> 3 THEN GOTO LABEL_0201
    CALL LABEL_047F
    IF INPUT_ERROR = 0 THEN GOTO LABEL_01FE
    OUTPUT "*"
    GOTO LABEL_0399

LABEL_01FE
    SET VAR_0070,0
    CALL LABEL_0403
    GOTO LABEL_0399

LABEL_0201
    EXTRACT_BIT 1
    STORE VAR_0070
    SET VAR_005E,1
    CALL LABEL_047F
    IF INPUT_ERROR = 0 THEN GOTO LABEL_020A
    OUTPUT "*"
    GOTO LABEL_0399

LABEL_020A
    STORE VAR_0064
    CASE_OF VAR_0070
        CALL LABEL_0403
        CALL LABEL_03CB
    CASE_END
    OUTPUT STR_0000    * ","
    LOAD VAR_0064
    CASE_OF VAR_0070
        CALL LABEL_03CB
        CALL LABEL_0403
    CASE_END
    GOTO LABEL_0399

LABEL_0216
    IF 3,0 = 10 THEN GOTO LABEL_021C
    IF VAR_007A = 1 THEN SET VAR_0080,1

LABEL_021C
    IF 3,0 >= 8 THEN GOTO LABEL_0229
    IF 7,0 <> 000000090H THEN GOTO LABEL_0224
    OUTPUT "NOP"
    GOTO LABEL_0399

LABEL_0224
    OUTPUT "XCHG"
    CALL LABEL_0555
    OUTPUT "AX,"
    CALL LABEL_03C0
    GOTO LABEL_0399

LABEL_0229
    CASE_OF 2,0
        OUTPUT "CBW"
        OUTPUT "CWD"
        OUTPUT "CALL"
        OUTPUT "WAIT"
        OUTPUT "PUSHF"
        OUTPUT "POPF"
        OUTPUT "SAHF"
        OUTPUT "LAHF"
    CASE_END
    IF 2,0 <> 2 THEN GOTO LABEL_0399
    CALL LABEL_0555
    CALL LABEL_04FE
    GOTO LABEL_0399

LABEL_0239
    CASE_OF 3,1
        GOTO LABEL_024F
        GOTO LABEL_024F
        OUTPUT "MOV"
        OUTPUT "CMP"
        GOTO LABEL_0246
        OUTPUT "STO"
        OUTPUT "LOD"
        OUTPUT "SCA"
    CASE_END
    OUTPUT "S"
    CALL LABEL_0528
    GOTO LABEL_0396

LABEL_0246
    OUTPUT "TEST"
    CALL LABEL_0555
    CALL LABEL_0535
    OUTPUT STR_0000    * ","
    CASE_OF 0,0
        CALL LABEL_0464
        CALL LABEL_046D
    CASE_END
    GOTO LABEL_0399

LABEL_024F
    OUTPUT STR_000B    * "MOV"
    CALL LABEL_0555
    CASE_OF 1,1
        SET VAR_0070,1
        SET VAR_0070,0
    CASE_END
    CASE_OF 1,1
        CALL LABEL_0535
        CALL LABEL_0425
    CASE_END
    OUTPUT STR_0000    * ","
    LOAD VAR_0062
    CASE_OF 1,1
        CALL LABEL_0425
        CALL LABEL_0535
    CASE_END
    GOTO LABEL_0399

LABEL_0260
    OUTPUT STR_000B    * "MOV"
    CALL LABEL_0555
    EXTRACT_BIT 3
    STORE VAR_005E
    LOAD INPUT_DATA
    CALL LABEL_03B0
    OUTPUT STR_0000    * ","
    CASE_OF VAR_005E
        CALL LABEL_0464
        CALL LABEL_046D
    CASE_END
    GOTO LABEL_0399

LABEL_026C
    IF 2,0 <= 1 THEN GOTO LABEL_04B9
    CASE_OF 3,3
        GOTO LABEL_0273
        GOTO LABEL_029B
    CASE_END

LABEL_0273
    CASE_OF 2,0
        NOP
        NOP
        OUTPUT "RET(near)"
        OUTPUT "RET(near)"
        OUTPUT "LES"
        OUTPUT "LDS"
        OUTPUT STR_000B    * "MOV"
        OUTPUT STR_000B    * "MOV"
    CASE_END
    IF 2,0 = 3 THEN GOTO LABEL_0396
    CALL LABEL_0555
    IF 2,0 <> 2 THEN GOTO LABEL_0286
    CALL LABEL_046E
    GOTO LABEL_0399

LABEL_0286
    IF 2,1 = 3 THEN GOTO LABEL_028C
    SET VAR_005E,1
    CALL LABEL_03F7
    GOTO LABEL_0399

LABEL_028C
    CALL LABEL_047F
    IF INPUT_ERROR = 0 THEN GOTO LABEL_0292
    OUTPUT "*"
    GOTO LABEL_0399

LABEL_0292
    SET VAR_0070,0
    CALL LABEL_0403
    OUTPUT STR_0000    * ","
    LOAD VAR_0062
    CASE_OF 0,0
        CALL LABEL_0464
        CALL LABEL_046D
    CASE_END
    GOTO LABEL_0399

LABEL_029B
    CASE_OF 2,0
        NOP
        NOP
        OUTPUT "RET(far)"
        OUTPUT "RET(far)"
        OUTPUT "INT"
        OUTPUT "INT"
        OUTPUT "INTO"
        OUTPUT "IRET"
    CASE_END
    IF 2,0 = 2 THEN GOTO LABEL_02AE
    IF 2,0 = 5 THEN GOTO LABEL_02AE
    IF VAR_007A = 1 THEN SET VAR_0080,1

LABEL_02AE
    IF 7,0 = 0000000CBH THEN GOTO LABEL_0399
    IF 7,0 >= 0000000CEH THEN GOTO LABEL_0399
    CALL LABEL_0555
    CASE_OF 1,0
        OUTPUT "3d"
        CALL LABEL_047F
        CALL LABEL_046E
        NOP
    CASE_END
    LOAD VAR_0062
    IF 1,0 <> 1 THEN GOTO LABEL_0399
    IF INPUT_ERROR = 0 THEN GOTO LABEL_02C4
    OUTPUT STR_0007    * "**"
    GOTO LABEL_0399

LABEL_02C4
    LOAD INPUT_DATA
    OUTPUT ACCUMULATOR,FMT_0024    * 8,DEC,LEFT_JUSTIFIED
    OUTPUT "d"
    GOTO LABEL_0399

LABEL_02C8
    IF 3,3 = 0 THEN GOTO LABEL_02E3
    OUTPUT "ESC"
    CALL LABEL_0555
    OUTPUT ACCUMULATOR,FMT_0022    * 3,OCT,1
    CALL LABEL_047F
    IF INPUT_ERROR = 0 THEN GOTO LABEL_02D4
    OUTPUT "*,*****"
    GOTO LABEL_0399

LABEL_02D4
    ROTATE RIGHT,3
    OUTPUT ACCUMULATOR,FMT_0022    * 3,OCT,1
    OUTPUT "o,"
    SET VAR_005E,0
    SET VAR_0070,1
    LOAD INPUT_DATA
    IF 7,6 <> 3 THEN GOTO LABEL_02E1
    CALL LABEL_03B5
    OUTPUT "/"
    CALL LABEL_03C0
    GOTO LABEL_0399

LABEL_02E1
    CALL LABEL_0403
    GOTO LABEL_0399

LABEL_02E3
    CASE_OF 2,0
        GOTO LABEL_02F8
        GOTO LABEL_02F8
        GOTO LABEL_02F8
        GOTO LABEL_02F8
        OUTPUT "AAM"
        OUTPUT "AAD"
        GOTO LABEL_04B9
        OUTPUT "XLAT"
    CASE_END
    IF 2,0 <> 7 THEN GOTO LABEL_02F6
    IF VAR_0060 = 0 THEN GOTO LABEL_0396
    CALL LABEL_0555
    CALL LABEL_04C9
    GOTO LABEL_0399

LABEL_02F6
    CALL LABEL_047F
    GOTO LABEL_0399

LABEL_02F8
    EXTRACT_BIT 0
    STORE VAR_005E
    CALL LABEL_047F
    IF INPUT_ERROR = 0 THEN GOTO LABEL_0302
    OUTPUT "Shift"
    CALL LABEL_0555
    OUTPUT "*"
    GOTO LABEL_0399

LABEL_0302
    CASE_OF 5,3
        OUTPUT "ROL"
        OUTPUT "ROR"
        OUTPUT "RCL"
        OUTPUT "RCR"
        OUTPUT "SAL/SHL"
        OUTPUT "SHR"
        GOTO LABEL_04BC
        OUTPUT "SAR"
    CASE_END
    CALL LABEL_0555
    SET VAR_0070,0
    SET VAR_0074,1
    CALL LABEL_0403
    OUTPUT STR_0000    * ","
    LOAD VAR_0062
    CASE_OF 1,1
        OUTPUT "1"
        OUTPUT "CL"
    CASE_END
    GOTO LABEL_0399

LABEL_0317
    CASE_OF 3,0
        OUTPUT "LOOPNE/NZ"
        OUTPUT "LOOPE/Z"
        OUTPUT "LOOP"
        OUTPUT "JCXZ"
        OUTPUT STR_0003    * "IN"
        OUTPUT STR_0003    * "IN"
        OUTPUT STR_0001    * "OUT"
        OUTPUT STR_0001    * "OUT"
        OUTPUT "CALL"
        OUTPUT STR_0009    * "JMP"
        OUTPUT STR_0009    * "JMP"
        OUTPUT STR_0009    * "JMP"
        OUTPUT STR_0003    * "IN"
        OUTPUT STR_0003    * "IN"
        OUTPUT STR_0001    * "OUT"
        OUTPUT STR_0001    * "OUT"
    CASE_END
    IF 3,2 <> 3 THEN GOTO LABEL_032F
    IF VAR_007A = 1 THEN SET VAR_0080,1

LABEL_032F
    CALL LABEL_0555
    CASE_OF 3,2
        CALL LABEL_04D3
        CALL LABEL_053B
        CALL LABEL_054B
        CALL LABEL_053B
    CASE_END
    GOTO LABEL_0399

LABEL_0337
    CASE_OF 3,0
        OUTPUT "lock"
        GOTO LABEL_04BC
        OUTPUT "repne/nz"
        OUTPUT "rep/e/z"
        OUTPUT "HLT"
        OUTPUT "CMC"
        GOTO LABEL_034A
        GOTO LABEL_034A
        OUTPUT "CLC"
        OUTPUT "STC"
        OUTPUT "CLI"
        OUTPUT "STI"
        OUTPUT "CLD"
        OUTPUT "STD"
        GOTO LABEL_036F
        GOTO LABEL_036F
    CASE_END
    GOTO LABEL_0396

LABEL_034A
    EXTRACT_BIT 0
    STORE VAR_005E
    CALL LABEL_047F
    IF INPUT_ERROR = 0 THEN GOTO LABEL_0354
    OUTPUT "Grp_1"
    CALL LABEL_0555
    OUTPUT "*"
    GOTO LABEL_0399

LABEL_0354
    STORE VAR_0064
    CASE_OF 5,3
        OUTPUT "TEST"
        GOTO LABEL_04BC
        OUTPUT "NOT"
        OUTPUT "NEG"
        OUTPUT "MUL"
        OUTPUT "IMUL"
        OUTPUT "DIV"
        OUTPUT "IDIV"
    CASE_END
    CALL LABEL_0555
    IF 5,3 > 0 THEN SET VAR_0074,1
    SET VAR_0070,1
    CALL LABEL_0403
    LOAD VAR_0064
    IF 5,3 <> 0 THEN RETURN
    OUTPUT STR_0000    * ","
    CASE_OF VAR_005E
        CALL LABEL_0464
        CALL LABEL_046D
    CASE_END
    GOTO LABEL_0399

LABEL_036F
    EXTRACT_BIT 0
    STORE VAR_005E
    CALL LABEL_047F
    IF INPUT_ERROR = 0 THEN GOTO LABEL_0379
    OUTPUT "Grp_2"
    CALL LABEL_0555
    OUTPUT "*"
    GOTO LABEL_0399

LABEL_0379
    IF VAR_005E = 1 THEN GOTO LABEL_037F
    IF 5,3 > 1 THEN GOTO LABEL_04BC

LABEL_037F
    CASE_OF 5,3
        OUTPUT "INC"
        OUTPUT "DEC"
        OUTPUT "CALL"
        OUTPUT "CALL"
        OUTPUT STR_0009    * "JMP"
        OUTPUT STR_0009    * "JMP"
        OUTPUT "PUSH"
        GOTO LABEL_04BC
    CASE_END
    CALL LABEL_0555
    IF 5,3 <= 1 THEN SET VAR_0074,1
    SET VAR_0070,1
    IF 5,3 = 3 THEN OUTPUT "dwp "
    IF 5,3 = 5 THEN OUTPUT "dwp "
    CALL LABEL_0403
    GOTO LABEL_0399

LABEL_0396
    IF VAR_007A = 1 THEN SET VAR_0080,1

LABEL_0399
    LOAD VAR_0090
    IF VAR_0078 = 0 THEN CALL LABEL_0592
    IF VAR_0078 = 0 THEN RETURN
    IF VAR_0076 <> 1 THEN RETURN
    IF VAR_007E <> 1 THEN RETURN
    IF VAR_007A <> 1 THEN RETURN
    CALL LABEL_047D
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_04BF
    SET VAR_007E,1
    OUTPUT "  "
    GOTO LABEL_0132

LABEL_03B0
    CASE_OF VAR_005E
        CALL LABEL_03B5
        CALL LABEL_03C0
    CASE_END
    RETURN

LABEL_03B5
    CASE_OF 2,0
        OUTPUT "AL"
        OUTPUT "CL"
        OUTPUT "DL"
        OUTPUT "BL"
        OUTPUT "AH"
        OUTPUT "CH"
        OUTPUT "DH"
        OUTPUT "BH"
    CASE_END
    RETURN

LABEL_03C0
    CASE_OF 2,0
        OUTPUT "AX"
        OUTPUT "CX"
        OUTPUT "DX"
        OUTPUT "BX"
        OUTPUT "SP"
        OUTPUT "BP"
        OUTPUT "SI"
        OUTPUT "DI"
    CASE_END
    RETURN

LABEL_03CB
    CASE_OF 4,3
        OUTPUT "E"
        OUTPUT "C"
        OUTPUT "S"
        OUTPUT "D"
    CASE_END
    OUTPUT "S"
    RETURN

LABEL_03D3
    CASE_OF 5,4
        OUTPUT "ADD"
        OUTPUT "ADC"
        OUTPUT "AND"
        OUTPUT "XOR"
    CASE_END
    RETURN

LABEL_03DA
    CASE_OF 5,4
        OUTPUT "OR"
        OUTPUT "SBB"
        OUTPUT "SUB"
        OUTPUT "CMP"
    CASE_END
    RETURN

LABEL_03E1
    EXTRACT_BIT 0
    STORE VAR_005E
    LOAD INPUT_DATA
    CASE_OF 1,1
        CALL LABEL_03E9
        CALL LABEL_03F7
    CASE_END
    RETURN

LABEL_03E9
    CALL LABEL_047F
    IF INPUT_ERROR = 0 THEN GOTO LABEL_03EF
    OUTPUT "*"
    RETURN

LABEL_03EF
    STORE VAR_0064
    SET VAR_0070,0
    CALL LABEL_0403
    OUTPUT STR_0000    * ","
    LOAD VAR_0064
    ROTATE RIGHT,3
    CALL LABEL_03B0
    RETURN

LABEL_03F7
    CALL LABEL_047F
    IF INPUT_ERROR = 0 THEN GOTO LABEL_03FD
    OUTPUT "*"
    RETURN

LABEL_03FD
    ROTATE RIGHT,3
    CALL LABEL_03B0
    OUTPUT STR_0000    * ","
    SET VAR_0070,1
    CALL LABEL_0403
    RETURN

LABEL_0403
    LOAD INPUT_DATA
    STORE VAR_0064
    IF 7,6 = 3 THEN GOTO LABEL_03B0
    IF VAR_0074 = 1 THEN CALL LABEL_052D
    AND 0000000C7H
    IF 7,0 = 6 THEN GOTO LABEL_0425
    CALL LABEL_04C9
    OUTPUT "["
    CASE_OF 2,0
        OUTPUT "BX][SI"
        OUTPUT "BX][DI"
        OUTPUT "BP][SI"
        OUTPUT "BP][DI"
        OUTPUT "SI"
        OUTPUT "DI"
        OUTPUT "BP"
        OUTPUT "BX"
    CASE_END
    IF 7,6 = 0 THEN GOTO LABEL_0423
    OUTPUT "+"
    CASE_OF 7,7
        CALL LABEL_0465
        CALL LABEL_046E
    CASE_END

LABEL_0423
    OUTPUT "]"
    RETURN

LABEL_0425
    SET VAR_006E,0
    CALL LABEL_047F
    IF INPUT_ERROR <> 0 THEN SET VAR_006E,1
    AND CONST_0054
    STORE VAR_006C
    CALL LABEL_047F
    IF INPUT_ERROR = 0 THEN GOTO LABEL_0433
    LOAD VAR_006E
    INCLUSIVE_OR 2
    STORE VAR_006E

LABEL_0433
    AND CONST_0054
    ROTATE LEFT,8
    INCLUSIVE_OR VAR_006C
    STORE VAR_006C
    IF VAR_0078 = 1 THEN GOTO LABEL_0453
    CASE_OF VAR_0070
        LOAD VAR_008A
        LOAD VAR_008C
    CASE_END
    STORE QUALIFY_VALUE
    LOAD VAR_0088
    STORE QUALIFY_MASK
    INPUT REL,1,QUALIFIED
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_0453
    LOAD INPUT_ADDRESS
    IF_NOT_MAPPED THEN NOP
    STORE VAR_005A
    LOAD RETURN_FLAGS
    IF 16,16 = 0 THEN GOTO LABEL_0453
    IF 17,17 = 1 THEN RETURN
    LOAD VAR_005A
    OUTPUT ACCUMULATOR,FMT_0020    * 20,HEX,5
    RETURN

LABEL_0453
    CALL LABEL_04C9
    LOAD VAR_006C
    ROTATE RIGHT,8
    CASE_OF VAR_006E
        OUTPUT ACCUMULATOR,FMT_001C    * 8,HEX,2
        OUTPUT ACCUMULATOR,FMT_001C    * 8,HEX,2
        OUTPUT STR_0007    * "**"
        OUTPUT STR_0007    * "**"
    CASE_END
    LOAD VAR_006C
    CASE_OF VAR_006E
        OUTPUT ACCUMULATOR,FMT_001C    * 8,HEX,2
        OUTPUT STR_0007    * "**"
        OUTPUT ACCUMULATOR,FMT_001C    * 8,HEX,2
        OUTPUT STR_0007    * "**"
    CASE_END
    RETURN

LABEL_0464
    OUTPUT "#"

LABEL_0465
    CALL LABEL_047F
    IF INPUT_ERROR = 0 THEN GOTO LABEL_046B
    OUTPUT STR_0007    * "**"
    RETURN

LABEL_046B
    OUTPUT ACCUMULATOR,FMT_001C    * 8,HEX,2
    RETURN

LABEL_046D
    OUTPUT "#"

LABEL_046E
    POSITION REL,2
    CALL LABEL_0465
    STORE VAR_005A
    POSITION REL,-4
    CALL LABEL_0465
    ROTATE LEFT,8
    INCLUSIVE_OR VAR_005A
    POSITION REL,2
    RETURN
    POSITION REL,4
    CALL LABEL_046E
    POSITION REL,-8
    CALL LABEL_046E
    POSITION REL,4
    RETURN

LABEL_047D
    LOAD VAR_0086
    GOTO LABEL_0481

LABEL_047F
    LOAD VAR_0084
    GOTO LABEL_0481

LABEL_0481
    INCREMENT VAR_007E
    STORE QUALIFY_VALUE
    LOAD VAR_0082
    STORE QUALIFY_MASK
    IF VAR_0078 = 0 THEN GOTO LABEL_04A9
    IF VAR_0076 = 0 THEN GOTO LABEL_04A9
    IF VAR_007A = 1 THEN GOTO LABEL_049E
    INCREMENT VAR_0092
    INPUT ABS,VAR_0092,QUALIFIED
    CALL LABEL_059E
    IF INPUT_ERROR <> 0 THEN RETURN
    LOAD INPUT_TAG
    INCLUSIVE_OR 1
    STORE VAR_005C
    TAG_WITH VAR_005C
    SET VAR_007A,1
    LOAD INPUT_DATA
    STORE VAR_007C
    AND CONST_0054
    STORE INPUT_DATA
    RETURN

LABEL_049E
    LOAD INPUT_TAG
    INCLUSIVE_OR 2
    STORE VAR_005C
    TAG_WITH VAR_005C
    SET VAR_007A,0
    LOAD VAR_007C
    ROTATE RIGHT,8
    AND CONST_0054
    STORE INPUT_DATA
    INCREMENT VAR_0092
    RETURN

LABEL_04A9
    INCREMENT VAR_0092
    INPUT ABS,VAR_0092,QUALIFIED
    IF VAR_0078 = 0 THEN GOTO LABEL_04B3
    CALL LABEL_059E
    IF INPUT_ERROR <> 0 THEN RETURN
    TAG_WITH 3

LABEL_04B3
    IF INPUT_ERROR <> 0 THEN RETURN
    LOAD INPUT_DATA
    STORE VAR_007C
    RETURN

LABEL_04B9
    POSITION ABS,3
    OUTPUT "Illegal Opcode"
    ABORT

LABEL_04BC
    POSITION ABS,3
    OUTPUT "Illegal Instruction"
    ABORT

LABEL_04BF
    POSITION ABS,3
    OUTPUT "Data Acquisition Error "
    ABORT

LABEL_04C2
    CALL LABEL_0535
    OUTPUT ",#"
    CASE_OF 0,0
        CALL LABEL_0465
        CALL LABEL_046E
    CASE_END
    RETURN

LABEL_04C9
    IF VAR_0060 = 0 THEN RETURN
    STORE VAR_005A
    LOAD VAR_0060
    CALL LABEL_03CB
    OUTPUT ":"
    LOAD VAR_005A
    RETURN

LABEL_04D2
    OUTPUT "s "

LABEL_04D3
    CALL LABEL_047F
    IF INPUT_ERROR = 0 THEN GOTO LABEL_04D9
    OUTPUT "*****"
    RETURN

LABEL_04D9
    AND CONST_0054
    IF 7,7 = 1 THEN INCLUSIVE_OR 0000FFF00H
    ADD VAR_0092
    ADD 1
    AND CONST_0056
    IF_NOT_MAPPED THEN OUTPUT ACCUMULATOR,FMT_0020    * 20,HEX,5
    RETURN

LABEL_04E3
    OUTPUT "np "
    CALL LABEL_047F
    IF INPUT_ERROR = 0 THEN GOTO LABEL_04EA
    OUTPUT "*****"
    RETURN

LABEL_04EA
    AND CONST_0054
    STORE VAR_005A
    CALL LABEL_047F
    IF INPUT_ERROR = 0 THEN GOTO LABEL_04F2
    OUTPUT "*****"
    RETURN

LABEL_04F2
    AND CONST_0054
    ROTATE LEFT,8
    INCLUSIVE_OR VAR_005A
    IF 15,15 = 1 THEN INCLUSIVE_OR 0000F0000H
    ADD VAR_0092
    ADD 1
    AND 0000FFFFFH
    IF_NOT_MAPPED THEN OUTPUT ACCUMULATOR,FMT_0020    * 20,HEX,5
    RETURN

LABEL_04FE
    OUTPUT "fp "
    CALL LABEL_047F
    IF INPUT_ERROR = 0 THEN GOTO LABEL_0505
    OUTPUT "*****"
    RETURN

LABEL_0505
    AND CONST_0054
    STORE VAR_0066
    CALL LABEL_047F
    IF INPUT_ERROR = 0 THEN GOTO LABEL_050D
    OUTPUT "*****"
    RETURN

LABEL_050D
    AND CONST_0054
    ROTATE LEFT,8
    INCLUSIVE_OR VAR_0066
    STORE VAR_0066
    CALL LABEL_047F
    IF INPUT_ERROR = 0 THEN GOTO LABEL_0517
    OUTPUT "*****"
    RETURN

LABEL_0517
    AND CONST_0054
    STORE VAR_0068
    CALL LABEL_047F
    IF INPUT_ERROR = 0 THEN GOTO LABEL_051F
    OUTPUT "*****"
    RETURN

LABEL_051F
    AND CONST_0054
    ROTATE LEFT,8
    INCLUSIVE_OR VAR_0068
    ROTATE LEFT,4
    STORE VAR_0068
    ADD VAR_0066
    IF_NOT_MAPPED THEN OUTPUT ACCUMULATOR,FMT_0020    * 20,HEX,5
    RETURN

LABEL_0528
    CASE_OF 0,0
        OUTPUT "B"
        OUTPUT "W"
    CASE_END
    RETURN

LABEL_052D
    LOAD VAR_0062
    CASE_OF 0,0
        OUTPUT "b"
        OUTPUT "w"
    CASE_END
    OUTPUT "p "
    LOAD VAR_0064
    RETURN

LABEL_0535
    OUTPUT "A"
    CASE_OF 0,0
        OUTPUT "L"
        OUTPUT "X"
    CASE_END
    RETURN

LABEL_053B
    CASE_OF 1,1
        CALL LABEL_0535
        CALL LABEL_0546
    CASE_END
    OUTPUT STR_0000    * ","
    LOAD VAR_0062
    CASE_OF 1,1
        CALL LABEL_0546
        CALL LABEL_0535
    CASE_END
    RETURN

LABEL_0546
    CASE_OF 3,3
        CALL LABEL_0464
        OUTPUT "DX"
    CASE_END
    RETURN

LABEL_054B
    CASE_OF 1,0
        CALL LABEL_04E3
        CALL LABEL_04E3
        CALL LABEL_04FE
        CALL LABEL_04D2
    CASE_END
    RETURN

LABEL_0552
    IF VAR_007A = 1 THEN SET VAR_0080,1

LABEL_0555
    IF VAR_0076 <> 1 THEN SET VAR_0080,0
    IF VAR_0078 <> 1 THEN SET VAR_0080,0
    CASE_OF VAR_0080
        CALL LABEL_0560
        POSITION REL,1
    CASE_END
    RETURN

LABEL_0560
    CASE_OF VAR_008E
        POSITION ABS,13
        POSITION ABS,15
    CASE_END
    RETURN

LABEL_0565
    SET VAR_0060,0
    IF VAR_0078 = 1 THEN RETURN
    LOAD VAR_0092
    SUBTRACT 1
    STORE VAR_005A
    LOAD VAR_0082
    STORE QUALIFY_MASK
    LOAD VAR_0086
    STORE QUALIFY_VALUE
    INPUT REL,-1,QUALIFIED
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_0586
    IF INPUT_ADDRESS <> VAR_005A THEN GOTO LABEL_0586
    LOAD INPUT_DATA
    AND 0000000FFH
    STORE INPUT_DATA
    IF INPUT_DATA = 38 THEN STORE VAR_0060
    IF INPUT_DATA = 54 THEN STORE VAR_0060
    IF INPUT_DATA = 46 THEN STORE VAR_0060
    IF INPUT_DATA = 62 THEN STORE VAR_0060

LABEL_0586
    INPUT REL,0
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_04BF
    LOAD INPUT_DATA
    AND 0000000FFH
    STORE INPUT_DATA
    IF VAR_0060 = 0 THEN RETURN
    TAG_WITH 3
    RETURN

LABEL_0592
    STORE VAR_005A
    LOAD ID_CODE
    IF 7,0 = CONST_0058 THEN RETURN
    LOAD VAR_005A
    AND 000000099H
    POSITION ABS,35
    IF 7,0 = 000000099H THEN OUTPUT "lbc"
    RETURN

LABEL_059E
    IF TASK = 3 THEN RETURN
    IF VAR_0094 = 1 THEN SET INPUT_ERROR,1
    IF INPUT_ERROR <> 0 THEN RETURN
    LOAD INPUT_TAG
    IF 17,16 <> 3 THEN RETURN
    IF VAR_0076 = 0 THEN GOTO LABEL_05B1
    IF 0,0 = 1 THEN RETURN

LABEL_05B1
    SET VAR_0094,1
    SET INPUT_ERROR,1
    RETURN
