"IAL"

*
* Original Source File Name: d:\ial\procs\insc800_
*

CONST_0034      CONSTANT 00000FFDFH
CONST_0036      CONSTANT 000000080H
CONST_0038      CONSTANT 000000081H
CONST_003A      CONSTANT 0000000F0H
CONST_003C      CONSTANT 000000077H
CONST_003E      CONSTANT 000000058H
CONST_0040      CONSTANT 000000050H
STR_0000        ASCII "dma cycle"
STR_0005        ASCII "interrupt ack"
STR_000C        ASCII "unknown"
STR_0010        ASCII " (bus req)"
STR_0016        ASCII " (nmi req)"
STR_001C        ASCII " (restart req)"
VAR_0042        VARIABLE 000000000H
VAR_0044        VARIABLE 000000000H
VAR_0046        VARIABLE 000000000H
VAR_0048        VARIABLE 000000000H
VAR_004A        VARIABLE 000000000H
VAR_004C        VARIABLE 000000000H
VAR_004E        VARIABLE 000000000H
VAR_0050        VARIABLE 000000000H
VAR_0052        VARIABLE 000000000H
VAR_0054        VARIABLE 000000000H
VAR_0056        VARIABLE 000000000H
VAR_0058        VARIABLE 000000000H
VAR_005A_UNREF  VARIABLE 000000000H
VAR_005C_UNREF  VARIABLE 000000000H
FMT_0024        FORMAT 8,HEX,2
FMT_0026        FORMAT 16,HEX,4
        LABEL_TITLE      "NSC800 Mnemonic"
        BASE_TITLE       "   hex"
        DEFAULT_WIDTH    32
        MAPPED_WIDTH     32

ENTRY_POINT
    LOAD ID_CODE
    AND 0000000FFH
    STORE ID_CODE
    SET VAR_0046,0
    SET VAR_0048,0
    SET VAR_004C,0
    SET VAR_004E,0
    SET RETURN_FLAGS,1
    LOAD 63
    IF ID_CODE = CONST_0038 THEN LOAD 31
    IF ID_CODE = CONST_003A THEN LOAD CONST_003C
    STORE VAR_0056
    LOAD 62
    IF ID_CODE = CONST_0038 THEN LOAD 30
    IF ID_CODE = CONST_003A THEN LOAD 54
    STORE VAR_0054
    IF TASK = 3 THEN GOTO LABEL_0023
    IF TASK = 4 THEN GOTO LABEL_0023
    IF TASK = 5 THEN GOTO LABEL_0023
    OUTPUT "Illegal Task Request"
    ABORT

LABEL_0023
    LOAD INPUT_TAG
    IF 1,0 = 2 THEN GOTO LABEL_002C
    LOAD INPUT_STATUS
    AND VAR_0056
    IF 7,0 = VAR_0054 THEN GOTO LABEL_007E

LABEL_002C
    SET RETURN_FLAGS,0
    POSITION ABS,3
    LOAD INITIAL_DATA
    OUTPUT ACCUMULATOR,FMT_0024    * 8,HEX,2
    POSITION REL,1
    IF TASK = 4 THEN GOTO LABEL_0049
    IF TASK = 5 THEN GOTO LABEL_0049
    IF ID_CODE = CONST_0036 THEN GOTO LABEL_0049
    IF ID_CODE = CONST_003A THEN GOTO LABEL_0055
    CALL LABEL_0064
    CASE_OF 7,5
        OUTPUT STR_0010    * " (bus req)"
        OUTPUT STR_0010    * " (bus req)"
        OUTPUT STR_0010    * " (bus req)"
        OUTPUT STR_0010    * " (bus req)"
        OUTPUT STR_0016    * " (nmi req)"
        OUTPUT STR_0016    * " (nmi req)"
        OUTPUT STR_001C    * " (restart req)"
        NOP
    CASE_END
    RETURN

LABEL_0049
    LOAD INPUT_STATUS
    CASE_OF 5,3
        OUTPUT STR_000C    * "unknown"
        OUTPUT STR_000C    * "unknown"
        CALL LABEL_007B
        OUTPUT STR_0000    * "dma cycle"
        CALL LABEL_007B
        OUTPUT STR_0005    * "interrupt ack"
        CALL LABEL_007B
        CALL LABEL_0064
    CASE_END
    RETURN

LABEL_0055
    LOAD INPUT_STATUS
    AND CONST_003E
    IF 6,0 <> CONST_0040 THEN GOTO LABEL_005C
    CALL LABEL_007B
    RETURN

LABEL_005C
    LOAD INPUT_STATUS
    CASE_OF 5,4
        OUTPUT STR_000C    * "unknown"
        OUTPUT STR_0000    * "dma cycle"
        CALL LABEL_0064
        CALL LABEL_0064
    CASE_END
    RETURN

LABEL_0064
    LOAD INPUT_STATUS
    IF 4,4 = 1 THEN GOTO LABEL_006A
    OUTPUT STR_0005    * "interrupt ack"
    RETURN

LABEL_006A
    IF ID_CODE = CONST_003A THEN GOTO LABEL_0070
    IF 3,3 = 0 THEN GOTO LABEL_007B

LABEL_0070
    CASE_OF 2,0
        OUTPUT "halt"
        OUTPUT STR_000C    * "unknown"
        OUTPUT "memory write"
        OUTPUT "i/o write"
        OUTPUT "memory read"
        OUTPUT "i/o read"
        OUTPUT "opcode"
        OUTPUT STR_000C    * "unknown"
    CASE_END
    RETURN

LABEL_007B
    POSITION ABS,3
    OUTPUT "xx refresh"
    RETURN

LABEL_007E
    LOAD INPUT_TAG
    IF 1,0 = 0 THEN CALL LABEL_035D
    IF 1,0 = 2 THEN GOTO LABEL_002C
    TAG_WITH 1
    LOAD INPUT_DATA
    CASE_OF 7,6
        GOTO LABEL_008D
        GOTO LABEL_0097
        GOTO LABEL_00A2
        GOTO LABEL_00A8
    CASE_END

LABEL_008D
    CASE_OF 2,0
        GOTO LABEL_00B2
        GOTO LABEL_00C6
        GOTO LABEL_00D1
        GOTO LABEL_00ED
        GOTO LABEL_00F4
        GOTO LABEL_00F4
        GOTO LABEL_00FB
        GOTO LABEL_0101
    CASE_END

LABEL_0097
    IF 7,0 <> 000000076H THEN GOTO LABEL_009C
    OUTPUT "HALT"
    RETURN

LABEL_009C
    OUTPUT "LD"
    POSITION ABS,6
    CALL LABEL_02C6
    OUTPUT ","
    CALL LABEL_02C9
    RETURN

LABEL_00A2
    CALL LABEL_0352
    CASE_OF 6,6
        CALL LABEL_02C9
        CALL LABEL_02FE
    CASE_END
    RETURN

LABEL_00A8
    CASE_OF 2,0
        GOTO LABEL_010C
        GOTO LABEL_0119
        GOTO LABEL_010C
        GOTO LABEL_0127
        GOTO LABEL_010C
        GOTO LABEL_014C
        GOTO LABEL_00A2
        GOTO LABEL_013F
    CASE_END

LABEL_00B2
    CASE_OF 5,3
        OUTPUT "NOP"
        OUTPUT "EX   AF,AF'"
        OUTPUT "DJNZ"
    CASE_END
    IF 5,3 < 2 THEN RETURN
    IF 5,3 >= 3 THEN OUTPUT "JR"
    POSITION ABS,6
    IF 5,5 <> 1 THEN GOTO LABEL_00C4
    AND CONST_0034
    CALL LABEL_02F3
    OUTPUT ","

LABEL_00C4
    CALL LABEL_039A
    RETURN

LABEL_00C6
    CASE_OF 3,3
        OUTPUT "LD   "
        OUTPUT "ADD  HL,"
    CASE_END
    CALL LABEL_02E1
    IF 3,3 = 1 THEN RETURN
    OUTPUT ","
    CALL LABEL_0307
    RETURN

LABEL_00D1
    OUTPUT "LD"
    POSITION ABS,6
    IF 3,3 = 0 THEN OUTPUT "["
    CASE_OF 5,3
        OUTPUT "BC],A"
        OUTPUT "A,[BC]"
        OUTPUT "DE],A"
        OUTPUT "A,[DE]"
        CALL LABEL_0307
        OUTPUT "HL,["
        CALL LABEL_0307
        OUTPUT "A,["
    CASE_END
    IF 5,5 = 0 THEN RETURN
    CASE_OF 4,3
        OUTPUT "],HL"
        CALL LABEL_0307
        OUTPUT "],A"
        CALL LABEL_0307
    CASE_END
    IF 3,3 = 1 THEN OUTPUT "]"
    RETURN

LABEL_00ED
    CASE_OF 3,3
        OUTPUT "INC"
        OUTPUT "DEC"
    CASE_END
    POSITION ABS,6
    CALL LABEL_02E1
    RETURN

LABEL_00F4
    CASE_OF 0,0
        OUTPUT "INC"
        OUTPUT "DEC"
    CASE_END
    POSITION ABS,6
    CALL LABEL_02C6
    RETURN

LABEL_00FB
    OUTPUT "LD"
    POSITION ABS,6
    CALL LABEL_02C6
    OUTPUT ","
    CALL LABEL_02FE
    RETURN

LABEL_0101
    CASE_OF 5,3
        OUTPUT "RLCA"
        OUTPUT "RRCA"
        OUTPUT "RLA"
        OUTPUT "RRA"
        OUTPUT "DAA"
        OUTPUT "CPL"
        OUTPUT "SCF"
        OUTPUT "CCF"
    CASE_END
    RETURN

LABEL_010C
    CASE_OF 2,1
        OUTPUT "RET"
        OUTPUT "JP"
        OUTPUT "CALL"
    CASE_END
    POSITION ABS,6
    CALL LABEL_02F3
    IF 2,1 = 0 THEN RETURN
    OUTPUT ","
    CALL LABEL_0307
    RETURN

LABEL_0119
    IF 3,3 = 0 THEN OUTPUT "POP  "
    CASE_OF 5,3
        OUTPUT "BC"
        OUTPUT "RET"
        OUTPUT "DE"
        OUTPUT "EXX"
        OUTPUT "HL"
        OUTPUT "JP   [HL]"
        OUTPUT "AF"
        OUTPUT "LD   SP,HL"
    CASE_END
    RETURN

LABEL_0127
    CASE_OF 5,3
        OUTPUT "JP   "
        GOTO LABEL_015D
        OUTPUT "OUT  ["
        OUTPUT "IN   A,["
        OUTPUT "EX   [SP],HL"
        OUTPUT "EX   DE,HL"
        OUTPUT "DI"
        OUTPUT "EI"
    CASE_END
    CASE_OF 5,3
        CALL LABEL_0307
        NOP
        CALL LABEL_02FE
        CALL LABEL_02FE
    CASE_END
    LOAD INITIAL_DATA
    CASE_OF 5,3
        NOP
        NOP
        OUTPUT "],A"
        OUTPUT "]"
    CASE_END
    RETURN

LABEL_013F
    OUTPUT "RST"
    POSITION ABS,6
    CASE_OF 5,3
        OUTPUT "0"
        OUTPUT "8"
        OUTPUT "10"
        OUTPUT "18"
        OUTPUT "20"
        OUTPUT "28"
        OUTPUT "30"
        OUTPUT "38"
    CASE_END
    RETURN

LABEL_014C
    IF 3,3 = 0 THEN OUTPUT "PUSH "
    CASE_OF 5,3
        OUTPUT "BC"
        OUTPUT "CALL "
        OUTPUT "DE"
        GOTO LABEL_015D
        OUTPUT "HL"
        GOTO LABEL_015D
        OUTPUT "AF"
        GOTO LABEL_015D
    CASE_END
    IF 5,3 = 1 THEN CALL LABEL_0307
    RETURN

LABEL_015D
    IF VAR_0046 <> 0 THEN STORE VAR_0048
    IF VAR_0046 = 0 THEN STORE VAR_0046
    CASE_OF 5,4
        GOTO LABEL_0169
        GOTO LABEL_0187
        GOTO LABEL_0191
        GOTO LABEL_0187
    CASE_END

LABEL_0169
    IF VAR_0046 = 0000000DDH THEN GOTO LABEL_029D
    IF VAR_0046 = 0000000FDH THEN GOTO LABEL_029D
    CALL LABEL_0334
    TAG_WITH 2
    LOAD INPUT_DATA
    CASE_OF 7,6
        GOTO LABEL_0178
        GOTO LABEL_017C
        GOTO LABEL_017C
        GOTO LABEL_017C
    CASE_END

LABEL_0178
    CALL LABEL_02E8
    POSITION ABS,6
    CALL LABEL_02C9
    RETURN

LABEL_017C
    CASE_OF 7,6
        NOP
        OUTPUT "BIT"
        OUTPUT "RES"
        OUTPUT "SET"
    CASE_END
    POSITION ABS,6
    CALL LABEL_02D6
    OUTPUT ","
    CALL LABEL_02C9
    RETURN

LABEL_0187
    CALL LABEL_0334
    TAG_WITH 2
    LOAD INPUT_DATA
    CASE_OF 7,6
        GOTO LABEL_0209
        GOTO LABEL_025B
        GOTO LABEL_0274
        GOTO LABEL_027A
    CASE_END
    RETURN

LABEL_0191
    CALL LABEL_0334
    TAG_WITH 2
    LOAD INPUT_DATA
    CASE_OF 7,6
        GOTO LABEL_034C
        GOTO LABEL_019A
        GOTO LABEL_01EF
        GOTO LABEL_034C
    CASE_END

LABEL_019A
    CASE_OF 2,0
        GOTO LABEL_01A4
        GOTO LABEL_01A4
        GOTO LABEL_01B0
        GOTO LABEL_01B8
        GOTO LABEL_01C8
        GOTO LABEL_01CD
        GOTO LABEL_01D6
        GOTO LABEL_01E4
    CASE_END

LABEL_01A4
    IF 5,3 = 6 THEN GOTO LABEL_034C
    CASE_OF 0,0
        OUTPUT "IN   "
        OUTPUT "OUT  [C],"
    CASE_END
    CALL LABEL_02C6
    IF 0,0 = 0 THEN OUTPUT ",[C]"
    RETURN

LABEL_01B0
    CASE_OF 3,3
        OUTPUT "SBC"
        OUTPUT "ADC"
    CASE_END
    POSITION ABS,6
    OUTPUT "HL,"
    CALL LABEL_02E1
    RETURN

LABEL_01B8
    IF 5,4 = 2 THEN GOTO LABEL_034C
    OUTPUT "LD"
    POSITION ABS,6
    SET VAR_004C,3
    CASE_OF 3,3
        CALL LABEL_0307
        CALL LABEL_02E1
    CASE_END
    OUTPUT ","
    CASE_OF 3,3
        CALL LABEL_02E1
        CALL LABEL_0307
    CASE_END
    RETURN

LABEL_01C8
    IF 5,3 <> 0 THEN GOTO LABEL_034C
    OUTPUT "NEG"
    RETURN

LABEL_01CD
    IF 5,4 <> 0 THEN GOTO LABEL_034C
    OUTPUT "RET"
    CASE_OF 3,3
        OUTPUT "N"
        OUTPUT "I"
    CASE_END
    RETURN

LABEL_01D6
    IF 5,3 > 3 THEN GOTO LABEL_034C
    IF 5,3 = 1 THEN GOTO LABEL_034C
    OUTPUT "IM "
    CASE_OF 4,3
        OUTPUT "0"
        NOP
        OUTPUT "1"
        OUTPUT "2"
    CASE_END
    RETURN

LABEL_01E4
    CASE_OF 5,3
        OUTPUT "LD   I,A"
        OUTPUT "LD   R,A"
        OUTPUT "LD   A,I"
        OUTPUT "LD   A,R"
        OUTPUT "RRD"
        OUTPUT "RLD"
        GOTO LABEL_034C
        GOTO LABEL_034C
    CASE_END
    RETURN

LABEL_01EF
    IF 5,5 = 0 THEN GOTO LABEL_034C
    IF 2,2 = 1 THEN GOTO LABEL_034C
    CASE_OF 1,0
        OUTPUT "LD"
        OUTPUT "CP"
        OUTPUT "IN"
        OUTPUT "O"
    CASE_END
    IF 1,0 <> 3 THEN GOTO LABEL_0202
    CASE_OF 4,4
        OUTPUT "UT"
        OUTPUT "T"
    CASE_END

LABEL_0202
    CASE_OF 4,3
        OUTPUT "I"
        OUTPUT "D"
        OUTPUT "IR"
        OUTPUT "DR"
    CASE_END
    RETURN

LABEL_0209
    CASE_OF 2,0
        GOTO LABEL_034C
        GOTO LABEL_0213
        GOTO LABEL_022E
        GOTO LABEL_023E
        GOTO LABEL_0248
        GOTO LABEL_0248
        GOTO LABEL_0248
        GOTO LABEL_034C
    CASE_END

LABEL_0213
    IF 3,3 = 1 THEN OUTPUT "ADD  "
    IF 5,3 = 4 THEN OUTPUT "LD   "
    CASE_OF 5,3
        GOTO LABEL_034C
        OUTPUT "xx,BC"
        GOTO LABEL_034C
        OUTPUT "xx,DE"
        OUTPUT "xx,"
        NOP
        GOTO LABEL_034C
        OUTPUT "xx,SP"
    CASE_END
    IF 5,3 = 4 THEN CALL LABEL_0307
    POSITION ABS,6
    CALL LABEL_033E
    IF 5,3 <> 5 THEN RETURN
    OUTPUT ","
    CALL LABEL_033E
    RETURN

LABEL_022E
    IF 5,4 <> 2 THEN GOTO LABEL_034C
    OUTPUT "LD"
    POSITION ABS,6
    SET VAR_004C,3
    CASE_OF 3,3
        CALL LABEL_0307
        CALL LABEL_033E
    CASE_END
    OUTPUT ","
    CASE_OF 3,3
        CALL LABEL_033E
        CALL LABEL_0307
    CASE_END
    RETURN

LABEL_023E
    IF 5,4 <> 2 THEN GOTO LABEL_034C
    CASE_OF 3,3
        OUTPUT "INC"
        OUTPUT "DEC"
    CASE_END
    POSITION ABS,6
    CALL LABEL_033E
    RETURN

LABEL_0248
    IF 5,3 <> 6 THEN GOTO LABEL_034C
    CASE_OF 1,0
        OUTPUT "INC"
        OUTPUT "DEC"
        OUTPUT "LD"
        GOTO LABEL_034C
    CASE_END
    POSITION ABS,6
    STORE VAR_004A
    CALL LABEL_0346
    LOAD VAR_004A
    IF 2,0 <> 6 THEN RETURN
    OUTPUT ","
    CALL LABEL_02FE
    RETURN

LABEL_025B
    OUTPUT "LD"
    POSITION ABS,6
    IF 2,0 = 6 THEN GOTO LABEL_0264
    IF 5,3 = 6 THEN GOTO LABEL_026B
    GOTO LABEL_034C

LABEL_0264
    IF 5,3 = 6 THEN GOTO LABEL_034C
    CALL LABEL_02C6
    OUTPUT ","
    CALL LABEL_0346
    RETURN

LABEL_026B
    IF 2,0 = 6 THEN GOTO LABEL_034C
    STORE VAR_004A
    CALL LABEL_0346
    LOAD VAR_004A
    OUTPUT ","
    CALL LABEL_02C9
    RETURN

LABEL_0274
    IF 2,0 <> 6 THEN GOTO LABEL_034C
    CALL LABEL_0352
    CALL LABEL_0346
    RETURN

LABEL_027A
    IF 7,0 = 0000000CBH THEN GOTO LABEL_015D
    IF 0,0 = 0 THEN GOTO LABEL_034C
    IF 2,0 = 7 THEN GOTO LABEL_034C
    IF 2,0 = 1 THEN GOTO LABEL_028F
    IF 5,3 <> 4 THEN GOTO LABEL_034C
    CASE_OF 1,1
        OUTPUT "PUSH "
        OUTPUT "EX   [SP],"
    CASE_END
    CALL LABEL_033E
    RETURN

LABEL_028F
    IF 5,5 = 0 THEN GOTO LABEL_034C
    CASE_OF 4,3
        OUTPUT "POP  "
        OUTPUT "JP   ["
        GOTO LABEL_034C
        OUTPUT "LD   SP,"
    CASE_END
    CALL LABEL_033E
    IF 5,3 = 5 THEN OUTPUT "]"
    RETURN

LABEL_029D
    INCREMENT INPUT_ADDRESS
    INCREMENT INPUT_ADDRESS
    LOAD 63
    STORE QUALIFY_MASK
    LOAD 60
    STORE QUALIFY_VALUE
    INPUT ABS,INPUT_ADDRESS,QUALIFIED
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_034F
    LOAD INPUT_DATA
    IF 2,0 <> 6 THEN GOTO LABEL_034C
    CASE_OF 7,6
        GOTO LABEL_02B1
        GOTO LABEL_02B8
        GOTO LABEL_02B8
        GOTO LABEL_02B8
    CASE_END

LABEL_02B1
    CALL LABEL_02E8
    POSITION ABS,6
    LOAD INPUT_ADDRESS
    SUBTRACT 2
    STORE INPUT_ADDRESS
    CALL LABEL_0346
    RETURN

LABEL_02B8
    CASE_OF 7,6
        NOP
        OUTPUT "BIT"
        OUTPUT "RES"
        OUTPUT "SET"
    CASE_END
    POSITION ABS,6
    CALL LABEL_02D6
    OUTPUT ","
    LOAD INPUT_ADDRESS
    SUBTRACT 2
    STORE INPUT_ADDRESS
    CALL LABEL_0346
    RETURN

LABEL_02C6
    STORE VAR_004A
    ROTATE RIGHT,3
    GOTO LABEL_02CA

LABEL_02C9
    STORE VAR_004A

LABEL_02CA
    CASE_OF 2,0
        OUTPUT "B"
        OUTPUT "C"
        OUTPUT "D"
        OUTPUT "E"
        OUTPUT "H"
        OUTPUT "L"
        OUTPUT "[HL]"
        OUTPUT "A"
    CASE_END
    LOAD VAR_004A
    RETURN

LABEL_02D6
    CASE_OF 5,3
        OUTPUT "0"
        OUTPUT "1"
        OUTPUT "2"
        OUTPUT "3"
        OUTPUT "4"
        OUTPUT "5"
        OUTPUT "6"
        OUTPUT "7"
    CASE_END
    RETURN

LABEL_02E1
    CASE_OF 5,4
        OUTPUT "BC"
        OUTPUT "DE"
        OUTPUT "HL"
        OUTPUT "SP"
    CASE_END
    RETURN

LABEL_02E8
    CASE_OF 5,3
        OUTPUT "RLC"
        OUTPUT "RRC"
        OUTPUT "RL"
        OUTPUT "RR"
        OUTPUT "SLA"
        OUTPUT "SRA"
        GOTO LABEL_034C
        OUTPUT "SRL"
    CASE_END
    RETURN

LABEL_02F3
    CASE_OF 5,3
        OUTPUT "NZ"
        OUTPUT "Z"
        OUTPUT "NC"
        OUTPUT "C"
        OUTPUT "PO"
        OUTPUT "PE"
        OUTPUT "P"
        OUTPUT "M"
    CASE_END
    RETURN

LABEL_02FE
    CALL LABEL_032D
    LOAD INPUT_DATA
    IF INPUT_ERROR = 0 THEN OUTPUT ACCUMULATOR,FMT_0024    * 8,HEX,2
    IF INPUT_ERROR <> 0 THEN OUTPUT "**"
    RETURN

LABEL_0307
    SET VAR_0042,1
    GOTO LABEL_030A
    SET VAR_0042,0

LABEL_030A
    STORE VAR_004A
    LOAD VAR_004C
    IF 1,1 = 1 THEN OUTPUT "["
    CALL LABEL_032D
    IF INPUT_ERROR = 0 THEN GOTO LABEL_0317
    SET VAR_0042,0
    POSITION REL,2
    OUTPUT "**"
    POSITION REL,-4

LABEL_0317
    LOAD INPUT_DATA
    STORE VAR_0044
    CALL LABEL_032D
    IF INPUT_ERROR = 0 THEN GOTO LABEL_031F
    SET VAR_0042,0
    OUTPUT "**"

LABEL_031F
    IF VAR_0042 = 0 THEN GOTO LABEL_0327
    LOAD INPUT_DATA
    ROTATE LEFT,8
    INCLUSIVE_OR VAR_0044
    IF_NOT_MAPPED THEN OUTPUT ACCUMULATOR,FMT_0026    * 16,HEX,4

LABEL_0327
    LOAD VAR_004C
    IF 0,0 = 1 THEN OUTPUT "]"
    LOAD VAR_004A
    RETURN

LABEL_032D
    INCREMENT INPUT_ADDRESS
    LOAD 60
    STORE QUALIFY_VALUE
    LOAD 63
    STORE QUALIFY_MASK
    INPUT ABS,INPUT_ADDRESS,QUALIFIED
    RETURN

LABEL_0334
    INCREMENT INPUT_ADDRESS
    LOAD VAR_0056
    STORE QUALIFY_MASK
    LOAD VAR_0054
    STORE QUALIFY_VALUE
    INPUT ABS,INPUT_ADDRESS,QUALIFIED
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_034F
    RETURN

LABEL_033E
    STORE VAR_004A
    LOAD VAR_0046
    CASE_OF 5,5
        OUTPUT "IX"
        OUTPUT "IY"
    CASE_END
    LOAD VAR_004A
    RETURN

LABEL_0346
    OUTPUT "["
    CALL LABEL_033E
    OUTPUT "+"
    CALL LABEL_02FE
    OUTPUT "]"
    RETURN

LABEL_034C
    POSITION ABS,1
    OUTPUT "Illegal Opcode                         "
    ABORT

LABEL_034F
    POSITION ABS,1
    OUTPUT "Partial Instruction                    "
    ABORT

LABEL_0352
    CASE_OF 5,3
        OUTPUT "ADD  A,"
        OUTPUT "ADC  A,"
        OUTPUT "SUB  "
        OUTPUT "SBC  A,"
        OUTPUT "AND  "
        OUTPUT "XOR  "
        OUTPUT "OR   "
        OUTPUT "CP   "
    CASE_END
    RETURN

LABEL_035D
    SET VAR_0052,-1
    LOAD INPUT_ADDRESS
    SUBTRACT 1
    STORE VAR_0058
    LOAD VAR_0056
    STORE QUALIFY_MASK
    LOAD VAR_0054
    STORE QUALIFY_VALUE
    INPUT REL,VAR_0052,QUALIFIED
    IF INPUT_ADDRESS <> VAR_0058 THEN GOTO LABEL_0395
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_0395
    LOAD INPUT_TAG
    IF 1,0 <> 0 THEN GOTO LABEL_0395
    IF INPUT_DATA = 0000000CBH THEN GOTO LABEL_037D
    IF INPUT_DATA = 0000000DDH THEN GOTO LABEL_037D
    IF INPUT_DATA = 0000000EDH THEN GOTO LABEL_037D
    IF INPUT_DATA = 0000000FDH THEN GOTO LABEL_037D
    GOTO LABEL_0395

LABEL_037D
    SET VAR_0050,2
    IF INPUT_DATA <> 0000000CBH THEN GOTO LABEL_0396

LABEL_0381
    DECREMENT VAR_0052
    DECREMENT VAR_0058
    INPUT REL,VAR_0052,QUALIFIED
    IF INPUT_ADDRESS <> VAR_0058 THEN GOTO LABEL_0396
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_0396
    LOAD INPUT_TAG
    IF 1,0 <> 0 THEN GOTO LABEL_0396
    IF INPUT_DATA <> 0000000CBH THEN GOTO LABEL_0396
    LOAD VAR_0050
    EXCLUSIVE_OR 2
    STORE VAR_0050
    GOTO LABEL_0381

LABEL_0395
    SET VAR_0050,0

LABEL_0396
    INPUT REL,0
    TAG_WITH VAR_0050
    LOAD INPUT_TAG
    RETURN

LABEL_039A
    CALL LABEL_032D
    IF INPUT_ERROR <> 0 THEN GOTO LABEL_03A7
    LOAD INPUT_DATA
    IF 7,7 = 1 THEN INCLUSIVE_OR 00000FF00H
    ADD INPUT_ADDRESS
    ADD 1
    IF_NOT_MAPPED THEN OUTPUT ACCUMULATOR,FMT_0026    * 16,HEX,4
    RETURN

LABEL_03A7
    OUTPUT "****"
    RETURN
